<?php
/*
* --------------------------------------------------------------------------
*                                    NuclearBB
*                              (c) 2007 NuclearBB
* --------------------------------------------------------------------------
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* --------------------------------------------------------------------------
*/

function admin_reauth()
{
	global $db, $password_salt, $session, $template;
	
	admin_header(lang('reauth'));
	
	if(isset($_POST['submit']))
	{
		if(md5_salt($_POST['password']) == $session->user_data['password'])
		{
			$sql = "UPDATE sessions
					SET admin_reauthed = 1
					WHERE sid = '" . $session->user_data['sid'] ."'";
			$db->query($sql);
			
			trigger_error('successful_reauth');
		}
		else
		{
			add_log(LOG_ADMIN, 'unsuccessful_admin_login');
			trigger_error('reauth_error');
		}
	}
	else
	{
		$template->load('admin_reauth', 'reauth.html');
		
		$template->display('admin_reauth');
	}
	
	admin_footer();
}

function admin_success($redirect_url, $message_text = '')
{
	global $template;
	
	$template->load('admin_success', 'admin_success.html');
	
	if(! defined('PAGE_TITLE'))
	{
		define('PAGE_TITLE', 'operation_successful');
	}
	
	$use_lang_string = (empty($message_text)) ? 'op_successful' : $message_text;
	
	$template->assign_vars(array(
		'MESSAGE_TEXT'		=>	lang($use_lang_string),
		'RETURN_MESSAGE'	=>	sprintf(lang('click_return_text'), $redirect_url, 'index.php')
	));
	
	$template->display('admin_success');
}

function admin_header($page_title = '')
{
	global $config, $root_path, $template;
	
	$template->load('admin_header', 'header.html');
	
	$template->assign_vars(array(
		'BOARD_NAME'			=>	$config['board_name'],
		'INSTALL_DIR_PRESENT'	=>	(file_exists("$root_path/install")) ? true : false,
		'PAGE_TITLE'			=>	$page_title
	));
	
	$template->display('admin_header');
	define('ADMIN_HEADER_OUT', true);
}

function admin_footer()
{
	global $db, $start_time, $template;
	
	$template->load('admin_footer', 'footer.html');
	
	$end_time = explode(' ', microtime());
	$load_time = $end_time[0] + $end_time[1] - $start_time;
	
	$template->assign_vars(array(
		'DB_QUERIES'	=>	$db->num_queries,
		'LOAD_TIME'		=>	sprintf('%.3f', $load_time)
	));
	
	$template->display('admin_footer');
	
	exit;
}
?>