<?php
/*
* --------------------------------------------------------------------------
*                                    NuclearBB
*                              (c) 2007 NuclearBB
* --------------------------------------------------------------------------
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* --------------------------------------------------------------------------
*/

define('IN_NBB', true);
define('IN_ADMIN', true);
$root_path = './..';
require("$root_path/inc/global.php");
require("$root_path/admin/inc/functions.php");
$template->custom_template('admin', 'template');
add_lang('admin');
add_lang('admin_definitions');
$session->begin();
$auth->setup();

//This is basically a catch-all for people who really shouldn't be here
if(! $auth->check('admin'))
{
	trigger_error('not_auth');
}

//Check the user has re-authenticated. If not, show a re-auth page
if(! $session->user_data['admin_reauthed'])
{
	admin_reauth();
}

$admin_module_list = $admin_modules_ordered = $default_module = $hide_menu = array();
$last_cat_id = $last_tab_id = -1;
$current_tab = $last_cat_name = $last_tab_name = $module_content = $selected_tab = '';

$current_module = (isset($_GET['m'])) ? htmlspecialchars($_GET['m']) : 'admin_index';
$mode = (isset($_GET['mode'])) ? htmlspecialchars($_GET['mode']) : '';

$sql = "SELECT *
		FROM modules
		WHERE module_type = 'acp'
		AND module_enabled = 1
		ORDER BY left_id ASC";
$result = $db->query($sql);
while($row = $db->fetch_assoc($result))
{
	$admin_module_list[] = $row;
}

for($i = 0; $i < count($admin_module_list); $i++)
{
	//Tabs
	if($admin_module_list[$i]['parent_id'] == 0)
	{
		$last_tab_id = $admin_module_list[$i]['module_id'];
		$last_tab_name = $admin_module_list[$i]['module_name'];
		$default_module[ $admin_module_list[$i]['module_name'] ] = $admin_module_list[$i]['module_file'];
	}
	
	//Categories
	if($admin_module_list[$i]['parent_id'] == $last_tab_id)
	{
		$last_cat_id = $admin_module_list[$i]['module_id'];
		$last_cat_name = $admin_module_list[$i]['module_name'];
	}
	
	//Modules
	if($admin_module_list[$i]['parent_id'] == $last_cat_id)
	{
		$admin_modules_ordered[$last_tab_name][$last_cat_name][ $admin_module_list[$i]['module_name'] ] = $admin_module_list[$i]['module_file'];
		if($current_module == $admin_module_list[$i]['module_name'])
		{
			$current_tab = $last_tab_name;
		}
		
		if(! $admin_module_list[$i]['show_menu'])
		{
			$hide_menu[] = $admin_module_list[$i]['module_name'];
		}
	}
}

foreach($admin_modules_ordered as $tab_name => $tab_data)
{
	$template->assign_block_vars('admin_tab', array(
		'HREF'			=>	'index.php?m=' . $default_module[$tab_name],
		'IS_SELECTED'	=>	($current_tab == $tab_name),
		'LANG'			=>	lang($tab_name, true)
	));
	
	foreach($tab_data as $cat_name => $cat_data)
	{
		if($tab_name == $current_tab)
		{
			$template->assign_block_vars('admin_category', array(
				'LANG'	=>	lang($cat_name, true)
			));
		}
		
		foreach($cat_data as $module_name => $module_file)
		{
			if($tab_name == $current_tab && ! in_array($module_file, $hide_menu))
			{
				$template->assign_block_vars('admin_category.admin_module', array(
					'HREF'			=>	"index.php?m=$module_name",
					'IS_SELECTED'	=>	($current_module == $module_name),
					'LANG'			=>	lang($module_name, true)
				));
			}
			
			if($current_module == $module_name)
			{
				if((file_exists("$root_path/admin/modules/$module_file.php")) && (! defined('ADMIN_MODULE_INCLUDED')))
				{
					ob_start();
					include("$root_path/admin/modules/$module_file.php");
					$module_content = ob_get_contents();
					ob_end_clean();
					define('ADMIN_MODULE_INCLUDED', true);
				}
			}
		}
	}
}

//PAGE_TITLE is define()'ed in each module. If not set, it will default to lang('administration')
if(! defined('PAGE_TITLE'))
{
	define('PAGE_TITLE', 'administration');
}

admin_header(lang(PAGE_TITLE, true));

$template->load('admin_wrapper', 'admin_wrapper.html');

$template->assign_vars(array(
	'CURRENT_MODULE_LANG'	=>	lang($current_module, true),
	'CURRENT_MODULE_NAME'	=>	$current_module,
	'CURRENT_TAB_LANG'		=>	lang($current_tab, true),
	'CURRENT_TAB_NAME'		=>	$current_tab,
	'MODULE_CONTENT'		=>	$module_content,
	'SHOW_MODULE_ERROR'		=>	(! defined('ADMIN_MODULE_INCLUDED'))
));

$template->display('admin_wrapper');

admin_footer();
?>	