<?php
/*
* --------------------------------------------------------------------------
*                                    NuclearBB
*                              (c) 2007 NuclearBB
* --------------------------------------------------------------------------
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* --------------------------------------------------------------------------
*/

if(! defined('IN_ADMIN'))
{
	exit;
}

define('PAGE_TITLE', 'general_config');

if(isset($_POST['submit']))
{
	$captcha_noise = 0;
	$captcha_noise |= intval($_POST['noise_lines']);
	$captcha_noise |= intval($_POST['noise_squares']);
	$captcha_noise |= intval($_POST['noise_circles']);
	$captcha_noise |= intval($_POST['noise_letters']);
	
	$update_data = array(
		'board_email'				=>	htmlspecialchars($_POST['board_email']),
		'board_name'				=>	htmlspecialchars($_POST['board_name']),
		'board_online'				=>	intval($_POST['board_online']),
		'board_tagline'				=>	htmlspecialchars($_POST['board_tagline']),
		'board_url'					=>	htmlspecialchars($_POST['board_url']),
		'captcha_noise_bitfield'	=>	$captcha_noise,
		'default_style'				=>	intval($_POST['default_style']),
		'email_signature'			=>	htmlspecialchars($_POST['email_signature']),
		'max_avatar_height'			=>	intval($_POST['max_avatar_height']),
		'max_avatar_width'			=>	intval($_POST['max_avatar_width']),
		'offline_message'			=>	htmlspecialchars($_POST['offline_message']),
		'show_board_logo'			=>	intval($_POST['show_board_logo'])
	);
	
	foreach($update_data as $k => $v)
	{
		if((array_key_exists($k, $config)) && ($config[$k] != $v))
		{
			$sql = "UPDATE config
					SET config_value = '". $db->escape($v) ."'
					WHERE config_name = '$k'";
			$db->query($sql);
		}
	}
	
	$cache->delete('config');
	
	add_log(LOG_ADMIN, 'updated_general_config');
	admin_success("index.php?m=$current_module");
}
else
{
	$template->load('body', 'config_general.html');
	
	foreach($styles as $style_id => $style_data)
	{
		$template->assign_block_vars('style', array(
			'ID'	=>	$style_id,
			'NAME'	=>	$style_data['style_name']
		));
	}
	
	$template->assign_vars(array(
		'BOARD_EMAIL'				=>	$config['board_email'],
		'BOARD_NAME'				=>	$config['board_name'],
		'BOARD_ONLINE'				=>	$config['board_online'],
		'BOARD_TAGLINE'				=>	$config['board_tagline'],
		'BOARD_URL'					=>	$config['board_url'],
		'DEFAULT_STYLE'				=>	$config['default_style'],
		'EMAIL_SIGNATURE'			=>	$config['email_signature'],
		'MAX_AVATAR_HEIGHT'			=>	$config['max_avatar_height'],
		'MAX_AVATAR_WIDTH'			=>	$config['max_avatar_width'],
		'NOISE_CIRCLES'				=>	NOISE_CIRCLES,
		'NOISE_CIRCLES_CHECKED'		=>	$config['captcha_noise_bitfield'] & NOISE_CIRCLES,
		'NOISE_LETTERS'				=>	NOISE_LETTERS,
		'NOISE_LETTERS_CHECKED'		=>	$config['captcha_noise_bitfield'] & NOISE_LETTERS,
		'NOISE_LINES'				=>	NOISE_LINES,
		'NOISE_LINES_CHECKED'		=>	$config['captcha_noise_bitfield'] & NOISE_LINES,
		'NOISE_SQUARES'				=>	NOISE_SQUARES,
		'NOISE_SQUARES_CHECKED'		=>	$config['captcha_noise_bitfield'] & NOISE_SQUARES,
		'OFFLINE_MESSAGE'			=>	$config['offline_message'],
		'SHOW_BOARD_LOGO'			=>	$config['show_board_logo'],
		
		'FORM_ACTION'			=>	"index.php?m=$current_module"
	));
	
	$template->display('body');
}
?>