<?php
/*
* --------------------------------------------------------------------------
*                                    NuclearBB
*                              (c) 2007 NuclearBB
* --------------------------------------------------------------------------
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* --------------------------------------------------------------------------
*/

if(! defined('IN_ADMIN'))
{
	exit;
}

define('PAGE_TITLE', 'config_posting');

if(isset($_POST['submit']))
{
	$update_data = array(
		'duplicate_post_limit'	=>	(intval($_POST['duplicate_post_limit']) * intval($_POST['duplicate_post_limit_time_measure'])),
		'posts_per_page'		=>	intval($_POST['posts_per_page']),
		'topics_per_page'		=>	intval($_POST['topics_per_page'])
	);
	
	foreach($update_data as $k => $v)
	{
		if((array_key_exists($k, $config)) && ($config[$k] != $v))
		{
			$sql = "UPDATE config
					SET config_value = '". $db->escape($v) ."'
					WHERE config_name = '$k'";
			$db->query($sql);
		}
	}
	
	$cache->delete('config');
	add_log(LOG_ADMIN, 'updated_cookie_settings');
	admin_success("index.php?m=$current_module");
}
else
{
	$template->load('body', 'config_posting.html');
	
	$dupe_post_limit = 0;
	$dupe_post_limit_time = '';
	
	if($config['duplicate_post_limit'] < 3600)
	{
		$dupe_post_limit = $config['duplicate_post_limit'] / 60;
		$dupe_post_limit_time = 'm';
	}
	
	if($config['duplicate_post_limit'] >= 3600 && $config['duplicate_post_limit'] <= 86400)
	{
		$dupe_post_limit = $config['duplicate_post_limit'] / 3600;
		$dupe_post_limit_time = 'h';
	}
	
	if($config['duplicate_post_limit'] > 86400)
	{
		$dupe_post_limit = $config['duplicate_post_limit'] / 86400;
		$dupe_post_limit_time = 'd';
	}
	
	$template->assign_vars(array(
		'DUPE_POST_LIMIT'		=>	round($dupe_post_limit, 2),
		'DUPE_POST_LIMIT_TIME'	=>	$dupe_post_limit_time,
		'POSTS_PER_PAGE'		=>	$config['posts_per_page'],
		'TOPICS_PER_PAGE'		=>	$config['topics_per_page'],
		
		'FORM_ACTION'			=>	"index.php?m=$current_module"
	));
	
	$template->display('body');
}
?>