<?php
/*
* --------------------------------------------------------------------------
*                                    NuclearBB
*                              (c) 2007 NuclearBB
* --------------------------------------------------------------------------
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* --------------------------------------------------------------------------
*/

if(! defined('IN_ADMIN'))
{
	exit;
}

$word_id = (isset($_GET['word'])) ? intval($_GET['word']) : 0;

function edit_word_form($form_action, $l_header_text, $l_button_text, $bad_word = '', $replacement = '')
{
	global $mode, $template;
	
	$template->load('body', 'edit_censor_form.html');
	
	$template->assign_vars(array(
		'BAD_WORD'			=>	$bad_word,
		'REPLACEMENT'		=>	$replacement,
		
		'L_BUTTON_TEXT'		=>	$l_button_text,
		'L_HEADER_TEXT'		=>	$l_header_text,
		
		'FORM_ACTION'		=>	$form_action
	));
	
	$template->display('body');
}

switch($mode)
{
	case 'delete':
		define('PAGE_TITLE', 'delete_censor');
		
		$word_data = array();
		
		$sql = "SELECT *
				FROM word_censors
				WHERE word_id = $word_id";
		$result = $db->query($sql);
		$word_data = $db->fetch_assoc($result);
		
		if(empty($word_data))
		{
			trigger_error('word_no_exist');
		}
		
		if(isset($_POST['confirm_no']))
		{
			Header('Location: index.php?m=manage_censors');
		}
		
		if(isset($_POST['confirm_yes']))
		{
			$sql = "DELETE FROM word_censors
					WHERE word_id = $word_id";
			$db->query($sql);
			
			$cache->delete('words');
			
			add_log(LOG_ADMIN, 'deleted_word', htmlspecialchars($word_data['bad_word']));
			admin_success('index.php?m=manage_censors');
		}
		else
		{
			confirm_box("index.php?m=$current_module&amp;mode=delete&amp;word=$word_id", 'confirm_delete_word');
		}
	break;
	
	case 'new':
		define('PAGE_TITLE', 'new_censor');
		
		if(isset($_POST['submit']))
		{
			check_required_fields(array('bad_word', 'replacement'));
			
			$insert_sql = $db->build_query('INSERT', array(
				'bad_word'		=>	htmlspecialchars($_POST['bad_word']),
				'replacement'	=>	htmlspecialchars($_POST['replacement'])
			));
			
			$sql = "INSERT INTO word_censors $insert_sql";
			$db->query($sql);
			
			$cache->delete('words');
			
			add_log(LOG_ADMIN, 'created_word_censor', htmlspecialchars($_POST['bad_word']));
			admin_success('index.php?m=manage_censors');
		}
		else
		{
			edit_word_form("index.php?m=$current_module&amp;mode=new", lang('new_censor'), lang('create_censor'));
		}
	break;
	
	case 'edit':
		define('PAGE_TITLE', 'edit_bad_word');
		
		if(isset($_POST['submit']))
		{
			check_required_fields(array('bad_word', 'replacement'));
			
			$update_sql = $db->build_query('UPDATE', array(
				'bad_word'		=>	htmlspecialchars($_POST['bad_word']),
				'replacement'	=>	htmlspecialchars($_POST['replacement'])
			));
			
			$sql = "UPDATE word_censors
					SET $update_sql
					WHERE word_id = $word_id";
			$db->query($sql);
			
			$cache->delete('words');
			
			add_log(LOG_ADMIN, 'updated_word', htmlspecialchars($_POST['bad_word']));
			admin_success("index.php?m=manage_censors");
		}
		else
		{
			$word_data = array();
			
			$sql = "SELECT *
					FROM word_censors
					WHERE word_id = $word_id";
			$result = $db->query($sql);
			$word_data = $db->fetch_assoc($result);
			
			if(empty($word_data))
			{
				trigger_error('word_no_exist');
			}
			
			edit_word_form("index.php?m=$current_module&amp;mode=edit&amp;word=$word_id", lang('edit_censor'), lang('update_censor'), $word_data['bad_word'], $word_data['replacement']);
		}
	break;
	
	default:
		trigger_error('no_mode_set');
	break;
}
?>