<?php
/*
* --------------------------------------------------------------------------
*                                    NuclearBB
*                              (c) 2007 NuclearBB
* --------------------------------------------------------------------------
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* --------------------------------------------------------------------------
*/

if(! defined('IN_ADMIN'))
{
	exit;
}

define('PAGE_TITLE', 'edit_forum');

$forum_id = (isset($_GET['f'])) ? intval($_GET['f']) : 0;
$parent_id = (isset($_REQUEST['parent_id'])) ? intval($_REQUEST['parent_id']) : 0;
$forum_data = array();

function edit_forum_form($form_action, $options = array())
{
	global $template;
	
	$template->load('body', 'edit_forum_form.html');
	
	$template->assign_vars(array(
		'APPROVE_NEW_TOPICS'		=>	(isset($options['approve_new_topics'])) ? $options['approve_new_topics'] : 0,
		'APPROVE_REPLIES'			=>	(isset($options['approve_replies'])) ? $options['approve_replies'] : 0,
		'COUNT_HITS'				=>	(isset($options['count_hits'])) ? $options['count_hits'] : 0,
		'FORM_ACTION'				=>	$form_action,
		'FORUM_DESCRIPTION'			=>	(isset($options['forum_description'])) ? $options['forum_description'] : '',
		'FORUM_LOCKED'				=>	(isset($options['forum_locked'])) ? $options['forum_locked'] : 0,
		'FORUM_NAME'				=>	(isset($options['forum_name'])) ? $options['forum_name'] : '',
		'FORUM_RULES'				=>	(isset($options['forum_rules'])) ? $options['forum_rules'] : '',
		'FORUM_TYPE'				=>	(isset($options['forum_type'])) ? $options['forum_type'] : TYPE_FORUM,
		'INC_POST_COUNT'			=>	(isset($options['inc_post_count'])) ? $options['inc_post_count'] : 1,
		'PARENT_ID'					=>	(isset($options['parent_id'])) ? $options['parent_id'] : 0,
		'SHOW_FORUM_RULES'			=>	(isset($options['show_forum_rules'])) ? $options['show_forum_rules'] : 0,
		'SHOW_MODERATORS'			=>	(isset($options['show_moderators'])) ? $options['show_moderators'] : 1,
		'URL_REDIRECT'				=>	(isset($options['url_redirect'])) ? $options['url_redirect'] : '',
		
		'FLAG_APPROVE_NEW_TOPICS'	=>	FLAG_APPROVE_NEW_TOPICS,
		'FLAG_APPROVE_REPLIES'		=>	FLAG_APPROVE_REPLIES,
		'FLAG_COUNT_HITS'			=>	FLAG_LINK_FORUM_COUNT,
		'FLAG_LOCKED'				=>	FLAG_LOCKED,
		'FLAG_INC_POST_COUNT'		=>	FLAG_INCREMENT_POST_COUNT,
		'FLAG_SHOW_FORUM_RULES'		=>	FLAG_SHOW_FORUM_RULES,
		'FLAG_SHOW_MODERATORS'		=>	FLAG_SHOW_MODERATORS,
		
		'L_BUTTON_TEXT'				=>	$options['l_button_text'],
		'L_HEADER_TEXT'				=>	$options['l_header_text'],
		
		'TYPE_CATEGORY'				=>	TYPE_CATEGORY,
		'TYPE_FORUM'				=>	TYPE_FORUM,
		'TYPE_LINK'					=>	TYPE_LINK
	));
	
	$template->display('body');
}

switch($mode)
{
	case 'delete':
		$sql = "SELECT *
				FROM forums
				WHERE forum_id = $forum_id";
		$result = $db->query($sql);
		$forum_data = $db->fetch_assoc($result);
		
		//Only allow deletion of forums with no children
		if($forum_data['right_id'] != ($forum_data['left_id'] + 1))
		{
			trigger_error('no_delete_forum_has_children');
		}
		
		if(isset($_POST['confirm_no']))
		{
			Header('Location: index.php?m=manage_forums');
		}
		
		if(isset($_POST['confirm_yes']))
		{
			$sql = "DELETE FROM forums
					WHERE forum_id = $forum_id";
			$db->query($sql);
			
			$sql = "DELETE FROM forum_perms
					WHERE forum_id = $forum_id";
			$db->query($sql);
			
			$sql = "UPDATE forums
					SET left_id = left_id - 2
					WHERE left_id > " . $forum_data['left_id'];
			$db->query($sql);
			
			$sql = "UPDATE forums
					SET right_id = right_id - 2
					WHERE right_id > " . $forum_data['right_id'];
			$db->query($sql);
			
			$sql = "DELETE FROM forum_perms
					WHERE forum_id = $forum_id";
			$db->query($sql);
			
			add_log(LOG_ADMIN, 'deleted_forum', $forum_data['forum_name']);
			admin_success('index.php?m=manage_forums');
		}
		else
		{
			confirm_box("index.php?m=$current_module&amp;mode=delete&amp;f=$forum_id", 'confirm_delete_forum');
		}
	break;
	
	case 'resync':
		$sql = "SELECT forum_name
				FROM forums
				WHERE forum_id = $forum_id";
		$result = $db->query($sql);
		$forum_data = $db->fetch_assoc($result);
		
		resync_forum($forum_id);
		
		add_log(LOG_ADMIN, 'resynced_forum', $forum_data['forum_name']);
		admin_success('index.php?m=manage_forums');
	break;
	
	case 'move_down':
		$above_children = $below_children = array();
		
		$sql = "SELECT *
				FROM forums
				WHERE forum_id = $forum_id";
		$result = $db->query($sql);
		$forum_data = $db->fetch_assoc($result);
		
		$sql = "SELECT *
				FROM forums
				WHERE left_id = " . ($forum_data['right_id'] + 1);
		$result = $db->query($sql);
		$below_forum = $db->fetch_assoc($result);
		
		$sql = "SELECT *
				FROM forums
				WHERE left_id > ". $forum_data['left_id'] ."
				AND right_id < " . $forum_data['right_id'];
		$result = $db->query($sql);
		while($row = $db->fetch_assoc($result))
		{
			$above_children[] = $row['forum_id'];
		}
		
		$sql = "SELECT *
				FROM forums
				WHERE left_id > ". $below_forum['left_id'] ."
				AND right_id < " . $below_forum['right_id'];
		$result = $db->query($sql);
		while($row = $db->fetch_assoc($result))
		{
			$below_children[] = $row['forum_id'];
		}
		
		$imploded_above = implode(',', $above_children);
		$imploded_below = implode(',', $below_children);
		
		$above_descendants_plus_one = ((($forum_data['right_id'] - $forum_data['left_id'] - 1) /2) + 1) * 2;
		$below_descendants_plus_one = ((($below_forum['right_id'] - $below_forum['left_id'] - 1) /2) + 1) * 2;
		
		$sql = "UPDATE forums
				SET left_id = left_id - ". ($forum_data['right_id'] - $forum_data['left_id'] + 1) ."
				WHERE forum_id = " . $below_forum['forum_id'];
		$db->query($sql);
		
		$sql = "UPDATE forums
				SET right_id = right_id - ". ($forum_data['right_id'] - $forum_data['left_id'] + 1) ."
				WHERE forum_id = " . $below_forum['forum_id'];
		$db->query($sql);
		
		if(! empty($imploded_below))
		{
			$sql = "UPDATE forums
					SET left_id = left_id - $above_descendants_plus_one
					WHERE forum_id IN($imploded_below)";
			$db->query($sql);
		
			$sql = "UPDATE forums
					SET right_id = right_id - $above_descendants_plus_one
					WHERE forum_id IN($imploded_below)";
			$db->query($sql);
		}
		
		$sql = "UPDATE forums
				SET left_id = left_id + ". ($below_forum['right_id'] - $below_forum['left_id'] + 1) ."
				WHERE forum_id = " . $forum_data['forum_id'];
		$db->query($sql);
		
		$sql = "UPDATE forums
				SET right_id = right_id + ". ($below_forum['right_id'] - $below_forum['left_id'] + 1) ."
				WHERE forum_id = " . $forum_data['forum_id'];
		$db->query($sql);
		
		if(! empty($imploded_above))
		{
			$sql = "UPDATE forums
					SET left_id = left_id + $below_descendants_plus_one
					WHERE forum_id IN($imploded_above)";
			$db->query($sql);
			
			$sql = "UPDATE forums
					SET right_id = right_id + $below_descendants_plus_one
					WHERE forum_id IN($imploded_above)";
			$db->query($sql);
		}
		
		add_log(LOG_ADMIN, 'moved_forum_down', $forum_data['forum_name']);
		admin_success('index.php?m=manage_forums');
	break;
	
	case 'move_up':
		trigger_error('Not yet - for now, please move other forums down');
		
		add_log(LOG_ADMIN, 'moved_forum_up', $forum_data['forum_name']);
		admin_success('index.php?m=manage_forums');
	break;
	
	case 'new':
		if(isset($_POST['submit']))
		{
			$required_fields = array('forum_type', 'forum_name');
			if($_POST['forum_type'] == TYPE_LINK)
			{
				$required_fields[] = 'url_redirect';
			}
			
			check_required_fields($required_fields);
			
			$forum_flags = $left_id = $right_id = 0;
			
			$forum_flags |= intval($_POST['approve_new_topics']);
			$forum_flags |= intval($_POST['approve_replies']);
			$forum_flags |= intval($_POST['forum_locked']);
			$forum_flags |= intval($_POST['increment_post_count']);
			$forum_flags |= intval($_POST['link_count_hits']);
			$forum_flags |= intval($_POST['show_forum_rules']);
			$forum_flags |= intval($_POST['show_moderators']);
			
			if($parent_id == 0)
			{
				//Category
				$highest_right = 0;
				
				$sql = "SELECT *
						FROM forums";
				$result = $db->query($sql);
				while($row = $db->fetch_assoc($result))
				{
					if($row['right_id'] > $highest_right)
					{
						$highest_right = $row['right_id'];
					}
				}
				
				$left_id = $highest_right + 1;
				$right_id = $left_id + 1;
			}
			else
			{
				//Forum
				$sql = "SELECT *
						FROM forums
						WHERE forum_id = $parent_id";
				$result = $db->query($sql);
				$parent_data = $db->fetch_assoc($result);
				
				$sql = "UPDATE forums
						SET left_id = left_id + 2
						WHERE left_id > " . $parent_data['left_id'];
				$db->query($sql);
				
				$sql = "UPDATE forums
						SET right_id = right_id + 2
						WHERE right_id > " . $parent_data['left_id'];
				$db->query($sql);
				
				$left_id = $parent_data['left_id'] + 1;
				$right_id = $left_id + 1;
			}
			
			$insert_sql = $db->build_query('INSERT', array(
				'forum_description'	=>	htmlspecialchars($_POST['forum_description']),
				'forum_flags'		=>	$forum_flags,
				'forum_name'		=>	htmlspecialchars($_POST['forum_name']),
				'forum_parent'		=>	$parent_id,
				'forum_type'		=>	intval($_POST['forum_type']),
				'left_id'			=>	$left_id,
				'right_id'			=>	$right_id,
				'url_redirect'		=>	htmlspecialchars($_POST['url_redirect'])
			));
			
			$sql = "INSERT INTO forums $insert_sql";
			$db->query($sql);
			
			add_log(LOG_ADMIN, 'created_forum', $_POST['forum_name']);
			admin_success('index.php?m=manage_forums');
		}
		else
		{
			$options = array(
				'forum_name'	=>	(isset($_POST['forum_name'])) ? htmlspecialchars($_POST['forum_name']) : '',
				'forum_type'	=>	($parent_id == 0) ? TYPE_CATEGORY : TYPE_FORUM,
				'l_button_text'	=>	lang('create_forum'),
				'l_header_text'	=>	lang('new_forum'),
				'parent_id'		=>	$parent_id
			);
			
			edit_forum_form("index.php?m=$current_module&mode=new", $options);
		}
	break;
	
	case 'edit':
		if(isset($_POST['submit']))
		{
			$required_fields = array('forum_type', 'forum_name');
			if($_POST['forum_type'] == TYPE_LINK)
			{
				$required_fields[] = 'url_redirect';
			}
			
			check_required_fields($required_fields);
			
			$forum_flags = 0;
			$forum_flags |= intval($_POST['approve_new_topics']);
			$forum_flags |= intval($_POST['approve_replies']);
			$forum_flags |= intval($_POST['forum_locked']);
			$forum_flags |= intval($_POST['increment_post_count']);
			$forum_flags |= intval($_POST['link_count_hits']);
			$forum_flags |= intval($_POST['show_forum_rules']);
			$forum_flags |= intval($_POST['show_moderators']);
			
			$update_sql = $db->build_query('UPDATE', array(
				'forum_description'	=>	htmlspecialchars($_POST['forum_description']),
				'forum_flags'		=>	$forum_flags,
				'forum_name'		=>	htmlspecialchars($_POST['forum_name']),
				'forum_rules'		=>	htmlspecialchars($_POST['forum_rules']),
				'forum_type'		=>	intval($_POST['forum_type']),
				'url_redirect'		=>	htmlspecialchars($_POST['url_redirect'])
			));
			
			$sql = "UPDATE forums
					SET $update_sql
					WHERE forum_id = $forum_id";
			$db->query($sql);
			
			add_log(LOG_ADMIN, 'updated_forum', $_POST['forum_name']);
			admin_success('index.php?m=manage_forums');
		}
		else
		{
			$sql = "SELECT *
					FROM forums
					WHERE forum_id = $forum_id";
			$result = $db->query($sql);
			$forum_data = $db->fetch_assoc($result);
			
			if(empty($forum_data))
			{
				trigger_error('forum_no_exist');
			}
			
			$options = array(
				'approve_new_topics'	=>	($forum_data['forum_flags'] & FLAG_APPROVE_NEW_TOPICS),
				'approve_replies'		=>	($forum_data['forum_flags'] & FLAG_APPROVE_REPLIES),
				'count_hits'			=>	($forum_data['forum_flags'] & FLAG_LINK_FORUM_COUNT),
				'forum_description'		=>	$forum_data['forum_description'],
				'forum_locked'			=>	($forum_data['forum_flags'] & FLAG_LOCKED),
				'forum_name'			=>	$forum_data['forum_name'],
				'forum_rules'			=>	$forum_data['forum_rules'],
				'forum_type'			=>	$forum_data['forum_type'],
				'inc_post_count'		=>	($forum_data['forum_flags'] & FLAG_INCREMENT_POST_COUNT),
				'l_button_text'			=>	lang('update_forum'),
				'l_header_text'			=>	lang('edit_forum'),
				'parent_id'				=>	0,
				'show_forum_rules'		=>	($forum_data['forum_flags'] & FLAG_SHOW_FORUM_RULES),
				'show_moderators'		=>	($forum_data['forum_flags'] & FLAG_SHOW_MODERATORS),
				'url_redirect'			=>	$forum_data['url_redirect']
			);
			
			edit_forum_form("index.php?m=$current_module&mode=edit&amp;f=$forum_id", $options);
		}
	break;
	
	default:
		trigger_error('no_mode_set');
	break;
}
?>