<?php
/*
* --------------------------------------------------------------------------
*                                    NuclearBB
*                              (c) 2007 NuclearBB
* --------------------------------------------------------------------------
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* --------------------------------------------------------------------------
*/

if(! defined('IN_ADMIN'))
{
	exit;
}

define('PAGE_TITLE', 'edit_forum_perms');

$group_id = (isset($_POST['group_id'])) ? intval($_POST['group_id']) : 0;
add_lang('perms');

if(isset($_POST['perm_submit']))
{
	$perm_ids = $perm_names = $raw_perms = array();
	
	$sql = "SELECT *
			FROM forum_perm_values";
	$result = $db->query($sql);
	while($row = $db->fetch_assoc($result))
	{
		$perm_ids[ $row['perm_name'] ] = $row['perm_name_id'];
		$perm_names[ $row['perm_name_id'] ] = $row['perm_name'];
	}
	
	$sql = "SELECT *
			FROM forum_perms
			WHERE group_id = $group_id";
	$result = $db->query($sql);
	while($row = $db->fetch_assoc($result))
	{
		$raw_perms[ $row['forum_id'] ][ $perm_names[ $row['perm_name_id'] ] ] = $row;
	}
	
	foreach($_POST['perms'] as $forum_id => $perm_data)
	{
		foreach($perm_data as $perm_name => $perm_value)
		{
			if(isset($raw_perms[$forum_id][$perm_name]))
			{
				if($raw_perms[$forum_id][$perm_name]['perm_value'] != $perm_value)
				{
					$sql = "UPDATE forum_perms
							SET perm_value = $perm_value
							WHERE group_id = $group_id
							AND forum_id = $forum_id
							AND perm_name_id = " . $raw_perms[$forum_id][$perm_name]['perm_name_id'];
					$db->query($sql);
				}
			}
			else
			{
				$insert_sql = $db->build_query('INSERT', array(
					'forum_id'		=>	intval($forum_id),
					'group_id'		=>	$group_id,
					'perm_name_id'	=>	$perm_ids[$perm_name],
					'perm_value'	=>	intval($_POST['perms'][$forum_id][$perm_name])
				));
				
				$sql = "INSERT INTO forum_perms $insert_sql";
				$db->query($sql);
			}
		}
	}
	
	add_log(LOG_ADMIN, 'updated_forum_permissions');
	admin_success("index.php?m=forum_permissions");
}
else
{
	$forum_data = $forum_list = $perm_values = $perms = $raw_perms = array();
	$forum_list_post = (isset($_POST['forum_id'])) ? $_POST['forum_id'] : array();
	
	//Sanitising of the $_POST['forum_id'] array
	for($i = 0; $i < count($forum_list_post); $i++)
	{
		$forum_list[] = intval($_POST['forum_id'][$i]);
	}
	
	if((empty($group_id)) || (empty($forum_list)))
	{
		trigger_error('required_fields');
	}
	
	$template->load('body', 'edit_forum_perms.html');
	
	$perm_values = $cache->get_permission_values();
	$imploded_forum_ids = implode(',', $forum_list);
	
	$sql = "SELECT *
			FROM forums
			WHERE forum_id IN($imploded_forum_ids)";
	$result = $db->query($sql);
	while($row = $db->fetch_assoc($result))
	{
		$forum_data[ $row['forum_id'] ] = $row;
	}
	
	$sql = "SELECT p.*, v.*
			FROM forum_perms p, forum_perm_values v
			WHERE p.forum_id IN($imploded_forum_ids)
			AND p.perm_name_id = v.perm_name_id
			AND p.group_id = $group_id";
	$result = $db->query($sql);
	while($row = $db->fetch_assoc($result))
	{
		$raw_perms[ $row['forum_id'] ][ $row['perm_name_id'] ] = $row;
	}
	
	for($i = 0; $i < count($forum_list); $i++)
	{
		$forum_id = intval($_POST['forum_id'][$i]);
		
		foreach($perm_values['forum'] as $perm_name => $perm_data)
		{
			$perms[$forum_id][$perm_name] = (isset($raw_perms[$forum_id][ $perm_data['perm_name_id'] ])) ? $raw_perms[$forum_id][ $perm_data['perm_name_id'] ]['perm_value'] : PERM_UNSET;
		}
		
		$template->assign_block_vars('forum', array(
			'ID'	=>	$forum_data[ $forum_list[$i] ]['forum_id'],
			'NAME'	=>	$forum_data[ $forum_list[$i] ]['forum_name']
		));
		
		foreach($perms[ $forum_list[$i] ] as $perm_name => $perm_value)
		{
			$template->assign_block_vars('forum.perm', array(
				'LANG'	=>	lang($perm_name, true),
				'NAME'	=>	$perm_name,
				'VALUE'	=>	$perm_value
			));
		}
	}
	
	$template->assign_vars(array(
		'GROUP_ID'		=>	$group_id,
		'PERM_NO'		=>	PERM_NO,
		'PERM_UNSET'	=>	PERM_UNSET,
		'PERM_YES'		=>	PERM_YES
	));
	
	$template->display('body');
}
?>