<?php
/*
* --------------------------------------------------------------------------
*                                    NuclearBB
*                              (c) 2007 NuclearBB
* --------------------------------------------------------------------------
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* --------------------------------------------------------------------------
*/

if(! defined('IN_ADMIN'))
{
	exit;
}

define('PAGE_TITLE', 'edit_global_perms');

$group_id = (isset($_POST['group_id'])) ? intval($_POST['group_id']) : 0;
add_lang('perms');

if(isset($_POST['perm_submit']))
{
	$perm_ids = $perm_names = $raw_perms = array();
	
	$sql = "SELECT *
			FROM perm_values";
	$result = $db->query($sql);
	while($row = $db->fetch_assoc($result))
	{
		$perm_ids[ $row['perm_name'] ] = $row['perm_name_id'];
		$perm_names[ $row['perm_name_id'] ] = $row['perm_name'];
	}
	
	$sql = "SELECT *
			FROM perms
			WHERE group_id = $group_id";
	$result = $db->query($sql);
	while($row = $db->fetch_assoc($result))
	{
		$raw_perms[ $perm_names[ $row['perm_name_id'] ] ] = $row;
	}
	
	foreach($_POST['perms'] as $perm_name => $perm_value)
	{
		if(isset($raw_perms[$perm_name]))
		{
			if($raw_perms[$perm_name]['perm_value'] != $perm_value)
			{
				$sql = "UPDATE perms
						SET perm_value = $perm_value
						WHERE group_id = $group_id
						AND perm_name_id = " . $raw_perms[$perm_name]['perm_name_id'];
				$db->query($sql);
			}
		}
		else
		{
			$insert_sql = $db->build_query('INSERT', array(
				'group_id'		=>	$group_id,
				'perm_name_id'	=>	$perm_ids[$perm_name],
				'perm_value'	=>	intval($_POST['perms'][$perm_name])
			));
			
			$sql = "INSERT INTO perms $insert_sql";
			$db->query($sql);
		}
	}
	
	add_log(LOG_ADMIN, 'updated_global_permissions');
	admin_success("index.php?m=global_permissions");
}
else
{
	$perm_values = $perms = $raw_perms = array();
	
	if(empty($group_id))
	{
		trigger_error('required_fields');
	}
	
	$template->load('body', 'edit_global_perms.html');
	
	$perm_values = $cache->get_permission_values();
	
	$sql = "SELECT p.*, v.*
			FROM perms p, perm_values v
			WHERE p.perm_name_id = v.perm_name_id
			AND p.group_id = $group_id";
	$result = $db->query($sql);
	while($row = $db->fetch_assoc($result))
	{
		$raw_perms[ $row['perm_name_id'] ] = $row;
	}
	
	foreach($perm_values['global'] as $perm_name => $perm_data)
	{
		$perms[$perm_name] = (isset($raw_perms[ $perm_data['perm_name_id'] ])) ? $raw_perms[ $perm_data['perm_name_id'] ]['perm_value'] : PERM_UNSET;
	}
	
	foreach($perms as $perm_name => $perm_value)
	{
		$template->assign_block_vars('perm', array(
			'LANG'	=>	lang($perm_name, true),
			'NAME'	=>	$perm_name,
			'VALUE'	=>	$perm_value
		));
	}
	
	$template->assign_vars(array(
		'GROUP_ID'		=>	$group_id,
		'PERM_NO'		=>	PERM_NO,
		'PERM_UNSET'	=>	PERM_UNSET,
		'PERM_YES'		=>	PERM_YES
	));
	
	$template->display('body');
}
?>