<?php
/*
* --------------------------------------------------------------------------
*                                    NuclearBB
*                              (c) 2007 NuclearBB
* --------------------------------------------------------------------------
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* --------------------------------------------------------------------------
*/

if(! defined('IN_ADMIN'))
{
	exit;
}

define('PAGE_TITLE', 'edit_group');
add_lang('groups');
$group_id = (isset($_GET['g'])) ? intval($_GET['g']) : 0;

function edit_group_form($form_action, $l_header_text, $l_button_text, $group_name = '', $group_description = '', $group_type = GROUP_FREE, $show_legend = true, $group_colour = '')
{
	global $template;
	
	$template->load('body', 'edit_group_form.html');
	
	$template->assign_vars(array(
		'FORM_ACTION'		=>	$form_action,
		'GROUP_COLOUR'		=>	$group_colour,
		'GROUP_DESCRIPTION'	=>	$group_description,
		'GROUP_FREE'		=>	GROUP_FREE,
		'GROUP_HIDDEN'		=>	GROUP_HIDDEN,
		'GROUP_REQUEST'		=>	GROUP_REQUEST,
		'GROUP_NAME'		=>	$group_name,
		'GROUP_PRIVATE'		=>	GROUP_PRIVATE,
		'GROUP_TYPE'		=>	$group_type,
		'SHOW_GROUP_TYPE'	=>	$group_type != GROUP_INTERNAL,
		'SHOW_ON_LEGEND'	=>	$show_legend,
		
		'L_BUTTON_TEXT'		=>	$l_button_text,
		'L_HEADER_TEXT'		=>	$l_header_text
	));
	
	$template->display('body');
}

switch($mode)
{
	case 'delete':
		$sql = "SELECT *
				FROM groups
				WHERE group_id = $group_id";
		$result = $db->query($sql);
		$group_data = $db->fetch_assoc($result);
		
		if($group_data['group_type'] == GROUP_INTERNAL)
		{
			trigger_error('no_delete_internal_group');
		}
		
		if(isset($_POST['confirm_no']))
		{
			Header('Location: index.php?m=manage_groups');
		}
		
		if(isset($_POST['confirm_yes']))
		{
			//If this is any members primary group, do something
			
			$sql = "DELETE FROM groups
					WHERE group_id = $group_id";
			$db->query($sql);
			
			//Group 3 is the Registered Users group
			$sql = "UPDATE users
					SET primary_group = 3
					WHERE primary_group = " . $group_id;
			$db->query($sql);
			
			$sql = "DELETE FROM group_members
					WHERE group_id = $group_id";
			$db->query($sql);
			
			$cache->delete('groups');
			add_log(LOG_ADMIN, 'deleted_group', $group_data['group_name']);
			admin_success('index.php?m=manage_groups');
		}
		else
		{
			confirm_box("index.php?m=$current_module&amp;mode=delete&amp;g=$group_id", 'confirm_delete_group');
		}
	break;
	
	case 'moderate':
		$users = array();
		$action = (isset($_POST['action'])) ? htmlspecialchars($_POST['action']) : '';
		$users_post = (isset($_POST['users'])) ? $_POST['users'] : array();
		for($i = 0; $i < count($users_post); $i++)
		{
			$users[] = intval($users_post[$i]);
		}
		
		$imploded_users = implode(',', $users);
		
		$sql = "SELECT *
				FROM groups
				WHERE group_id = $group_id";
		$result = $db->query($sql);
		$group_data = $db->fetch_assoc($result);
		
		if(empty($group_data))
		{
			trigger_error('group_no_exist');
		}
		
		switch($action)
		{
			case 'add_leader':
				$sql = "UPDATE group_members
						SET membership_type = ". MEMBERSHIP_LEADER ."
						WHERE user_id IN($imploded_users)
						AND group_id = $group_id";
				$db->query($sql);
				
				admin_success("index.php?m=view_group_members&amp;g=$group_id");
			break;
			
			case 'add_mod':
				$sql = "UPDATE group_members
						SET membership_type = ". MEMBERSHIP_MODERATOR ."
						WHERE user_id IN($imploded_users)
						AND group_id = $group_id";
				$db->query($sql);
				
				admin_success("index.php?m=view_group_members&amp;g=$group_id");
			break;
			
			case 'remove_leader':
			case 'remove_mod':
			case 'approve_pending':
				$sql = "UPDATE group_members
						SET membership_type = ". MEMBERSHIP_NORMAL ."
						WHERE user_id IN($imploded_users)
						AND group_id = $group_id";
				$db->query($sql);
				
				$message = ($action == 'remove_mod') ? 'removed_moderator_from_group' : 'successfully_approved_pending';
				admin_success("index.php?m=view_group_members&amp;g=$group_id");
			break;
			
			case 'remove':
			case 'deny_pending':
				$sql = "DELETE FROM group_members
						WHERE user_id IN($imploded_users)
						AND group_id = $group_id";
				$db->query($sql);
				
				$message = ($action == 'remove') ? 'removed_from_group' : 'successfully_denied_pending';
				admin_success("index.php?m=view_group_members&amp;g=$group_id");
			break;
			
			case 'add_user':
				$membership_data = array();
				$user_id = user_id_from_username(htmlspecialchars($_POST['username']));
				
				if($user_id === false)
				{
					trigger_error('user_no_exist');
				}
				
				$sql = "SELECT *
						FROM group_members
						WHERE group_id = $group_id
						AND user_id = $user_id";
				$result = $db->query($sql);
				$membership_data = $db->fetch_assoc($result);
				
				if(! empty($membership_data))
				{
					trigger_error('is_already_group_member');
				}
				
				$sql = "INSERT INTO group_members (group_id, user_id, membership_type)
						VALUES($group_id, $user_id, ". MEMBERSHIP_NORMAL .")";
				$db->query($sql);
				
				admin_success("index.php?m=view_group_members&amp;g=$group_id");
			break;
			
			default:
				trigger_error('no_mode_set');
			break;
		}
	break;
	
	case 'new':
		if(isset($_POST['submit']))
		{
			check_required_fields(array('group_name'));
			
			$insert_sql = $db->build_query('INSERT', array(
				'group_colour'		=>	htmlspecialchars($_POST['group_colour']),
				'group_description'	=>	htmlspecialchars($_POST['group_description']),
				'group_name'		=>	htmlspecialchars($_POST['group_name']),
				'group_type'		=>	intval($_POST['group_type']),
				'show_on_legend'	=>	intval($_POST['show_on_legend'])
			));
			
			$sql = "INSERT INTO groups
					$insert_sql";
			$db->query($sql);
			
			$cache->delete('groups');
			add_log(LOG_ADMIN, 'created_group', htmlspecialchars($_POST['group_name']));
			admin_success("index.php?m=manage_groups");
		}
		else
		{
			edit_group_form("index.php?m=$current_module&amp;mode=new", lang('new_group'), lang('create_group'), (isset($_POST['group_name'])) ? htmlspecialchars($_POST['group_name']) : '');
		}
	break;
	
	case 'edit':
		$group_data = array();
		
		$sql = "SELECT *
				FROM groups
				WHERE group_id = $group_id";
		$result = $db->query($sql);
		$group_data = $db->fetch_assoc($result);
		
		if(empty($group_data))
		{
			trigger_error('group_no_exist');
		}
		
		if(isset($_POST['submit']))
		{
			check_required_fields(array('group_name'));
			
			$update_sql = $db->build_query('UPDATE', array(
				'group_colour'		=>	htmlspecialchars($_POST['group_colour']),
				'group_description'	=>	htmlspecialchars($_POST['group_description']),
				'group_name'		=>	htmlspecialchars($_POST['group_name']),
				'group_type'		=>	($group_data['group_type'] == GROUP_INTERNAL) ? GROUP_INTERNAL : intval($_POST['group_type']),
				'show_on_legend'	=>	intval($_POST['show_on_legend'])
			));
			
			$sql = "UPDATE groups
					SET $update_sql
					WHERE group_id = $group_id";
			$db->query($sql);
			
			$cache->delete('groups');
			add_log(LOG_ADMIN, 'updated_group', htmlspecialchars($_POST['group_name']));
			admin_success("index.php?m=manage_groups");
		}
		else
		{
			edit_group_form("index.php?m=$current_module&amp;mode=edit&amp;g=$group_id", lang('edit_group'), lang('update_group'), $group_data['group_name'], $group_data['group_description'], $group_data['group_type'], $group_data['show_on_legend'], $group_data['group_colour']);
		}
	break;
	
	default:
		trigger_error('no_mode_set');
	break;
}
?>