<?php
/*
* --------------------------------------------------------------------------
*                                    NuclearBB
*                              (c) 2007 NuclearBB
* --------------------------------------------------------------------------
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* --------------------------------------------------------------------------
*/

if(! defined('IN_ADMIN'))
{
	exit;
}

$infraction_id = (isset($_GET['infraction'])) ? intval($_GET['infraction']) : 0;

function edit_infraction_form($form_action, $warning_level = '', $infraction_name = '', $infraction_affects = '')
{
	global $db, $mode, $template;
	
	add_lang('perms');
	
	$template->load('body', 'edit_infraction_form.html');
	
	$sql = "SELECT *
			FROM infraction_effectors e, perm_values v
			WHERE e.affecting = v.perm_name_id";
	$result = $db->query($sql);
	while($row = $db->fetch_assoc($result))
	{
		$template->assign_block_vars('effector', array(
			'ID'	=>	$row['affecting'],
			'LANG'	=>	lang($row['perm_name'], true)
		));
	}
	
	$template->assign_vars(array(
		'INFRACTION_AFFECTS'	=>	$infraction_affects,
		'INFRACTION_NAME'		=>	$infraction_name,
		'WARNING_LEVEL'			=>	$warning_level,
		
		'L_BUTTON_TEXT'			=>	($mode == 'edit') ? lang('update_infraction') : lang('add_infraction'),
		'L_HEADER_TEXT'			=>	($mode == 'edit') ? lang('edit_infraction') : lang('new_infraction'),
		
		'FORM_ACTION'			=>	$form_action
	));
	
	$template->display('body');
}

switch($mode)
{
	case 'delete':
		define('PAGE_TITLE', 'delete_infraction');
		
		$infraction_data = array();
		
		$sql = "SELECT *
				FROM infractions
				WHERE infraction_id = $infraction_id";
		$result = $db->query($sql);
		$infraction_data = $db->fetch_assoc($result);
		if(empty($infraction_data))
		{
			trigger_error('infraction_no_exist');
		}
		
		if(isset($_POST['confirm_no']))
		{
			Header('Location: index.php?m=infractions');
		}
		
		if(isset($_POST['confirm_yes']))
		{
			$sql = "DELETE FROM infractions
					WHERE infraction_id = $infraction_id";
			$db->query($sql);
			
			$cache->delete('infractions');
			add_log(LOG_ADMIN, 'deleted_infraction', htmlspecialchars($infraction_data['infraction_name']));
			admin_success('index.php?m=infractions');
		}
		else
		{
			confirm_box("index.php?m=$current_module&amp;mode=delete&amp;infraction=$infraction_id", 'confirm_delete_infraction');
		}
	break;
	
	case 'new':
		define('PAGE_TITLE', 'new_infraction');
		
		if(isset($_POST['submit']))
		{
			check_required_fields(array('warning_level', 'infraction_name', 'infraction_affects'));
			
			$update_sql = $db->build_query('INSERT', array(
				'infraction_affects'	=>	intval($_POST['infraction_affects']),
				'infraction_name'		=>	htmlspecialchars($_POST['infraction_name']),
				'warning_level'			=>	intval($_POST['warning_level'])
			));
			
			$sql = "INSERT INTO infractions $update_sql";
			$db->query($sql);
			
			$cache->delete('infractions');
			add_log(LOG_ADMIN, 'created_infraction', htmlspecialchars($_POST['infraction_name']));
			admin_success("index.php?m=infractions");
		}
		else
		{
			edit_infraction_form("index.php?m=$current_module&amp;mode=new", (! empty($_POST['warning_level']) ? intval($_POST['warning_level']) : ''));
		}
	break;
	
	case 'edit':
		define('PAGE_TITLE', 'edit_infraction');
		
		if(isset($_POST['submit']))
		{
			check_required_fields(array('warning_level', 'infraction_name', 'infraction_affects'));
			
			$update_sql = $db->build_query('UPDATE', array(
				'infraction_affects'	=>	intval($_POST['infraction_affects']),
				'infraction_name'		=>	htmlspecialchars($_POST['infraction_name']),
				'warning_level'			=>	intval($_POST['warning_level'])
			));
			
			$sql = "UPDATE infractions
					SET $update_sql
					WHERE infraction_id = $infraction_id";
			$db->query($sql);
			
			$cache->delete('infractions');
			add_log(LOG_ADMIN, 'updated_infraction', htmlspecialchars($_POST['infraction_name']));
			admin_success("index.php?m=infractions");
		}
		else
		{
			$infraction_data = array();
			
			$sql = "SELECT *
					FROM infractions
					WHERE infraction_id = $infraction_id";
			$result = $db->query($sql);
			$infraction_data = $db->fetch_assoc($result);
			if(empty($infraction_data))
			{
				trigger_error('infraction_no_exist');
			}
			
			edit_infraction_form("index.php?m=$current_module&amp;mode=edit&amp;infraction=$infraction_id", $infraction_data['warning_level'], $infraction_data['infraction_name'], $infraction_data['infraction_affects']);
		}
	break;
	
	default:
		trigger_error('no_mode_set');
	break;
}
?>