<?php
/*
* --------------------------------------------------------------------------
*                                    NuclearBB
*                              (c) 2007 NuclearBB
* --------------------------------------------------------------------------
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* --------------------------------------------------------------------------
*/

if(! defined('IN_ADMIN'))
{
	exit;
}

define('PAGE_TITLE', 'edit_module');
$module_id = (isset($_GET['module'])) ? intval($_GET['module']) : 0;
$parent_id = (isset($_REQUEST['parent'])) ? intval($_REQUEST['parent']) : 0;

switch($mode)
{
	case 'new':
		if(isset($_POST['submit']))
		{
			//===================================================================================================
			//===================================================================================================
			//===================================================================================================
			trigger_error('Broken!');
			//===================================================================================================
			//===================================================================================================
			//===================================================================================================
			
			check_required_fields(array('module_name', 'module_file', 'view_perm'));
			
			add_log(LOG_ADMIN, 'created_module', htmlspecialchars($_POST['module_name']));
			admin_success('index.php?m=manage_'. $_POST['module_type'] .'_modules');
		}
		else
		{
			$template->load('body', 'edit_module_form.html');
			
			generate_module_files_dropdown();
			
			$template->assign_vars(array(
				'MODULE_ENABLED'	=>	true,
				'MODULE_FILE'		=>	'',
				'MODULE_NAME'		=>	(isset($_POST['module_name'])) ? htmlspecialchars($_POST['module_name']) : '',
				'MODULE_TYPE'		=>	'acp',
				'SHOW_MENU'			=>	true,
				
				'L_BUTTON_TEXT'		=>	lang('create_module'),
				
				'FORM_ACTION'		=>	"index.php?m=$current_module&amp;mode=new&amp;parent=$parent_id"
			));
			
			$template->display('body');
		}
	break;
	
	case 'edit':
		if(isset($_POST['submit']))
		{
			check_required_fields(array('module_name', 'module_file', 'view_perm'));
			
			$update_sql = $db->build_query('UPDATE', array(
				'module_enabled'	=>	intval($_POST['module_enabled']),
				'module_file'		=>	htmlspecialchars($_POST['module_file']),
				'module_name'		=>	htmlspecialchars($_POST['module_name']),
				'show_menu'			=>	intval($_POST['show_menu']),
				'view_perm'			=>	htmlspecialchars($_POST['view_perm'])
			));
			
			$sql = "UPDATE modules
					SET $update_sql
					WHERE module_id = $module_id";
			$db->query($sql);
			
			add_log(LOG_ADMIN, 'updated_module', htmlspecialchars($_POST['module_name']));
			admin_success('index.php?m=manage_'. $_POST['module_type'] .'_modules');
		}
		else
		{
			$module_data = array();
			$module_type = '';
			
			$template->load('body', 'edit_module_form.html');
			
			$sql = "SELECT *
					FROM modules
					WHERE module_id = $module_id";
			$result = $db->query($sql);
			$module_data = $db->fetch_assoc($result);
			if(empty($module_data))
			{
				trigger_error('module_no_exist');
			}
			
			if($module_data['parent_id'] == 0)
			{
				$module_type = 'tab';
			}
			
			if(($module_data['right_id'] != ($module_data['left_id'] + 1)) && ($module_data['parent_id'] != 0))
			{
				$module_type = 'category';
			}
			
			if($module_data['right_id'] == ($module_data['left_id'] + 1))
			{
				$module_type = 'module';
			}
			
			generate_module_files_dropdown();
			
			$template->assign_vars(array(
				'MODULE_ENABLED'	=>	$module_data['module_enabled'],
				'MODULE_FILE'		=>	$module_data['module_file'],
				'MODULE_NAME'		=>	$module_data['module_name'],
				'MODULE_TYPE'		=>	$module_data['module_type'],
				'SHOW_MENU'			=>	$module_data['show_menu'],
				'VIEW_PERM'			=>	$module_data['view_perm'],
				
				'L_BUTTON_TEXT'		=>	lang('edit_module'),
				
				'FORM_ACTION'		=>	"index.php?m=$current_module&amp;mode=edit&amp;module=$module_id"
			));
			
			$template->display('body');
		}
	break;
	
	default:
		trigger_error('no_mode_set');
	break;
}

function generate_module_files_dropdown()
{
	global $root_path, $template;
	
	if($dh = opendir("$root_path/admin/modules"))
	{
		while(($file = readdir($dh)) !== false)
		{
			if($file != '.' && $file != '..')
			{
				$template->assign_block_vars('module_file', array(
					'NAME'	=>	$file,
					'VALUE'	=>	str_replace('.php', '', $file)
				));
			}
		}
		
		closedir($dh);
	}
}
?>