<?php
/*
* --------------------------------------------------------------------------
*                                    NuclearBB
*                              (c) 2007 NuclearBB
* --------------------------------------------------------------------------
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* --------------------------------------------------------------------------
*/

if(! defined('IN_ADMIN'))
{
	exit;
}

$rank_id = (isset($_GET['rank'])) ? intval($_GET['rank']) : 0;

function edit_rank_form($form_action, $l_header_text, $l_button_text, $rank_title = '', $rank_image = '', $rank_posts = 0, $rank_special = 0)
{
	global $mode, $root_path, $template;
	
	$template->load('body', 'edit_rank_form.html');
	
	if($dh = opendir("$root_path/images/ranks"))
	{
		while(($file = readdir($dh)) !== false)
		{
			if($file != '.' && $file != '..')
			{
				$template->assign_block_vars('rank_image', array(
					'NAME'	=>	$file
				));
			}
		}
		
		closedir($dh);
	}
	
	$template->assign_vars(array(
		'RANK_IMAGE'		=>	$rank_image,
		'RANK_POSTS'		=>	$rank_posts,
		'RANK_SPECIAL'		=>	$rank_special,
		'RANK_TITLE'		=>	$rank_title,
		
		'L_BUTTON_TEXT'		=>	$l_button_text,
		'L_HEADER_TEXT'		=>	$l_header_text,
		
		'FORM_ACTION'		=>	$form_action
	));
	
	$template->display('body');
}

switch($mode)
{
	case 'delete':
		define('PAGE_TITLE', 'delete_rank');
		
		$rank_data = array();
		
		$sql = "SELECT *
				FROM ranks
				WHERE rank_id = $rank_id";
		$result = $db->query($sql);
		$rank_data = $db->fetch_assoc($result);
		
		if(empty($rank_data))
		{
			trigger_error('rank_no_exist');
		}
		
		if(isset($_POST['confirm_no']))
		{
			Header('Location: index.php?m=manage_ranks');
		}
		
		if(isset($_POST['confirm_yes']))
		{
			$sql = "DELETE FROM ranks
					WHERE rank_id = $rank_id";
			$db->query($sql);
			
			$cache->delete('ranks');
			
			add_log(LOG_ADMIN, 'deleted_rank', htmlspecialchars($rank_data['rank_title']));
			admin_success('index.php?m=manage_ranks');
		}
		else
		{
			confirm_box("index.php?m=$current_module&amp;mode=delete&amp;rank=$rank_id", 'confirm_delete_rank');
		}
	break;
	
	case 'new':
		define('PAGE_TITLE', 'new_rank');
		
		if(isset($_POST['submit']))
		{
			check_required_fields(array('rank_name'));
			
			$insert_sql = $db->build_query('INSERT', array(
				'rank_image'	=>	htmlspecialchars($_POST['rank_image']),
				'rank_posts'	=>	intval($_POST['rank_posts']),
				'rank_special'	=>	intval($_POST['rank_special']),
				'rank_title'	=>	htmlspecialchars($_POST['rank_name'])
			));
			
			$sql = "INSERT INTO ranks $insert_sql";
			$db->query($sql);
			
			$cache->delete('ranks');
			
			add_log(LOG_ADMIN, 'created_rank', htmlspecialchars($_POST['rank_name']));
			admin_success('index.php?m=manage_ranks');
		}
		else
		{
			edit_rank_form("index.php?m=$current_module&amp;mode=new", lang('new_rank'), lang('create_rank'), ((isset($_POST['new_rank_submit']) ? htmlspecialchars($_POST['rank_name']) : '')));
		}
	break;
	
	case 'edit':
		define('PAGE_TITLE', 'edit_rank');
		
		if(isset($_POST['submit']))
		{
			check_required_fields(array('rank_name'));
			
			$update_sql = $db->build_query('UPDATE', array(
				'rank_image'	=>	htmlspecialchars($_POST['rank_image']),
				'rank_posts'	=>	intval($_POST['rank_posts']),
				'rank_special'	=>	intval($_POST['rank_special']),
				'rank_title'	=>	htmlspecialchars($_POST['rank_name'])
			));
			
			$sql = "UPDATE ranks
					SET $update_sql
					WHERE rank_id = $rank_id";
			$db->query($sql);
			
			$cache->delete('ranks');
			
			add_log(LOG_ADMIN, 'updated_rank', htmlspecialchars($_POST['rank_name']));
			admin_success("index.php?m=manage_ranks");
		}
		else
		{
			$rank_data = array();
			
			$sql = "SELECT *
					FROM ranks
					WHERE rank_id = $rank_id";
			$result = $db->query($sql);
			$rank_data = $db->fetch_assoc($result);
			
			if(empty($rank_data))
			{
				trigger_error('rank_no_exist');
			}
			
			edit_rank_form("index.php?m=$current_module&amp;mode=edit&amp;rank=$rank_id", lang('edit_rank'), lang('update_rank'), $rank_data['rank_title'], $rank_data['rank_image'], $rank_data['rank_posts'], $rank_data['rank_special']);
		}
	break;
	
	default:
		trigger_error('no_mode_set');
	break;
}
?>