<?php
/*
* --------------------------------------------------------------------------
*                                    NuclearBB
*                              (c) 2007 NuclearBB
* --------------------------------------------------------------------------
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* --------------------------------------------------------------------------
*/

if(! defined('IN_ADMIN'))
{
	exit;
}

define('PAGE_TITLE', 'edit_user');

if(isset($_POST['submit']))
{
	$user_id = intval($_GET['u']);
	$user_options = 0;
	
	check_required_fields(array('username', 'user_email', 'primary_group'));
	
	$user_options |= intval($_POST['always_notify_replies']);
	$user_options |= intval($_POST['notify_new_pm']);
	$user_options |= intval($_POST['always_attach_signature']);
	
	$update_sql = $db->build_query('UPDATE', array(
		'aol'				=>	htmlspecialchars($_POST['aol']),
		'date_format'		=>	htmlspecialchars($_POST['date_format']),
		'icq'				=>	htmlspecialchars($_POST['icq']),
		'location'			=>	htmlspecialchars($_POST['location']),
		'msn'				=>	htmlspecialchars($_POST['msn']),
		'post_count'		=>	intval($_POST['post_count']),
		'primary_group'		=>	intval($_POST['primary_group']),
		'user_active'		=>	intval($_POST['user_active']),
		'user_options'		=>	$user_options,
		'user_rank'			=>	intval($_POST['user_rank']),
		'user_signature'	=>	htmlspecialchars($_POST['signature']),
		'website'			=>	htmlspecialchars($_POST['website']),
		'yahoo'				=>	htmlspecialchars($_POST['yahoo'])
	));
	
	$sql = "UPDATE users
			SET $update_sql
			WHERE user_id = $user_id";
	$db->query($sql);
	
	add_log(LOG_ADMIN, 'edited_user', $_POST['username']);
	admin_success("index.php?m=$current_module");
}
else
{
	if(isset($_POST['select_user']))
	{
		$group_data = $rank_data = $user_data = array();
		
		$rank_data = $cache->get_ranks();
		
		$sql = "SELECT *
				FROM users
				WHERE username = '". $db->escape(htmlspecialchars($_POST['username'])) ."'
				AND user_id != ". GUEST_USER;
		$result = $db->query($sql);
		$user_data = $db->fetch_assoc($result);
		
		if(empty($user_data))
		{
			trigger_error('user_no_exist');
		}
		
		$sql = "SELECT g.*, m.*
				FROM groups g, group_members m
				WHERE m.user_id = ". $user_data['user_id'] ."
				AND m.group_id = g.group_id";
		$result = $db->query($sql);
		while($row = $db->fetch_assoc($result))
		{
			$group_data[] = $row;
		}
		
		$template->load('body', 'edit_user_form.html');
		
		for($i = 0; $i < count($group_data); $i++)
		{
			$template->assign_block_vars('group', array(
				'ID'		=>	$group_data[$i]['group_id'],
				'NAME'		=>	$group_data[$i]['group_name'],
				'SELECTED'	=>	($user_data['primary_group'] == $group_data[$i]['group_id'])
			));
		}
		
		foreach($rank_data['special'] as $k => $v)
		{
			$template->assign_block_vars('rank', array(
				'ID'		=>	$k,
				'NAME'		=>	$v['rank_title'],
				'SELECTED'	=>	$user_data['user_rank'] == $k
			));
		}
		
		$template->assign_vars(array(
			'ALWAYS_ATTACH_SIGNATURE'	=>	$user_data['user_options'] & USER_ATTACH_SIGNATURE,
			'ALWAYS_NOTIFY_REPLIES'		=>	$user_data['user_options'] & USER_NOTIFY_TOPIC_REPLY,
			'AOL'						=>	$user_data['aol'],
			'DATE_FORMAT'				=>	$user_data['date_format'],
			'EDIT_USERNAME'				=>	$user_data['username'],
			'ICQ'						=>	$user_data['icq'],
			'LOCATION'					=>	$user_data['location'],
			'MSN'						=>	$user_data['msn'],
			'NO_RANK'					=>	(empty($user_data['rank'])),
			'NOTIFY_NEW_PM'				=>	$user_data['user_options'] & USER_NOTIFY_NEW_PM,
			'POST_COUNT'				=>	$user_data['post_count'],
			'SIGNATURE'					=>	$user_data['user_signature'],
			'USER_ACTIVE'				=>	$user_data['user_active'],
			'USER_EMAIL'				=>	$user_data['email'],
			'USER_ATTACH_SIGNATURE'		=>	USER_ATTACH_SIGNATURE,
			'USER_NOTIFY_NEW_PM'		=>	USER_NOTIFY_NEW_PM,
			'USER_NOTIFY_TOPIC_REPLY'	=>	USER_NOTIFY_TOPIC_REPLY,
			'WEBSITE'					=>	$user_data['website'],
			'YAHOO'						=>	$user_data['yahoo'],
			
			'FORM_ACTION'				=>	"index.php?m=$current_module&amp;u=". $user_data['user_id']
		));
		
		$template->display('body');
	}
	else
	{
		$template->load('body', 'select_user.html');
		
		$template->assign_vars(array(
			'FORM_ACTION'	=>	"index.php?m=$current_module"
		));
		
		$template->display('body');
	}
}
?>