<?php
/*
* --------------------------------------------------------------------------
*                                    NuclearBB
*                              (c) 2007 NuclearBB
* --------------------------------------------------------------------------
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* --------------------------------------------------------------------------
*/

if(! defined('IN_ADMIN'))
{
	exit;
}

define('PAGE_TITLE', 'manage_forums');

$forum_id = (isset($_GET['f'])) ? intval($_GET['f']) : 0;
$breadcrumbs = array(array(0, lang('forum_index')));
$forums = array();
$last_cat = $forum_id;
$last_left = $last_right = $total_replies = $total_topics = 0;

$template->load('body', 'manage_forums.html');

if(empty($forum_id))
{
	$sql = "SELECT *
			FROM forums
			ORDER BY left_id ASC";
	$result = $db->query($sql);
	while($row = $db->fetch_assoc($result))
	{
		$forums[] = $row;
	}
}
else
{
	$sql = "SELECT *
			FROM forums
			WHERE forum_id = $forum_id";
	$result = $db->query($sql);
	$parent_data = $db->fetch_assoc($result);
	
	$sql = "SELECT *
			FROM forums
			WHERE left_id > ". $parent_data['left_id'] ."
			AND right_id < ". $parent_data['right_id'] ."
			ORDER BY left_id ASC";
	$result = $db->query($sql);
	while($row = $db->fetch_assoc($result))
	{
		$forums[] = $row;
	}
	
	$sql = "SELECT *
			FROM forums
			WHERE left_id < ". $parent_data['left_id'] ."
			AND right_id > ". $parent_data['right_id'] ."
			ORDER BY left_id ASC;";
	$result = $db->query($sql);
	while($row = $db->fetch_assoc($result))
	{
		$breadcrumbs[] = array($row['forum_id'], $row['forum_name']);
	}
	
	$breadcrumbs[] = array($parent_data['forum_id'], $parent_data['forum_name']);
	
	$last_cat = $parent_data['forum_id'];
	$last_left = $parent_data['left_id'];
	$last_right = $parent_data['right_id'];
}

for($i = 0; $i < count($forums); $i++)
{
	$is_cat = false;
	
	if($forums[$i]['forum_type'] == TYPE_CATEGORY && $forums[$i]['forum_parent'] == $forum_id)
	{
		$is_cat = true;
		
		$last_cat = $forums[$i]['forum_id'];
		$last_left = $forums[$i]['left_id'];
		$last_right = $forums[$i]['right_id'];
	}
	
	if($last_cat == $forums[$i]['forum_parent'] || $is_cat)
	{
		$template->assign_block_vars('forum', array(
			'COUNT_CLICKS'				=>	($forums[$i]['forum_flags'] & FLAG_LINK_FORUM_COUNT) ? true : false,
			'DESCRIPTION'				=>	newlines($forums[$i]['forum_description']),
			'FORUM_LOCKED'				=>	($forums[$i]['forum_flags'] & FLAG_LOCKED) ? true : false,
			'FORUM_NAME'				=>	$forums[$i]['forum_name'],
			'FORUM_TYPE'				=>	$forums[$i]['forum_type'],
			'IS_CATEGORY'				=>	$is_cat,
			'IS_LAST_FORUM_IN_CATEGORY'	=>	(($forums[$i]['right_id'] + 1) == $last_right),
			'NUM_CLICKS'				=>	$forums[$i]['topics'],
			'REPLIES'					=>	($auth->forum_check('view_hidden_posts', $forums[$i]['forum_id'])) ? $forums[$i]['replies_actual'] : $forums[$i]['replies'],
			'TOPICS'					=>	($auth->forum_check('view_hidden_topics', $forums[$i]['forum_id'])) ? $forums[$i]['topics_actual'] : $forums[$i]['topics'],
			
			'U_CAT_DOWN'				=>	(false) ? '' : 'index.php?m=edit_forum&amp;mode=move_down&amp;f=' . $forums[$i]['forum_id'],
			'U_DELETE'					=>	'index.php?m=edit_forum&amp;mode=delete&amp;f=' . $forums[$i]['forum_id'],
			'U_FORUM_DOWN'				=>	($forums[$i]['right_id'] + 1 == $last_right) ? '' : 'index.php?m=edit_forum&amp;mode=move_down&amp;f=' . $forums[$i]['forum_id'],
			'U_EDIT'					=>	'index.php?m=edit_forum&amp;mode=edit&amp;f='. $forums[$i]['forum_id'],
			'U_NEW_FORUM'				=>	"index.php?m=edit_forum&amp;mode=new&amp;parent_id=$last_cat",
			'U_RESYNC'					=>	'index.php?m=edit_forum&amp;mode=resync&amp;f='. $forums[$i]['forum_id'],
			//Temporarily purposefully disable moving up
			'U_CAT_UP'					=>	'index.php?m=edit_forum&amp;mode=move_up&amp;f=' . $forums[$i]['forum_id'],
			//==========================================
			'U_FORUM_UP'				=>	($forums[$i]['left_id'] == $last_left + 1) ? '' : 'index.php?m=edit_forum&amp;mode=move_up&amp;f=' . $forums[$i]['forum_id'],
			'U_VIEWFORUM'				=>	"index.php?m=$current_module&amp;f=" . $forums[$i]['forum_id']
		));
	}
}

$final_breadcrumbs = '';
for($i = 0; $i < count($breadcrumbs); $i++)
{
	$final_breadcrumbs .= (($i + 1) == count($breadcrumbs)) ? $breadcrumbs[$i][1] : '<a href="index.php?m=manage_forums&amp;f='. $breadcrumbs[$i][0] .'">' . $breadcrumbs[$i][1] . '</a> &raquo; ';
}

$template->assign_vars(array(
	'BREADCRUMBS'		=>	$final_breadcrumbs,
	'TYPE_FORUM'		=>	TYPE_FORUM,
	
	'U_NEW_CATEGORY'	=>	"index.php?m=edit_forum&amp;mode=new&amp;parent_id=$forum_id",
));

$template->display('body');
?>