<?php
/*
* --------------------------------------------------------------------------
*                                    NuclearBB
*                              (c) 2007 NuclearBB
* --------------------------------------------------------------------------
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* --------------------------------------------------------------------------
*/

if(! defined('IN_ADMIN'))
{
	exit;
}

define('PAGE_TITLE', 'admin_index');
add_lang('logs');

if(isset($_POST['admin_notes_submit']))
{
	$sql = "UPDATE config
			SET config_value = '". $db->escape(htmlspecialchars($_POST['admin_notes'])) ."'
			WHERE config_name = 'admin_notes'";
	$db->query($sql);
	
	add_log(LOG_ADMIN, 'updated_admin_notes');
	
	Header('Location: index.php');
}

$template->load('body', 'admin_index.html');

$groups = $cache->get_groups();
$sql = "SELECT l.*, u.username, u.primary_group
		FROM logs l, users u
		WHERE l.log_user = u.user_id
		AND l.log_type = ". LOG_ADMIN ."
		ORDER BY log_time DESC
		LIMIT 5";
$result = $db->query($sql);
while($row = $db->fetch_assoc($result))
{
	$template->assign_block_vars('log', array(
		'ACTION'	=>	lang($row['log_text'], true),
		'COLOUR'	=>	(! empty($row['primary_group'])) ? $groups[ $row['primary_group'] ]['group_colour'] : '',
		'LOG_EXTRA'	=>	$row['log_extra'],
		'TIME'		=>	format_date($row['log_time']),
		'USER'		=>	$row['username']
	));
}

$template->assign_vars(array(
	'ADMIN_NOTES'		=>	$config['admin_notes'],
	'VERSION_HUMAN'		=>	$config['human_version'],
	'VERSION_INTERNAL'	=>	$config['internal_version'],
	'PHP_VERSION'		=>	phpversion(),
	'SQL_VERSION'		=>	$db->version(),
	
	'U_EDIT_USER'		=>	'index.php?m=edit_user'
));

$template->display('body');
?>