<?php
/*
* --------------------------------------------------------------------------
*                                    NuclearBB
*                              (c) 2007 NuclearBB
* --------------------------------------------------------------------------
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* --------------------------------------------------------------------------
*/

if(! defined('IN_ADMIN'))
{
	exit;
}

define('PAGE_TITLE', 'manage_bans');
$email_bans = $ip_bans = $user_bans = 0;

switch($mode)
{
	case 'new':
		check_required_fields(array('ban_info'));
		
		if($_POST['ban_type'] == BAN_USER)
		{
			$ban_info = user_id_from_username(htmlspecialchars($_POST['ban_info']));
		}
		else
		{
			$ban_info = htmlspecialchars($_POST['ban_info']);
		}
		
		switch($_POST['ban_type'])
		{
			case BAN_EMAIL:
				if($ban_info == $session->user_data['email'])
				{
					trigger_error('no_ban_self');
				}
			break;
			
			case BAN_IP:
				if($ban_info == $_SERVER['REMOTE_ADDR'])
				{
					trigger_error('no_ban_self');
				}
			break;
			
			case BAN_USER:
				if($ban_info == $session->user_data['user_id'])
				{
					trigger_error('no_ban_self');
				}
			break;
		}
		
		if($_POST['ban_expires'] == 1)
		{
			$ban_end = time();
			
			$ban_end += (3600 * intval($_POST['expire_hour']));
			$ban_end += (86400 * intval($_POST['expire_day']));
			$ban_end += (2592000 * intval($_POST['expire_month']));
		}
		else
		{
			$ban_end = 0;
		}
		
		$insert_sql = $db->build_query('INSERT', array(
			'ban_expires'	=>	intval($ban_end),
			'ban_info'		=>	$ban_info,
			'ban_type'		=>	intval($_POST['ban_type'])
		));
		
		$sql = "INSERT INTO bans
				$insert_sql";
		$db->query($sql);
		$cache->delete('bans');
		
		add_log(LOG_ADMIN, 'added_ban', htmlspecialchars($_POST['ban_info']));
		admin_success("index.php?m=$current_module");
	break;
	
	case 'lift_ban':
		$sql = "SELECT *
				FROM bans
				WHERE ban_id = " . intval($_GET['ban']);
		$result = $db->query($sql);
		$ban_data = $db->fetch_assoc($result);
		
		$sql = "DELETE FROM bans
				WHERE ban_id = " . intval($_GET['ban']);
		$db->query($sql);
		$cache->delete('bans');
		
		add_log(LOG_ADMIN, 'lifted_ban', $ban_data['ban_info']);
		admin_success("index.php?m=$current_module");
	break;
	
	default:
		$template->load('body', 'manage_bans.html');
		
		$bans = $cache->get_bans();
		
		for($i = 0; $i < count($bans); $i++)
		{
			$block = '';
			
			switch($bans[$i]['ban_type'])
			{
				case BAN_USER:
					$block = 'user_ban';
					$user_bans++;
					
					$sql = "SELECT *
							FROM users
							WHERE user_id = " . $bans[$i]['ban_info'];
					$result = $db->query($sql);
					$user_data = $db->fetch_assoc($result);
					
					$bans[$i]['ban_info'] = $user_data['username'];
				break;
				
				case BAN_EMAIL:
					$block = 'email_ban';
					$email_bans++;
				break;
				
				case BAN_IP:
					$block = 'ip_ban';
					$ip_bans++;
				break;
			}
			
			$template->assign_block_vars($block, array(
				'BAN_INFO'		=>	$bans[$i]['ban_info'],
				'BAN_EXPIRES'	=>	($bans[$i]['ban_expires'] == 0) ? lang('never') : format_date($bans[$i]['ban_expires']),
				
				'U_LIFT_BAN'	=>	"index.php?m=$current_module&amp;mode=lift_ban&amp;ban=" . $bans[$i]['ban_id']
			));
		}
		
		//Hours select box
		for($i = 0; $i < 24	; $i++)
		{
			$template->assign_block_vars('hour', array(
				'VALUE'		=>	$i
			));
		}
		
		//Days select box
		for($i = 0; $i < 30	; $i++)
		{
			$template->assign_block_vars('day', array(
				'VALUE'		=>	$i
			));
		}
		
		//Months select box
		for($i = 0; $i < 13	; $i++)
		{
			$template->assign_block_vars('month', array(
				'VALUE'		=>	$i
			));
		}
		
		$template->assign_vars(array(
			'BAN_EMAIL'			=>	BAN_EMAIL,
			'BAN_IP'			=>	BAN_IP,
			'BAN_USER'			=>	BAN_USER,
			'TOTAL_EMAIL_BANS'	=>	$email_bans,
			'TOTAL_IP_BANS'		=>	$ip_bans,
			'TOTAL_USER_BANS'	=>	$user_bans,
			
			'U_NEW_BAN'			=>	"index.php?m=$current_module&amp;mode=new",
		));
		
		$template->display('body');
	break;
}
?>