<?php
/*
* --------------------------------------------------------------------------
*                                    NuclearBB
*                              (c) 2007 NuclearBB
* --------------------------------------------------------------------------
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* --------------------------------------------------------------------------
*/

if(! defined('IN_ADMIN'))
{
	exit;
}

define('PAGE_TITLE', 'view_admin_logs');
add_lang('logs');

$template->load('body', 'view_logs.html');

$groups = $cache->get_groups();
$sql = "SELECT l.*, u.username, u.primary_group
		FROM logs l, users u
		WHERE l.log_user = u.user_id
		AND l.log_type = ". LOG_ADMIN ."
		ORDER BY log_time DESC";
$result = $db->query($sql);
while($row = $db->fetch_assoc($result))
{
	$template->assign_block_vars('log', array(
		'ACTION'		=>	lang($row['log_text'], true),
		'COLOUR'		=>	(! empty($row['primary_group'])) ? $groups[ $row['primary_group'] ]['group_colour'] : '',
		'LOG_EXTRA'		=>	$row['log_extra'],
		'SHOW_DELETE'	=>	($row['log_time'] < (time() - 604800)), //604800 Seconds = 1 week
		'TIME'			=>	format_date($row['log_time']),
		'USER'			=>	$row['username']
	));
}

$template->assign_vars(array(
	'L_VIEW_LOGS'	=>	lang('view_admin_logs')
));

$template->display('body');
?>