<?php
/*
* --------------------------------------------------------------------------
*                                    NuclearBB
*                              (c) 2007 NuclearBB
* --------------------------------------------------------------------------
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* --------------------------------------------------------------------------
*/

if(! defined('IN_ADMIN'))
{
	exit;
}

define('PAGE_TITLE', 'view_group_members');
add_lang('groups');

$group_id = (isset($_GET['g'])) ? intval($_GET['g']) : 0;
$group_data = $leader_data = array();
$group_members = array('leader' => array(), 'moderator' => array(), 'normal' => array(), 'pending' => array());

$template->load('body', 'view_group_members.html');

$sql = "SELECT *
		FROM groups
		WHERE group_id = $group_id";
$result = $db->query($sql);
$group_data = $db->fetch_assoc($result);if(empty($group_data))
{
	trigger_error('group_no_exist');
}

$sql = "SELECT m.*, u.username, g.group_colour, g.group_id
		FROM group_members m, users u, groups g
		WHERE m.group_id = $group_id
		AND m.user_id = u.user_id
		AND u.primary_group = g.group_id
		ORDER BY u.username ASC";
$result = $db->query($sql);
while($row = $db->fetch_assoc($result))
{
	if($row['user_id'] == $session->user_data['user_id'])
	{
		$user_already_member = true;
	}
	
	switch($row['membership_type'])
	{
		case MEMBERSHIP_LEADER:
			$group_members['leader'][] = $row;
		break;
		
		case MEMBERSHIP_MODERATOR:
			$group_members['moderator'][] = $row;
		break;
		
		case MEMBERSHIP_NORMAL:
			$group_members['normal'][] = $row;
		break;
		
		case MEMBERSHIP_PENDING:
			$group_members['pending'][] = $row;
		break;
	}
}

foreach($group_members as $group_type => $type_data)
{
	for($i = 0; $i < count($group_members[$group_type]); $i++)
	{
		$data = $type_data[$i];
		
		$template->assign_block_vars($group_type, array(
			'USER_COLOUR'	=>	$data['group_colour'],
			'USER_ID'		=>	$data['user_id'],
			'USERNAME'		=>	$data['username']
		));
	}
}

$num_leaders = count($group_members['leader']);
$num_moderators = count($group_members['moderator']);
$num_normal = count($group_members['normal']);
$num_pending = count($group_members['pending']);

$template->assign_vars(array(
	'FORM_ACTION'			=>	"index.php?m=edit_group&amp;mode=moderate&amp;g=$group_id",
	'GROUP_DESCRIPTION'		=>	newlines($group_data['group_description']),
	'GROUP_COLOUR'			=>	$group_data['group_colour'],
	'GROUP_NAME'			=>	$group_data['group_name'],
	'NUM_NORMAL'			=>	count($group_members['normal']),
	'SHOW_LEADERS'			=>	($num_leaders > 0),
	'SHOW_MODERATORS'		=>	($num_moderators > 0),
	'SHOW_PENDING'			=>	($num_pending > 0),
	
	'A_APPROVE_PENDING'		=>	($num_pending > 0),
	'A_DENY_PENDING'		=>	($num_pending > 0),
	'A_MAKE_LEADER'			=>	(($num_normal > 0) || ($num_moderators > 0)),
	'A_MAKE_MODERATOR'		=>	(($num_normal > 0) || ($num_leaders > 0)),
	'A_REMOVE_LEADER'		=>	($num_leaders > 0),
	'A_REMOVE_MODERATOR'	=>	($num_moderators > 0),
	'A_REMOVE_USER'			=>	(($num_normal > 0) || ($num_moderators > 0) || ($num_leaders > 0))
));

$template->display('body');
?>