<?php
/*
* --------------------------------------------------------------------------
*                                    NuclearBB
*                              (c) 2007 NuclearBB
* --------------------------------------------------------------------------
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* --------------------------------------------------------------------------
*/

define('IN_NBB', true);
$root_path = '.';
require("$root_path/inc/global.php");
$session->begin();
$auth->setup();

require("$root_path/inc/functions_captcha.php");
$captcha = new captcha;

forum_header('contact');

if(isset($_POST['contact']))
{
	$captcha_id = (isset($_POST['captcha_id'])) ? htmlspecialchars($_POST['captcha_id']) : '';
	$captcha_guess = (isset($_POST['captcha_id'])) ? htmlspecialchars($_POST['captcha_guess']) : '';
	
	if(! $captcha->check($captcha_id, $captcha_guess))
	{
		trigger_error('captcha_error');
	}
	
	$required_fields = array('reason', 'message', 'captcha_guess');
	
	if(! $session->logged_in)
	{
		$required_fields[] = 'name';
		$required_fields[] = 'email';
	}
	
	check_required_fields($required_fields);
	
	require("$root_path/inc/functions_email.php");
	$mail = new email;
	
	$mail->subject = 'Contact Form Message';
	$mail->add_recipient($config['board_email']);
	$mail->load_message('contact_form');
	
	$mail->parse_vars(array(
		'EMAIL'		=>	($session->logged_in) ? $session->user_data['email'] : htmlspecialchars($_POST['email']),
		'MESSAGE'	=>	htmlspecialchars($_POST['message']),
		'REASON'	=>	htmlspecialchars($_POST['reason'])
	));
	
	$mail->send();
	
	trigger_error('contact_sent');
}
else
{			
	$template->load('body', 'contact.html');
	
	$template->assign_vars(array(
		'CAPTCHA_ID'	=>	$captcha->create_captcha(),
		'USER_EMAIL'	=>	$session->user_data['email']
	));
	
	$template->display('body');
}

forum_footer();
?>