<?php
/*
* --------------------------------------------------------------------------
*                                    NuclearBB
*                              (c) 2007 NuclearBB
* --------------------------------------------------------------------------
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* --------------------------------------------------------------------------
*/

define('IN_NBB', true);
$root_path = '.';
require("$root_path/inc/global.php");
$session->begin();
$auth->setup();
forum_header('groups');
add_lang('groups');

$group_id = (isset($_GET['g'])) ? intval($_GET['g']) : 0;
$mode = (isset($_GET['mode'])) ? htmlspecialchars($_GET['mode']) : '';

switch($mode)
{
	case 'view':
		$group_data = array();
		$group_members = array('leader' => array(), 'moderator' => array(), 'normal' => array(), 'pending' => array());
		$is_leader = $is_moderator = $user_already_member = $user_can_mod = false;
		
		$template->load('body', 'group_detail.html');
		
		$sql = "SELECT *
				FROM groups
				WHERE group_id = $group_id";
		$result = $db->query($sql);
		$group_data = $db->fetch_assoc($result);
		
		if((empty($group_data)) || ($group_data['group_type'] == GROUP_HIDDEN))
		{
			trigger_error('group_no_exist');
		}
		
		$sql = "SELECT m.*, u.username, g.group_colour, g.group_id
				FROM group_members m, users u, groups g
				WHERE m.group_id = $group_id
				AND m.user_id = u.user_id
				AND u.primary_group = g.group_id
				AND u.user_id != ". GUEST_USER ."
				ORDER BY u.username ASC";
		$result = $db->query($sql);
		while($row = $db->fetch_assoc($result))
		{
			if($row['user_id'] == $session->user_data['user_id'])
			{
				$user_already_member = true;
			}
			
			switch($row['membership_type'])
			{
				case MEMBERSHIP_LEADER:
					$group_members['leader'][] = $row;
					
					if($row['user_id'] == $session->user_data['user_id'])
					{
						$is_leader = true;
					}
				break;
				
				case MEMBERSHIP_MODERATOR:
					$group_members['moderator'][] = $row;
					
					if($row['user_id'] == $session->user_data['user_id'])
					{
						$is_moderator = true;
					}
				break;
				
				case MEMBERSHIP_NORMAL:
					$group_members['normal'][] = $row;
				break;
				
				case MEMBERSHIP_PENDING:
					$group_members['pending'][] = $row;
				break;
			}
		}
		
		$user_can_mod = ($is_leader || $is_moderator);
		
		foreach($group_members as $group_type => $type_data)
		{
			for($i = 0; $i < count($group_members[$group_type]); $i++)
			{
				$data = $type_data[$i];
				
				$template->assign_block_vars($group_type, array(
					'USER_COLOUR'	=>	$data['group_colour'],
					'USER_ID'		=>	$data['user_id'],
					'USERNAME'		=>	$data['username'],
					
					'U_PROFILE'		=>	'profile.php?u=' . $data['user_id']
				));
			}
		}
		
		$num_leaders = count($group_members['leader']);
		$num_moderators = count($group_members['moderator']);
		$num_normal = count($group_members['normal']);
		$num_pending = count($group_members['pending']);
		
		$template->assign_vars(array(
			'CAN_JOIN_GROUP'		=>	((! in_array($group_data['group_type'], array(GROUP_INTERNAL, GROUP_PRIVATE))) && (! $user_already_member) && ($session->logged_in)),
			'CAN_WITHDRAW_GROUP'	=>	(($user_already_member) && ($group_data['group_type'] != GROUP_INTERNAL)),
			'FORM_ACTION'			=>	"groups.php?mode=moderate&amp;g=$group_id",
			'GROUP_COLOUR'			=>	$group_data['group_colour'],
			'GROUP_DESCRIPTION'		=>	newlines($group_data['group_description']),
			'GROUP_NAME'			=>	$group_data['group_name'],
			'NUM_NORMAL'			=>	$num_normal,
			'SHOW_LEADERS'			=>	($num_leaders > 0),
			'SHOW_MODERATORS'		=>	($num_moderators > 0),
			'SHOW_PENDING'			=>	(($user_can_mod) && ($num_pending > 0)),
			
			'A_APPROVE_PENDING'		=>	($num_pending > 0),
			'A_DENY_PENDING'		=>	($num_pending > 0),
			'A_MAKE_LEADER'			=>	((($num_normal > 0) || ($num_moderators > 0)) && ($is_leader)),
			'A_MAKE_MODERATOR'		=>	(($num_normal > 0) || ($num_leaders > 0)),
			'A_REMOVE_LEADER'		=>	(($num_leaders > 0) && ($is_leader)),
			'A_REMOVE_MODERATOR'	=>	($num_moderators > 0),
			'A_REMOVE_USER'			=>	(($num_normal > 0) || ($num_moderators > 0) || ($num_leaders > 0)),
			'A_GROUP_MOD'			=>	$user_can_mod,
			
			'U_JOIN_GROUP'			=>	'groups.php?mode=join&amp;g=' . $group_data['group_id'],
			'U_WITHDRAW_GROUP'		=>	'groups.php?mode=withdraw&amp;g=' . $group_data['group_id']
		));
		
		$template->display('body');
	break;
	
	case 'withdraw':
		$membership_data = array();
		
		$sql = "SELECT *
				FROM groups
				WHERE group_id = $group_id";
		$result = $db->query($sql);
		$group_data = $db->fetch_assoc($result);
		
		if((empty($group_data)) || ($group_data['group_type'] == GROUP_HIDDEN))
		{
			trigger_error('group_no_exist');
		}
		
		$sql = "SELECT *
				FROM group_members
				WHERE group_id = $group_id
				AND user_id = " . $session->user_data['user_id'];
		$result = $db->query($sql);
		$membership_data = $db->fetch_assoc($result);
		
		if(empty($membership_data))
		{
			trigger_error('not_group_member');
		}
		
		$sql = "DELETE FROM group_members
				WHERE group_id = $group_id
				AND user_id = " . $session->user_data['user_id'];
		$db->query($sql);
		
		trigger_error(sprintf(lang('successfully_withdrawn'), $group_id));
	break;
	
	case 'moderate':
		$users = array();
		$action = (isset($_POST['action'])) ? htmlspecialchars($_POST['action']) : '';
		$users_post = (isset($_POST['users'])) ? $_POST['users'] : array();
		for($i = 0; $i < count($users_post); $i++)
		{
			$users[] = intval($users_post[$i]);
		}
		
		$imploded_users = implode(',', $users);
		
		$sql = "SELECT g.*, m.*
				FROM groups g, group_members m
				WHERE g.group_id = $group_id
				AND m.group_id = g.group_id
				AND m.user_id = " . $session->user_data['user_id'];
		$result = $db->query($sql);
		$group_data = $db->fetch_assoc($result);
		
		if((empty($group_data)) || ($group_data['group_type'] == GROUP_HIDDEN))
		{
			trigger_error('group_no_exist');
		}
		
		if(! in_array($group_data['membership_type'], array(MEMBERSHIP_LEADER, MEMBERSHIP_MODERATOR)))
		{
			trigger_error('not_auth');
		}
		
		switch($action)
		{
			case 'add_leader':
				if($group_data['membership_type'] != MEMBERSHIP_LEADER)
				{
					trigger_error('not_auth');
				}
				
				$sql = "UPDATE group_members
						SET membership_type = ". MEMBERSHIP_LEADER ."
						WHERE user_id IN($imploded_users)
						AND group_id = $group_id";
				$db->query($sql);
				
				trigger_error(sprintf(lang('added_leader_to_group'), $group_id));
			break;
			
			case 'add_mod':
				$sql = "UPDATE group_members
						SET membership_type = ". MEMBERSHIP_MODERATOR ."
						WHERE user_id IN($imploded_users)
						AND group_id = $group_id";
				$db->query($sql);
				
				trigger_error(sprintf(lang('added_moderator_to_group'), $group_id));
			break;
			
			case 'remove_leader':
			case 'remove_mod':
			case 'approve_pending':
				if(($action == 'remove_leader') && ($group_data['membership_type'] != MEMBERSHIP_LEADER))
				{
					trigger_error('not_auth');
				}
				
				$sql = "UPDATE group_members
						SET membership_type = ". MEMBERSHIP_NORMAL ."
						WHERE user_id IN($imploded_users)
						AND group_id = $group_id";
				$db->query($sql);
				
				switch($action)
				{
					case 'remove_leader':
						$message = 'removed_leader_from_group';
					break;
					
					case 'remove_mod':
						$message = 'removed_moderator_from_group';
					break;
					
					case 'approve_pending':
						$message = 'successfully_approved_pending';
					break;
				}
				
				trigger_error(sprintf(lang($message), $group_id));
			break;
			
			case 'remove':
			case 'deny_pending':
				$sql = "DELETE FROM group_members
						WHERE user_id IN($imploded_users)
						AND group_id = $group_id";
				$db->query($sql);
				
				$message = ($action == 'remove') ? 'removed_from_group' : 'successfully_denied_pending';
				trigger_error(sprintf(lang($message), $group_id));
			break;
			
			case 'add_user':
				$membership_data = array();
				$user_id = user_id_from_username(htmlspecialchars($_POST['username']));
				
				if($user_id === false)
				{
					trigger_error('user_no_exist');
				}
				
				$sql = "SELECT *
						FROM group_members
						WHERE group_id = $group_id
						AND user_id = $user_id";
				$result = $db->query($sql);
				$membership_data = $db->fetch_assoc($result);
				
				if(! empty($membership_data))
				{
					trigger_error('is_already_group_member');
				}
				
				$sql = "INSERT INTO group_members (group_id, user_id, membership_type)
						VALUES($group_id, $user_id, ". MEMBERSHIP_NORMAL .")";
				$db->query($sql);
				
				trigger_error(sprintf(lang('user_added_to_group'), $group_id));
			break;
			
			default:
				trigger_error('no_mode_set');
			break;
		}
	break;
	
	case 'join':
		$group_data = $membership_data = array();
		
		$sql = "SELECT *
				FROM groups
				WHERE group_id = $group_id";
		$result = $db->query($sql);
		$group_data = $db->fetch_assoc($result);
		
		if((empty($group_data)) || ($group_data['group_type'] == GROUP_HIDDEN))
		{
			trigger_error('group_no_exist');
		}
		
		if(in_array($group_data['group_type'], array(GROUP_INTERNAL, GROUP_PRIVATE)))
		{
			trigger_error('cannot_join_group');
		}
		
		$sql = "SELECT *
				FROM group_members
				WHERE group_id = $group_id
				AND user_id = " . $session->user_data['user_id'];
		$result = $db->query($sql);
		$membership_data = $db->fetch_assoc($result);
		
		if(! empty($membership_data))
		{
			trigger_error('already_group_member');
		}
		
		$membership_type = ($group_data['group_type'] == GROUP_FREE) ? MEMBERSHIP_NORMAL : MEMBERSHIP_PENDING;
		$message = ($group_data['group_type'] == GROUP_FREE) ? 'successfully_joined_group' : 'group_join_request_sent';
		
		$sql = "INSERT INTO group_members (group_id, user_id, membership_type)
				VALUES($group_id, ". $session->user_data['user_id'] .", $membership_type)";
		$db->query($sql);
		
		trigger_error(sprintf(lang($message), $group_id));
	break;
	
	default:
		$groups = array();
		
		$groups = $cache->get_groups();
		
		$template->load('body', 'groups.html');
		
		foreach($groups as $group_id => $group_data)
		{
			if($group_data['group_type'] == GROUP_HIDDEN)
			{
				continue;
			}
			
			$template->assign_block_vars('group', array(
				'DESCRIPTION'	=>	$group_data['group_description'],
				'GROUP_COLOUR'	=>	$group_data['group_colour'],
				'NAME'			=>	$group_data['group_name'],
				
				'U_VIEW_GROUP'	=>	"groups.php?mode=view&amp;g=$group_id"
			));
		}
		
		$template->display('body');
	break;
}
forum_footer();
?>