<?php
/*
* --------------------------------------------------------------------------
*                                    NuclearBB
*                              (c) 2007 NuclearBB
* --------------------------------------------------------------------------
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* --------------------------------------------------------------------------
*/

define('IN_NBB', true);
define('IN_AJAX', true);
$root_path = './..';
require("$root_path/inc/global.php");
$session->begin();
$auth->setup();

$mode = (isset($_GET['mode'])) ? htmlspecialchars($_GET['mode']) : '';

switch($mode)
{
	case 'check_username_not_taken':
		$username = htmlspecialchars(strtolower(trim($_POST['username'])));
		
		$user_data = array();
		
		$sql = "SELECT *
				FROM users
				WHERE username = '". $db->escape($username) ."'";
		$result = $db->query($sql);
		$user_data = $db->fetch_assoc($result);
		
		if(empty($user_data))
		{
			echo 0;
		}
		else
		{
			echo 1;
		}
	break;
	
	case 'get_post':
		$post_id = intval($_POST['post_id']);
		
		$sql = "SELECT p.*, t.*
				FROM posts p, topics t
				WHERE p.post_id = $post_id
				AND p.topic_id = t.topic_id";
		$result = $db->query($sql);
		$post_data = $db->fetch_assoc($result);
		
		if(! (($session->user_data['user_id'] == $post_data['post_author'] && $auth->forum_check('edit_own_posts', $post_data['forum_id'])) || $auth->forum_check('edit_others_posts', $post_data['forum_id'])))
		{
			return;
		}
		
		echo $post_data['post_text'];
	break;
	
	case 'update_post':
		$post_id = intval($_POST['post_id']);
		$post_text = trim(htmlspecialchars($_POST['post_text']));
		$post_md5 = md5($post_text);
		
		$sql = "SELECT p.*, t.*
				FROM posts p, topics t
				WHERE p.post_id = $post_id
				AND p.topic_id = t.topic_id";
		$result = $db->query($sql);
		$post_data = $db->fetch_assoc($result);
		
		if(! (($session->user_data['user_id'] == $post_data['post_author'] && $auth->forum_check('edit_own_posts', $post_data['forum_id'])) || $auth->forum_check('edit_others_posts', $post_data['forum_id'])))
		{
			return;
		}
		
		if($post_md5 != $post_data['post_md5'])
		{
			$sql = "UPDATE posts
					SET post_md5 = '$post_md5',
						post_text = '". $db->escape($post_text) ."'
					WHERE post_id = $post_id";
			$db->query($sql);
			
			echo newlines(censor_text(parse_smilies(parse_bbcode($post_text))));
		}
		else
		{
			echo newlines(censor_text(parse_smilies(parse_bbcode($post_data['post_text']))));
		}
	break;
	
	case 'get_post_subject':
		$post_id = intval($_POST['post_id']);
		
		$sql = "SELECT f.*, p.*, t.*
				FROM forums f, posts p, topics t
				WHERE p.post_id = $post_id
				AND t.topic_id = p.topic_id
				AND f.forum_id = t.forum_id";
		$result = $db->query($sql);
		$post_data = $db->fetch_assoc($result);
		
		if($post_data['first_post_id'] != $post_id)
		{
			$sql = "SELECT f.*, p.*, t.*
					FROM forums f, posts p, topics t
					WHERE p.post_id = ". $post_data['first_post_id'] ."
					AND t.topic_id = p.topic_id
					AND f.forum_id = t.forum_id";
			$result = $db->query($sql);
			$first_post_data = $db->fetch_assoc($result);
		}
		
		if(! (($session->user_data['user_id'] == $post_data['post_author'] && $auth->forum_check('edit_own_posts', $post_data['forum_id'])) || $auth->forum_check('edit_others_posts', $post_data['forum_id'])))
		{
			return;
		}
		
		echo (empty($post_data['post_subject'])) ? 'Re: ' . $first_post_data['post_subject'] : $post_data['post_subject'];
	break;
	
	case 'get_topic_title':
		$topic_id = intval($_POST['topic_id']);
		
		$sql = "SELECT *
				FROM topics
				WHERE topic_id = $topic_id";
		$result = $db->query($sql);
		$topic_data = $db->fetch_assoc($result);
		
		if(! (($session->user_data['user_id'] == $topic_data['topic_author'] && $auth->forum_check('edit_own_posts', $topic_data['forum_id'])) || $auth->forum_check('edit_others_posts', $topic_data['forum_id'])))
		{
			return;
		}
		
		echo $topic_data['topic_title'];
	break;
	
	case 'update_post_subject':
		$post_id = intval($_POST['post_id']);
		$post_subject = trim(htmlspecialchars($_POST['post_subject']));
		
		$sql = "SELECT f.*, p.*, t.*
				FROM forums f, posts p, topics t
				WHERE p.post_id = $post_id
				AND t.topic_id = p.topic_id
				AND f.forum_id = t.forum_id";
		$result = $db->query($sql);
		$post_data = $db->fetch_assoc($result);
		
		$sql = "SELECT f.*, p.*, t.*
				FROM forums f, posts p, topics t
				WHERE p.post_id = ". $post_data['first_post_id'] ."
				AND t.topic_id = p.topic_id
				AND f.forum_id = t.forum_id";
		$result = $db->query($sql);
		$first_post_data = $db->fetch_assoc($result);
		
		if(! (($session->user_data['user_id'] == $post_data['post_author'] && $auth->forum_check('edit_own_posts', $post_data['forum_id'])) || $auth->forum_check('edit_others_posts', $post_data['forum_id'])))
		{
			return;
		}
		
		if(($post_subject == 'Re: ' . $first_post_data['post_subject']) || (empty($post_subject)))
		{
			$update_post_subject = '';
			
			if(empty($post_subject))
			{
				$post_subject = 'Re: ' . $first_post_data['post_subject'];
			}
		}
		else
		{
			$update_post_subject = $post_subject;
		}
		
		$sql = "UPDATE posts
				SET post_subject = '". $db->escape($update_post_subject) ."'
				WHERE post_id = $post_id";
		$db->query($sql);
		
		if($post_data['first_post_id'] == $post_id)
		{
			$sql = "UPDATE topics
					SET topic_title = '". $db->escape($post_subject) ."'
					WHERE topic_id = " . $post_data['topic_id'];
			$db->query($sql);
		}
		
		resync_forum($post_data['forum_id']);
		
		echo '<span id="post_subject-'. $post_id .'">'. censor_text($post_subject) .'</span>';
	break;
	
	case 'update_topic_title':
		$topic_id = intval($_POST['topic_id']);
		$topic_title = trim(htmlspecialchars($_POST['topic_title']));
		
		$sql = "SELECT *
				FROM topics
				WHERE topic_id = $topic_id";
		$result = $db->query($sql);
		$topic_data = $db->fetch_assoc($result);
		
		if(! (($session->user_data['user_id'] == $topic_data['topic_author'] && $auth->forum_check('edit_own_posts', $topic_data['forum_id'])) || $auth->forum_check('edit_others_posts', $topic_data['forum_id'])))
		{
			return;
		}
		
		$sql = "UPDATE topics
				SET topic_title = '". $db->escape($topic_title) ."'
				WHERE topic_id = $topic_id";
		$db->query($sql);
		
		$sql = "UPDATE posts
				SET post_subject = '". $db->escape($topic_title) ."'
				WHERE post_id = " . $topic_data['first_post_id'];
		$db->query($sql);
		
		resync_forum($topic_data['forum_id']);
		
		echo '<a id="topic-a-'. $topic_id .'" href="viewtopic.php?t='. $topic_id .'">'. censor_text($topic_title) .'</a>';
	break;
}
?>