<?php
/*
* --------------------------------------------------------------------------
*                                    NuclearBB
*                              (c) 2007 NuclearBB
* --------------------------------------------------------------------------
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* --------------------------------------------------------------------------
*/

//Re-synchronises forum data such as last post info, number of topics and replies
function resync_forum($forum_id)
{
	global $db;
	
	$forum_data = $last_post_data = $topics = $user_data = array();
	$num_hidden_topics = $num_actual_replies = $num_apparent_replies = $num_topics = 0;
	
	$sql = "SELECT *
			FROM forums
			WHERE forum_id = $forum_id";
	$result = $db->query($sql);
	$forum_data = $db->fetch_assoc($result);
	
	$sql = "SELECT t.*, p.*
			FROM topics t, posts p
			WHERE t.forum_id = $forum_id
			AND t.topic_id = p.topic_id
			AND p.post_id = t.last_post_id
			ORDER BY t.last_post_time DESC";
	$result = $db->query($sql);
	while($row = $db->fetch_assoc($result))
	{
		$topics[] = $row;
	}
	
	if((count($topics)) == 0)
	{
		$last_post_data = array(
			'post_id'		=>	0,
			'post_time'		=>	0,
			'topic_id'		=>	0,
			'topic_title'	=>	'',
			'user_id'		=>	0,
			'username'		=>	''
		);
	}
	
	for($i = 0; $i < count($topics); $i++)
	{
		//$i = 0 is the last post
		if($i == 0)
		{
			$sql = "SELECT *
					FROM users
					WHERE user_id = " . $topics[$i]['topic_author'];
			$result = $db->query($sql);
			$user_data = $db->fetch_assoc($result);
			
			$last_post_data = array(
				'post_id'		=>	$topics[$i]['last_post_id'],
				'post_time'		=>	$topics[$i]['last_post_time'],
				'topic_id'		=>	$topics[$i]['topic_id'],
				'topic_title'	=>	(empty($topics[$i]['post_subject'])) ? 'Re: ' . $topics[$i]['topic_title'] : $topics[$i]['post_subject'],
				'user_id'		=>	$topics[$i]['topic_author'],
				'username'		=>	$user_data['username']
			);
		}
		
		if($topics[$i]['topic_hidden'])
		{
			$num_hidden_topics++;
		}
		
		$num_topics++;
		$num_actual_replies += $topics[$i]['replies_actual'];
		$num_apparent_replies += $topics[$i]['replies'];
	}
	
	$update_sql = $db->build_query('UPDATE', array(
		'last_post_id'			=>	$last_post_data['post_id'],
		'last_post_subject'		=>	$last_post_data['topic_title'],
		'last_post_time'		=>	$last_post_data['post_time'],
		'last_post_topic'		=>	$last_post_data['topic_id'],
		'last_post_user_id'		=>	$last_post_data['user_id'],
		'last_post_username'	=>	$last_post_data['username'],
		'replies'				=>	$num_apparent_replies,
		'replies_actual'		=>	$num_actual_replies,
		'topics'				=>	$num_topics - $num_hidden_topics,
		'topics_actual'			=>	count($topics)
	));
	
	$sql = "UPDATE forums
			SET $update_sql
			WHERE forum_id = $forum_id";
	$db->query($sql);
}

//Displays a confirmation box
function confirm_box($form_action, $text = '')
{
	global $template;
	
	$template->load('confirm', 'confirm.html');
	
	$template->assign_vars(array(
		'MESSAGE'				=>	lang($text, true),
		
		'CONFIRM_FORM_ACTION'	=>	$form_action
	));
	
	$template->display('confirm');
}

//Gets all forums that are child to $forum_id and sends data to the template.
//To use in the template, use <!-- INCLUDE forum_list.html -->
function get_forum_list($forum_id = 0)
{
	global $auth, $cache, $config, $db, $images, $template;
	
	$replies_in_topics_text = '';
	$children = $forum_moderators = $forums = $moderator_final_text = $navigation = array();
	$num_forums = $parent_data = $row_count = $total_replies = $total_topics = 0;
	$read_forums = (isset($_COOKIE[ $config['cookie_name'] . '_read_forums' ])) ? unserialize($_COOKIE[ $config['cookie_name'] . '_read_forums' ]) : array();
	
	if(empty($forum_id))
	{
		$sql = "SELECT *
				FROM forums
				ORDER BY left_id ASC";
		$result = $db->query($sql);
		while($row = $db->fetch_assoc($result))
		{
			$children[ $row['forum_id'] ] = 0;
			
			if(($auth->forum_check('view_forum', $row['forum_id'])) && ($row['forum_parent'] != 0))
			{
				$children[ $row['forum_parent'] ]++;
			}
			
			$forums[] = $row;
		}
	}
	else
	{
		$sql = "SELECT *
				FROM forums
				WHERE forum_id = $forum_id";
		$result = $db->query($sql);
		$parent_data = $db->fetch_assoc($result);
		
		$children[ $parent_data['forum_id'] ] = 0;
		
		$sql = "SELECT *
				FROM forums
				WHERE left_id > ". $parent_data['left_id'] ."
				AND right_id < ". $parent_data['right_id'] ."
				ORDER BY left_id ASC";
		$result = $db->query($sql);
		while($row = $db->fetch_assoc($result))
		{
			$children[ $row['forum_id'] ] = 0;
			
			if(($auth->forum_check('view_forum', $row['forum_id'])) && ($row['forum_parent'] != 0))
			{
				$children[ $row['forum_parent'] ]++;
			}
			
			$forums[] = $row;
		}
		
		$sql = "SELECT *
				FROM forums
				WHERE left_id < ". $parent_data['left_id'] ."
				AND right_id > ". $parent_data['right_id'] ."
				ORDER BY left_id ASC;";
		$result = $db->query($sql);
		while($row = $db->fetch_assoc($result))
		{
			$navigation[] = array($row['forum_id'], $row['forum_name']);
		}
		
		for($i = 0; $i < count($navigation); $i++)
		{
			$template->assign_block_vars('navigation', array(
				'FORUM_NAME'	=>	$navigation[$i][1],
				
				'U_VIEWFORUM'	=>	'viewforum.php?f=' . $navigation[$i][0]
			));
		}
		
		$last_cat = $parent_data['forum_id'];
		$last_left = $parent_data['left_id'];
		$last_right = $parent_data['right_id'];
	}
	
	$groups = $cache->get_groups();
	$perm_values = $cache->get_permission_values();
	$moderate_perm_name_id = $perm_values['forum']['moderate']['perm_name_id'];
	
	$sql = "SELECT *
			FROM forum_perms
			WHERE perm_name_id = $moderate_perm_name_id
			AND perm_value = " . PERM_YES;
	$result = $db->query($sql);
	while($row = $db->fetch_assoc($result))
	{
		$forum_moderators[] = $row;
	}
	
	for($i = 0; $i < count($forums); $i++)
	{
		//Only show the user forums they are authed to view
		if(! $auth->forum_check('view_forum', $forums[$i]['forum_id']))
		{
			continue;
		}
		
		$moderator_final_text[ $forums[$i]['forum_id'] ] = array();
		
		if($forums[$i]['forum_flags'] & FLAG_SHOW_MODERATORS)
		{
			for($j = 0; $j < count($forum_moderators); $j++)
			{
				if($forum_moderators[$j]['forum_id'] == $forums[$i]['forum_id'])
				{
					$text = '';
					
					$text .= '<a href="groups.php?mode=view&amp;g='. $groups[ $forum_moderators[$j]['group_id'] ]['group_id'] .'" style="color: #'. $groups[ $forum_moderators[$j]['group_id'] ]['group_colour'] .'; text-decoration: underline;">';
					$text .= $groups[ $forum_moderators[$j]['group_id'] ]['group_name'];
					$text .= '</a>';
					
					$moderator_final_text[ $forums[$i]['forum_id'] ][] = $text;
				}
			}
		}
		
		$num_forums++;
		$is_cat = false;
		$is_last_forum = false;
		
		if($forums[$i]['forum_type'] == TYPE_CATEGORY && $forums[$i]['forum_parent'] == $forum_id)
		{
			$is_cat = true;
			
			$last_cat = $forums[$i]['forum_id'];
			$last_left = $forums[$i]['left_id'];
			$last_right = $forums[$i]['right_id'];
			
			$row_count = 0;
		}
		
		if($last_cat == $forums[$i]['forum_parent'] || $is_cat)
		{
			$row_count++;
			
			$total_replies += $forums[$i]['replies'];
			$total_topics += $forums[$i]['topics'];
			
			$forum_image = $images['FORUM_NO_NEW_POSTS'];
			
			if((! array_key_exists($forums[$i]['forum_id'], $read_forums)) || ($forums[$i]['last_post_time'] > $read_forums[ $forums[$i]['forum_id'] ]))
			{
				$forum_image = $images['FORUM_NEW_POSTS'];
			}
			
			if($forums[$i]['forum_flags'] & FLAG_LOCKED ? true : false)
			{
				$forum_image = $images['FORUM_LOCKED'];
			}
			
			if($forums[$i]['forum_parent'] != 0 && $parent_data['forum_type'] != TYPE_CATEGORY)
			{
				$is_last_forum = ($children[ $forums[$i]['forum_parent'] ] == $row_count - 1);
			}
			
			if($forums[$i]['forum_parent'] != 0 && $parent_data['forum_type'] == TYPE_CATEGORY)
			{
				$is_last_forum = ($children[ $forums[$i]['forum_parent'] ] == $row_count);
			}
			
			$template->assign_block_vars('forum', array(
				'COUNT_CLICKS'				=>	($forums[$i]['forum_flags'] & FLAG_LINK_FORUM_COUNT) ? true : false,
				'DESCRIPTION'				=>	newlines($forums[$i]['forum_description']),
				'FORUM_ID'					=>	$forums[$i]['forum_id'],
				'FORUM_IMAGE'				=>	($forums[$i]['forum_type'] == TYPE_LINK) ? $images['FORUM_LINK'] : $forum_image,
				'FORUM_LOCKED'				=>	($forums[$i]['forum_flags'] & FLAG_LOCKED) ? true : false,
				'FORUM_MODERATORS'			=>	implode(', ', $moderator_final_text[ $forums[$i]['forum_id'] ]),
				'FORUM_NAME'				=>	$forums[$i]['forum_name'],
				'FORUM_TYPE'				=>	$forums[$i]['forum_type'],
				'HAS_REPORTED_POSTS'		=>	($auth->forum_check('view_reported_posts', $forums[$i]['forum_id']) && $forums[$i]['reported_posts'] > 0),
				'HAS_UNAPPROVED_ITEMS'		=>	(($auth->forum_check('view_hidden_topics', $forums[$i]['forum_id']) && $forums[$i]['unapproved_topics'] > 0) || ($auth->forum_check('view_hidden_posts', $forums[$i]['forum_id']) && $forums[$i]['unapproved_posts'] > 0)),
				'IS_CATEGORY'				=>	$is_cat,
				'IS_FIRST_FORUM'			=>	($row_count == 1),
				'IS_LAST_FORUM'				=>	$is_last_forum,
				'LAST_POST_SUBJECT'			=>	truncate_string(censor_text($forums[$i]['last_post_subject']), 30),
				'LAST_POST_USER_COLOUR'		=>	$forums[$i]['last_post_user_colour'],
				'LAST_POST_USERNAME'		=>	$forums[$i]['last_post_username'],
				'NUM_CLICKS'				=>	$forums[$i]['topics'],
				'REPLIES'					=>	($auth->forum_check('view_hidden_posts', $forums[$i]['forum_id'])) ? $forums[$i]['replies_actual'] : $forums[$i]['replies'],
				'REPORTED_POSTS'			=>	$forums[$i]['reported_posts'],
				'REPORTED_POSTS_TEXT'		=>	($forums[$i]['reported_posts'] > 1) ? sprintf(lang('forum_contains_reported_posts'), $forums[$i]['reported_posts']) : lang('forum_contains_reported_post'),
				'TOPICS'					=>	($auth->forum_check('view_hidden_topics', $forums[$i]['forum_id'])) ? $forums[$i]['topics_actual'] : $forums[$i]['topics'],
				'UNAPPROVED_POSTS'			=>	$forums[$i]['unapproved_posts'],
				'UNAPPROVED_POSTS_TEXT'		=>	($forums[$i]['unapproved_posts'] > 1) ? sprintf(lang('forum_contains_unapproved_posts'), $forums[$i]['unapproved_posts']) : lang('forum_contains_unapproved_post'),
				'UNAPPROVED_TOPICS'			=>	$forums[$i]['unapproved_topics'],
				'UNAPPROVED_TOPICS_TEXT'	=>	($forums[$i]['unapproved_topics'] > 1) ? sprintf(lang('forum_contains_unapproved_topics'), $forums[$i]['unapproved_topics']) : lang('forum_contains_unapproved_topic'),
				
				'L_MODERATOR_TEXT'			=>	(count($moderator_final_text[ $forums[$i]['forum_id'] ]) == 1) ? lang('moderator') : lang('moderators'),
				
				'U_LAST_POST'				=>	"viewtopic.php?t={$forums[$i]['last_post_topic']}&amp;p={$forums[$i]['last_post_id']}#p{$forums[$i]['last_post_id']}",
				'U_LAST_USER_PROFILE'		=>	'profile.php?u='. $forums[$i]['last_post_user_id'],
				'U_VIEWFORUM'				=>	"viewforum.php?f=" . $forums[$i]['forum_id']
			));
		}
	}
	
	if($total_topics == 1)
	{
		if($total_replies == 1)
		{
			$replies_in_topics_text = lang('reply_in_topic');
		}
		else
		{
			$replies_in_topics_text = sprintf(lang('replies_in_topic'), $total_replies);
		}
	}
	else
	{
		if($total_replies == 1)
		{
			$replies_in_topics_text = sprintf(lang('reply_in_topics'), $total_topics);
		}
		else
		{
			$replies_in_topics_text = sprintf(lang('replies_in_topics'), $total_replies, $total_topics);
		}
	}
	
	$template->assign_vars(array(
		'NUM_FORUMS'				=>	$num_forums,
		'REPLIES_IN_TOPICS_TEXT'	=>	$replies_in_topics_text,
		'TOTAL_TOPICS'				=>	$total_topics,
		'TOTAL_REPLIES'				=>	$total_replies,
		'TYPE_FORUM'				=>	TYPE_FORUM
	));
	
	return $num_forums;
}

//Returns a <select> box of all timezones
//We make it here so template authors don't have to
function timezone_select()
{
	global $lang, $session;
	
	$select = '<select name="timezone">';
	
	foreach($lang['TZ'] as $offset => $name)
	{
		$selected = ($session->user_data['time_offset'] == $offset) ? ' selected="selected"' : '';
		$select .= '<option value="'. $offset .'"'. $selected .'>'. $name .'</option>';
	}
	
	$select .= '</select>';
	
	return $select;
}

//Applies word censors to $text
function censor_text($text)
{
	global $cache;
	
	$words = $cache->get_bad_words();
	
	for($i = 0; $i < count($words); $i++)
	{
		$text = preg_replace('#\b'. $words[$i]['bad_word'] .'\b#i', $words[$i]['replacement'], $text);
	}
	
	return $text;
}

//Sends a private message. Handles E-Mail notification as well
function send_pm($to_user, $from_user, $subject = '', $message)
{
	global $config, $db, $root_path;
	$from_user_data = $to_user_data = array();
	
	$sql = "SELECT *
			FROM users
			WHERE user_id = ". intval($from_user);
	$result = $db->query($sql);
	$from_user_data = $db->fetch_assoc($result);
	
	$sql = "SELECT *
			FROM users
			WHERE user_id = ". intval($to_user);
	$result = $db->query($sql);
	$to_user_data = $db->fetch_assoc($result);
	
	if(empty($to_user_data))
	{
		trigger_error('user_no_exist');
	}
	
	$insert_sql = $db->build_query('INSERT', array(
		'from_user'		=>	intval($from_user),
		'to_user'		=>	intval($to_user),
		'time_sent'		=>	time(),
		'subject'		=>	htmlspecialchars($subject),
		'message'		=>	htmlspecialchars($message)
	));
	
	$sql = "INSERT INTO private_messages
			$insert_sql";
	$db->query($sql);
	
	$pm_id = $db->last_id();
	
	if($to_user_data['user_options'] & USER_NOTIFY_NEW_PM)
	{
		require("$root_path/inc/functions_email.php");
		$mail = new email;
		
		$mail->subject = 'You have received a new private message';
		$mail->add_recipient($to_user_data['email'], $to_user_data['username']);
		
		$mail->load_message('new_pm');
		$mail->parse_vars(array(
			'FORUM_NAME'	=>	$config['board_name'],
			'FROM_NAME'		=>	$from_user_data['username'],
			'SUBJECT'		=>	(! empty($subject)) ? htmlspecialchars($subject) : '[' . lang('no_subject') . ']',
			
			'U_READ'		=>	"{$config['board_url']}/ucp.php?m=read_pm&id=$pm_id"
		));
		
		$mail->send();
	}
	
	$sql = "UPDATE users
			SET unread_pms = unread_pms + 1
			WHERE user_id = $to_user";
	$db->query($sql);
	
	return $pm_id;
}

//Returns the extension of a file
function get_file_extension($file_name)
{
	$path_info = pathinfo($file_name);
	
	return $path_info['extension'];
}

function mcp_success($return_message, $message_text = '')
{
	global $template;
	
	$template->load('mcp_success', 'success_message.html');
	
	$use_lang_string = (empty($message_text)) ? 'op_successful' : $message_text;
	
	$template->assign_vars(array(
		'MESSAGE_TEXT'		=>	lang($use_lang_string),
		'RETURN_MESSAGE'	=>	$return_message
	));
	
	$template->display('mcp_success');
}

function ucp_success($redirect_url, $message_text = '')
{
	global $template;
	
	$template->load('ucp_success', 'success_message.html');
	
	$use_lang_string = (empty($message_text)) ? 'op_successful' : $message_text;
	
	$template->assign_vars(array(
		'MESSAGE_TEXT'		=>	lang($use_lang_string),
		'RETURN_MESSAGE'	=>	sprintf(lang('click_return_text'), $redirect_url, 'ucp.php')
	));
	
	$template->display('ucp_success');
}

//Returns a salted md5 of $string (saves having to do md5($string . $password_salt) all over the place)
function md5_salt($string)
{
	global $password_salt;
	
	return md5($string . $password_salt);
}

function generate_avatar_text($avatar_type, $avatar_file)
{
	global $config, $root_path;
	
	$src = '';
	$height = $width = 0;
	
	switch($avatar_type)
	{
		case AVATAR_REMOTE:
			$src = $avatar_file;
		break;
		
		case AVATAR_UPLOAD:
			$src = "$root_path/images/avatars/$avatar_file";
		break;
	}
	
	if(file_exists($src))
	{
		$image_info = getimagesize($src);
		$width = $image_info[0];
		$height = $image_info[1];
		
		//Check for oversized image and re-size as appropriate
		if($image_info[0] > $config['max_avatar_width'])
		{
			$width = $config['max_avatar_width'];
		}
		
		if($image_info[1] > $config['max_avatar_height'])
		{
			$height = $config['max_avatar_height'];
		}
	}
	
	return 'src="'. $src .'" alt="'. lang('avatar') .'" width="'. $width .'" height="'. $height .'"';
}

//This function will return a random set of characters
function generate_random_string($length = 6)
{
	$chars = array('A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J',  'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T',  'U', 'V', 'W', 'X', 'Y', 'Z', '1', '2', '3', '4', '5', '6', '7', '8', '9');
		
		$code = '';
		$num_chars = (count($chars)) - 1;
		for($i = 0; $i < $length; $i++)
		{
			$case = rand(0, 1);
			$rand_index = rand(0, $num_chars);
			//Random lowercasing of some letters
			$code .= ($case == 0) ? strtolower($chars[$rand_index]) : $chars[$rand_index];
		}
		
		return $code;
}

//This will return a user ID from a given username
function user_id_from_username($username)
{
	global $db;
	
	$user_data = array();
	
	$sql = "SELECT *
			FROM users
			WHERE username = '". $db->escape(htmlspecialchars($username)) ."'
			AND user_id != ". GUEST_USER;
	$result = $db->query($sql);
	$user_data = $db->fetch_assoc($result);
	
	if(empty($user_data))
	{
		return false;
	}
	
	return $user_data['user_id'];
}

//Truncates a string at a given length (Appears like this: I am a string that has been trunca...)
function truncate_string($string, $length, $dot_dot = '...')
{
	if(strlen($string) > $length)
	{
		$string = substr($string, 0, $length) . $dot_dot;
	}
	
	return $string;
}

//Adds a log into the database
function add_log($log_type, $log_action, $log_extra = '')
{
	global $db, $session;
	
	$sql = "INSERT INTO logs (log_type, log_text, log_extra, log_user, log_time)
			VALUES($log_type, '$log_action', '". $db->escape(htmlspecialchars($log_extra)) ."', ". $session->user_data['user_id'] .", ". time() .")";
	$db->query($sql);
}

//Parses $text and replaces smiley codes with their appropriate image :)
function parse_smilies($text)
{
	global $cache, $config, $root_path;
	
	if(defined('IN_AJAX'))
	{
		$root_path = '.';
	}
	
	$smilies = $cache->get_smilies();
	for($i = 0; $i < count($smilies[ $config['smiley_set'] ]); $i++)
	{
		$text = preg_replace('#' . preg_quote($smilies[ $config['smiley_set'] ][$i]['smiley_text'], '#') . '#i', '<img src="'. $root_path . '/images/smilies/'. $config['smiley_set'] .'/' . $smilies[ $config['smiley_set'] ][$i]['smiley_image'] .'" alt="" />', $text);
	}
	
	return $text;
}

//Formats a post with BBCode
function parse_bbcode($text)
{
	global $current_style_folder, $root_path;
	
	if(defined('IN_AJAX'))
	{
		$root_path = '..';
	}
	
	$template_bbcodes = array();
	
	$text = preg_replace('#(about|activex|applet|chrome|javascript):.+#i', '', $text);
	$bbcode_file = file_get_contents("$root_path/styles/$current_style_folder/bbcode.html");
	//So newlines() doesn't inset a <br /> for every new line in this file
	$bbcode_file = str_replace("\n", '', $bbcode_file);
	
	preg_match_all('#<!-- BEGIN (.+?) -->(.+?)<!-- END \\1 -->#s', $bbcode_file, $bbcode_matches);
	
	for($i = 0; $i < count($bbcode_matches[0]); $i++)
	{
		$bbcode_name = str_replace(array('_open', '_close'), '', $bbcode_matches[1][$i]);
		
		if(strstr($bbcode_matches[1][$i], '_open'))
		{
			$template_bbcodes[$bbcode_name][0] = $bbcode_matches[2][$i];
		}
		
		if(strstr($bbcode_matches[1][$i], '_close'))
		{
			$template_bbcodes[$bbcode_name][1] = $bbcode_matches[2][$i];
		}
	}
	
	//Bold Text - [b]NuclearBB[/b]
	$text = preg_replace('#\[b\](.+?)\[\/b\]#i', '<strong>$1</strong>', $text);
	
	//Italic Text - [i]NuclearBB[/i]
	$text = preg_replace('#\[i\](.+?)\[\/i\]#i', '<em>$1</em>', $text);
	
	//Underlined Text - [u]NuclearBB[/u]
	$text = preg_replace('#\[u\](.+?)\[\/u\]#i', '<u>$1</u>', $text);
	
	//Coloured Text - [color=#ffffff]NuclearBB[/color]
	$text = preg_replace('#\[color=\#(.+?)\](.+?)\[\/color\]#i', '<span style="color: #$1;">$2</span>', $text);
	$text = preg_replace('#\[color=(.+?)\](.+?)\[\/color\]#i', '<span style="color: #$1;">$2</span>', $text);
	
	//Image - [img]http://www.google.com/images/logo_sm.gif[/img]
	$text = preg_replace('#\[img\](.+?)\[\/img\]#i', '<img src="$1" alt="" />', $text);
	
	//URL - [url=http://www.google.co.uk]Google[/url]
	$text = preg_replace('#\[url=(.+?)\](.+?)\[\/url\]#i', '<a href="$1">$2</a>', $text);
	
	//URL - [url]http://www.google.co.uk[/url]
	$text = preg_replace('#\[url\](.+?)\[\/url\]#i', '<a href="$1">$1</a>', $text);
	
	//E-Mail - [email]nuclearbb@example.co.uk[/email]
	$text = preg_replace('#\[email\](.+?)\[\/email\]#i', '<a href="mailto:$1">$1</a>', $text);
	
	//Quote With Username - [quote=nuclearbb]NuclearBB[/quote]
	$text = preg_replace('#\[quote=(.+?)\](.+?)\[\/quote\]#is', $template_bbcodes['quote'][0] . $template_bbcodes['quote_username'][0] . '$1' . $template_bbcodes['quote_username'][1] . '$2' . $template_bbcodes['quote'][1], $text);
	
	//Quote - [quote]NuclearBB[/quote]
	$text = preg_replace('#\[quote\](.+?)\[\/quote\]#is', $template_bbcodes['quote'][0] . '$1' . $template_bbcodes['quote'][1], $text);
	
	//Code - [code]NuclearBB[/code]
	$text = preg_replace('#\[code\](.+?)\[\/code\]#is', $template_bbcodes['code'][0] . '$1' . $template_bbcodes['code'][1] , $text);
	
	return $text;
}

//Formats a date according to the users profile
//and adjusts it according to their timezone
function format_date($unix_timestamp, $override_format = '')
{
	global $session;
	
	$format = (empty($override_format)) ? $session->user_data['date_format'] : $override_format;
	
	return gmdate($format, ($unix_timestamp + (60 * $session->user_data['time_offset'])));
}

//This will handle pagination
function generate_pagination($num_items, $per_page, $start, $base_url)
{
	$pagination = '';
	
	$num_pages = floor($num_items / $per_page) + 1;
	$on_page = ($start / $per_page) + 1;
	
	if($num_pages == 1)
	{
		return;
	}
	
	if($num_pages < 5)
	{
		for($i = 0; $i < $num_pages; $i++)
		{
			$seperator = ($num_pages != $i + 1) ? ', ' : '';
			$pagination .= ($on_page == ($i + 1)) ? '<strong>'. ($i + 1) .'</strong>'. $seperator :  '<a href="'. $base_url .'&amp;page='. ($i + 1) .'">'. ($i + 1) .'</a>'. $seperator;
		}
	}
	else
	{
		for($i = 0; $i < 5; $i++)
		{
			$seperator = (($i + 1) != 5) ? ', ' : ' ... ';
			$pagination .= ($on_page == ($i + 1)) ? '<strong>'. ($i + 1) .'</strong>'. $seperator :  '<a href="'. $base_url .'&amp;page='. ($i + 1) .'">'. ($i + 1) .'</a>'. $seperator;
		}
		
		$start_num = (($num_pages - 3) < 5) ? 5 : $num_pages - 3;
		
		for($i = $start_num; $i < $num_pages; $i++)
		{
			$seperator = (($i + 1) != $num_pages) ? ', ' : '';
			$pagination .= ($on_page == ($i + 1)) ? '<strong>'. ($i + 1) .'</strong>'. $seperator :  '<a href="'. $base_url .'&amp;page='. ($i + 1) .'">'. ($i + 1) .'</a>'. $seperator;
		}
	}
	
	return $pagination;
}

//This will check an E-Mail is valid
function check_email($email)
{
	global $db;
	
	$email = trim($email);
	
	if(! preg_match('#^[a-z0-9&\'\.\-_\+]+@[a-z0-9\-]+\.([a-z0-9\-]+\.)*?[a-z]+$#i', $email))
	{
		return 'email_invalid';
	}
}

//This will check to see if a username is allowed
function check_allowed_username($username)
{
	global $config, $db;
	
	$username = trim($username);
	
	$sql = "SELECT *
			FROM users
			WHERE username = '". $db->escape($username) ."'";
	$result = $db->query($sql);
	$user_data = $db->fetch_assoc($result);
	
	if($user_data)
	{
		return 'username_taken';
	}
	
	if(strlen($username) > $config['max_username_length'])
	{
		return 'username_too_long';
	}
}

//This will check if all the field names specified in $required_fields
//are not empty. If they are, an error message will be shown
function check_required_fields($required_fields = array())
{
	foreach($_POST as $k => $v)
	{
		if((empty($_POST[$k])) && in_array($k, $required_fields))
		{
			define('FIELD_ERROR', true);
		}
		
		if(defined('FIELD_ERROR'))
		{
			trigger_error('required_fields');
		}
	}
}

//We use this instead of nl2br because older versions
//of PHP return <br> instead of <br />
function newlines($text)
{
	//Force a new line every 90 characters without a space
	$text = preg_replace('#(\S{90})#', '$1<br />', $text);
	
	//Replace all \n with XHTML valid <br />
	$text = str_replace("\n", "<br />\n", $text);
	
	return $text;
}

//This will add a language file to the $lang array,
//which can then be called with lang('lang_string');
function add_lang($file, $language = 'english')
{
	global $root_path, $lang;
	
	if(file_exists("$root_path/language/$language/$file.php"))
	{
		include("$root_path/language/$language/$file.php");
	}
	else
	{
		trigger_error(sprintf(lang('no_include_lang'), $file), E_USER_WARNING);
	}
}

//Returns a language string
function lang($lang_string, $return_literal = false)
{
	global $lang;
	
	$upper = strtoupper($lang_string);
	
	if(array_key_exists($upper, $lang))
	{
		return $lang[$upper];
	}
	else
	{
		return ($return_literal) ? $lang_string : "{{$upper}}";
	}
}


//Does the same as print_r plus adds the <pre> tags and
//allows an optional title to be placed in the output.
//This is only for debugging purposes and should not be used anywhere else
function printy_r($array, $title = '')
{
	echo('<hr />');
	if(! empty($title))
	{
		echo("<h1>$title</h1>");
	}
	echo('<pre>');
	print_r($array);
	echo('</pre>');
	echo('<hr />');
}

//This is our error handler. Use trigger_error('This is an error');
//to send a formatted message to the user
function bb_error_handler($errno, $errstr, $errfile, $errline)
{
	if(! error_reporting())
	{
		return;
	}
	
	global $lang, $root_path, $template;
	
	$path_info = pathinfo($errfile);
	$errfile = str_replace($path_info['dirname'], '', $errfile);
	if($errfile{0} == '\\')
	{
		$errfile = str_replace('\\', '', $errfile);
	}
	
	$errstr = lang($errstr, true);
	
	switch ($errno)
	{
		case E_ERROR:
		case E_USER_ERROR:
			echo "<p><strong>[NuclearBB Error]</strong> $errstr (Line $errline, File $errfile)</p>";
			exit;
		break;
		
		case E_WARNING:
		case E_USER_WARNING:
			echo "<p><strong>[NuclearBB Warning]</strong> $errstr (Line $errline, File $errfile)</p>";
		break;
		
		case E_NOTICE:
			echo "<p><strong>[NuclearBB Notice]</strong> $errstr (Line $errline, File $errfile)</p>";
		break;
		
		case E_USER_NOTICE:
			//We only use E_USER_NOTICE for formatted messages, so we'll
			//assume that $template is an object and all is well
			if(defined('IN_ADMIN') && ! defined('ADMIN_HEADER_OUT'))
			{
				admin_header(lang('message'));
			}
			
			if(! defined('HEADER_OUT') && ! defined('IN_ADMIN'))
			{
				forum_header('message');
			}
			
			$template->load('message', 'message.html');
			
			$template->assign_vars(array(
				'MESSAGE'	=>	$errstr
			));
			
			$template->display('message');
			
			if(defined('IN_ADMIN'))
			{
				admin_footer();
			}
			else
			{
				forum_footer();
			}
		break;
	}
}

function forum_header($page_title = '')
{
	global $auth, $config, $root_path, $session, $template;
	
	$template->load('forum_header', 'header.html');
	
	$template->assign_vars(array(
		'BOARD_NAME'			=>	$config['board_name'],
		'SHOW_OFFLINE_MESSAGE'	=>	((! $config['board_online']) && ($auth->check('view_offline_board'))),
		'BOARD_TAGLINE'			=>	$config['board_tagline'],
		'CURRENT_TIME_TEXT'		=>	sprintf(lang('current_time'), format_date(time(), 'g:i A')),
		'META_REFRESH'			=>	(defined('META_REFRESH')) ? '<meta http-equiv="refresh" content="3;url='. META_REFRESH .'" />' : '',
		'PAGE_TITLE'			=>	lang($page_title, true),
		'SHOW_BOARD_LOGO'		=>	$config['show_board_logo'],
		'UNREAD_PMS'			=>	$session->user_data['unread_pms'],
		'UNREAD_PM_TEXT'		=>	($session->user_data['unread_pms'] == 1) ? lang('1_unread_pm') : sprintf(lang('x_unread_pms'), $session->user_data['unread_pms']),
		
		'A_ADMIN'				=>	$auth->check('admin'),
		'A_VIEW_MEMBERLIST'		=>	$auth->check('view_memberlist')
	));
	
	$template->display('forum_header');
	define('HEADER_OUT', true);
	
	if(((! $config['board_online']) && (! $auth->check('view_offline_board'))) && (! defined('IN_LOGIN')))
	{
		$error_msg = (empty($config['offline_message'])) ? 'forums_offline_default' : $config['offline_message'];
		trigger_error(newlines($error_msg));
	}
	
	if(file_exists("$root_path/install"))
	{
		$show_message = ($auth->check('admin')) ? 'forums_offline_install_dir' : 'forums_offline_default';
		
		trigger_error($show_message);
	}
}

function forum_footer()
{
	global $db, $start_time, $template;
	
	$template->load('forum_footer', 'footer.html');
	
	$end_time = explode(' ', microtime());
	$load_time = $end_time[0] + $end_time[1] - $start_time;
	
	$template->assign_vars(array(
		'DB_QUERIES'	=>	$db->num_queries,
		'LOAD_TIME'		=>	sprintf('%.3f', $load_time)
	));
	
	$template->display('forum_footer');
	
	exit;
}
?>