<?php
/*
* --------------------------------------------------------------------------
*                                    NuclearBB
*                              (c) 2007 NuclearBB
* --------------------------------------------------------------------------
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* --------------------------------------------------------------------------
*/

class dbal_core
{
	function build_query($type, $query_ary)
	{
		$keys = $values = array();
		$return_sql = '';
		
		if($type == 'INSERT')
		{
			foreach($query_ary as $k => $v)
			{
				$keys[] = $k;
				
				if(is_string($v))
				{
					$values[] = "'" . $this->escape($v) . "'";
				}
				else
				{
					$values[] = (is_int($v)) ? intval($v) : $v;
				}
			}
			
			$return_sql = '(' . implode(',', $keys) . ') VALUES('. implode(',', $values) .')';
		}
		
		if($type == 'UPDATE')
		{
			foreach($query_ary as $k => $v)
			{
				if(is_string($v))
				{
					$values[] = "$k = '" . $this->escape($v) . "'";
				}
				else
				{
					$values[] = (is_int($v)) ? "$k = " . intval($v) : "$k = " . $v;
				}
			}
			
			$return_sql = implode(',', $values);
		}
		
		return $return_sql;
	}
	
	function report()
	{
		echo('<hr />');
		echo '<div align="center"><strong>Total Queries: '. $this->num_queries .'</strong></div>';
		for($i = 0; $i < count($this->executed_queries); $i++)
		{
			echo('<div align="center">');
			echo('<hr />');
			echo('<h1>Query #'. ($i + 1) .'</h1>');
			echo('<textarea rows="5" cols="50">'. str_replace("\t", '', $this->executed_queries[$i]) .'</textarea>');
			echo('</div>');
		}
	}
}
?>