<?php
/*
* --------------------------------------------------------------------------
*                                    NuclearBB
*                              (c) 2007 NuclearBB
* --------------------------------------------------------------------------
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* --------------------------------------------------------------------------
*/

/*
IMPORTANT NOTE: These functions should ONLY do their specified action and their only output (if any) should be a trigger_error() message
If you need to collect data from the user beforehand, do it in another place (suggested mcp.php)
It should also be noted that these functions should just **do** what they say - we assume all appropriate auth checks have already been carried out
Basically, the use of $template and $auth is forbidden in this file!
*/

function delete_post($post_id)
{
	global $db;
	
	$sql = "SELECT t.*, p.*
			FROM topics t, posts p
			WHERE p.post_id = $post_id
			AND t.topic_id = p.topic_id";
	$result = $db->query($sql);
	$post_data = $db->fetch_assoc($result);
	
	$sql = "DELETE FROM posts
			WHERE post_id = $post_id";
	$db->query($sql);
	
	$sql = "SELECT *
			FROM posts
			WHERE topic_id = " . $post_data['topic_id'] . "
			ORDER BY time_posted DESC
			LIMIT 1";
	$result = $db->query($sql);
	$last_post_data = $db->fetch_assoc($result);
	
	$sql = "UPDATE topics
			SET last_post_id = ". $last_post_data['post_id'] .",
				last_post_time = ". $last_post_data['time_posted'] .",
				replies = replies - 1,
				replies_actual = replies_actual - 1
			WHERE topic_id = " . $post_data['topic_id'];
	$db->query($sql);
	
	$sql = "UPDATE users
			SET post_count = post_count - 1
			WHERE user_id = " . $post_data['post_author'];
	$db->query($sql);
	
	resync_forum($post_data['forum_id']);
}

function delete_topic($topic_id)
{
	global $db;
	
	$adjust_post_count = array();
	
	$sql = "SELECT *
			FROM topics
			WHERE topic_id = $topic_id";
	$result = $db->query($sql);
	$topic_data = $db->fetch_assoc($result);
	
	if($topic_data['topic_type'] == TOPIC_GLOBAL)
	{
		return;
	}
	
	$sql = "SELECT *
			FROM posts
			wHERE topic_id = $topic_id";
	$result = $db->query($sql);
	while($row = $db->fetch_assoc($result))
	{
		if(! array_key_exists($row['post_author'], $adjust_post_count))
		{
			$adjust_post_count[ $row['post_author'] ] = 1;
		}
		else
		{
			$adjust_post_count[ $row['post_author'] ]++;
		}
	}
	
	foreach($adjust_post_count as $user_id => $num_posts)
	{
		$sql = "UPDATE users
				SET post_count = post_count - $num_posts
				WHERE user_id = $user_id";
		$db->query($sql);
	}
	
	$sql = "SELECT *
			FROM forums
			WHERE forum_id = " . $topic_data['forum_id'];
	$result = $db->query($sql);
	$forum_data = $db->fetch_assoc($result);
	
	$sql = "DELETE FROM topics
			WHERE topic_id = $topic_id";
	$db->query($sql);
	
	$sql = "DELETE FROM posts
			WHERE topic_id = $topic_id";
	$db->query($sql);
	
	$sql = "DELETE FROM notify_topics
			WHERE topic_id = $topic_id";
	$db->query($sql);
	
	resync_forum($forum_data['forum_id']);
}

function move_topic($topic_id, $new_forum_id)
{
	global $db;
	
	$last_post_sql = '';
	
	$sql = "SELECT *
			FROM topics
			WHERE topic_id = $topic_id";
	$result = $db->query($sql);
	$topic_data = $db->fetch_assoc($result);
	
	if($topic_data['topic_type'] == TOPIC_GLOBAL)
	{
		return;
	}
	
	$sql = "SELECT *
			FROM forums
			WHERE forum_id = $new_forum_id";
	$result = $db->query($sql);
	$new_forum_data = $db->fetch_assoc($result);
	
	$sql = "UPDATE topics
			SET forum_id = $new_forum_id
			WHERE topic_id = $topic_id";
	$db->query($sql);
	
	resync_forum($topic_data['forum_id']);
	resync_forum($new_forum_id);
}

function approve_post($post_id)
{
	global $db;
	
	$sql = "SELECT p.*, t.*
			FROM posts p, topics t
			WHERE p.post_id = $post_id
			AND t.topic_id = p.topic_id";
	$result = $db->query($sql);
	$post_data = $db->fetch_assoc($result);
	
	if($post_data['post_approved'])
	{
		return;
	}
	
	$sql = "UPDATE posts
			SET post_approved = 1,
				time_posted = ". time() ."
			WHERE post_id = $post_id";
	$db->query($sql);
	
	$sql = "UPDATE topics
			SET replies = replies + 1,
				unapproved_posts = unapproved_posts - 1,
				last_post_time = ". time() ."
			WHERE topic_id = " . $post_data['topic_id'];
	$db->query($sql);
	
	if($post_data['topic_type'] != TOPIC_GLOBAL)
	{
		$sql = "SELECT *
				FROM forums
				WHERE forum_id = " . $post_data['forum_id'];
		$result = $db->query($sql);
		$forum_data = $db->fetch_assoc($result);
		
		if($forum_data['forum_flags'] & FLAG_INCREMENT_POST_COUNT)
		{
			$sql = "UPDATE users
					SET post_count = post_count + 1
					WHERE user_id = " . $post_data['topic_author'];
			$db->query($sql);
		}
		
		$sql = "UPDATE forums
				SET replies = replies + 1,
					unapproved_posts = unapproved_posts - 1
				WHERE forum_id = " . $forum_data['forum_id'];
		$db->query($sql);
	}
	
	resync_forum($forum_data['forum_id']);
}

function approve_topic($topic_id)
{
	global $db;
	
	$sql = "SELECT *
			FROM topics
			WHERE topic_id = $topic_id";
	$result = $db->query($sql);
	$topic_data = $db->fetch_assoc($result);
	
	if($topic_data['topic_approved'])
	{
		return;
	}
	
	if($topic_data['topic_type'] != TOPIC_GLOBAL)
	{
		$sql = "SELECT *
				FROM forums
				WHERE forum_id = " . $topic_data['forum_id'];
		$result = $db->query($sql);
		$forum_data = $db->fetch_assoc($result);
		
		if($forum_data['forum_flags'] & FLAG_INCREMENT_POST_COUNT)
		{
			$sql = "UPDATE users
					SET post_count = post_count + 1
					WHERE user_id = " . $topic_data['topic_author'];
			$db->query($sql);
		}
		
		$sql = "UPDATE forums
				SET	topics = topics + 1,
					unapproved_topics = unapproved_topics - 1
				WHERE forum_id = " . $topic_data['forum_id'];
		$db->query($sql);
	}
	
	$sql = "UPDATE topics
			SET topic_approved = 1,
				last_post_time = ". time() ."
			WHERE topic_id = $topic_id";
	$db->query($sql);
	
	$sql = "UPDATE posts
			SET time_posted = ". time() ."
			WHERE post_id = " . $topic_data['first_post_id'];
	$db->query($sql);
	
	resync_forum($topic_data['forum_id']);
}

function alter_topic_type($topic_id, $new_type, $forum_id = 0)
{
	global $db;
	
	$update_forum = ($new_type == TOPIC_GLOBAL) ? 0 : $forum_id;
	
	$sql = "UPDATE topics
			SET topic_type = $new_type,
				forum_id = $update_forum
			WHERE topic_id = $topic_id";
	$db->query($sql);
}

function unlock_topic($topic_id)
{
	global $db;
	
	$sql = "UPDATE topics
			SET topic_locked = 0
			WHERE topic_id = $topic_id";
	$db->query($sql);
}

function lock_topic($topic_id)
{
	global $db;
	
	$sql = "UPDATE topics
			SET topic_locked = 1
			WHERE topic_id = $topic_id";
	$db->query($sql);
}

function hide_post($post_id)
{
	global $db;
	
	$sql = "SELECT p.*, t.*
			FROM posts p, topics t
			WHERE p.post_id = $post_id
			AND t.topic_id = p.topic_id";
	$result = $db->query($sql);
	$post_data = $db->fetch_assoc($result);
	
	if($post_data['post_hidden'])
	{
		return;
	}
	
	$sql = "UPDATE posts
			SET post_hidden = 1
			WHERE post_id = $post_id";
	$db->query($sql);
	
	$sql = "UPDATE topics
			SET replies = replies - 1
			WHERE topic_id = " . $post_data['topic_id'];
	$db->query($sql);
	
	if($post_data['topic_type'] != TOPIC_GLOBAL)
	{
		$sql = "SELECT *
				FROM forums
				WHERE forum_id = " . $post_data['forum_id'];
		$result = $db->query($sql);
		$forum_data = $db->fetch_assoc($result);
		
		if($forum_data['forum_flags'] & FLAG_INCREMENT_POST_COUNT)
		{
			$sql = "UPDATE users
					SET post_count = post_count - 1
					WHERE user_id = " . $post_data['post_author'];
			$db->query($sql);
		}
		
		$sql = "UPDATE forums
				SET replies = replies - 1
				WHERE forum_id = " . $forum_data['forum_id'];
		$db->query($sql);
	}
}

function hide_topic($topic_id)
{
	global $db;
	
	$adjust_post_count = $posts = array();
	
	$sql = "SELECT *
			FROM topics
			WHERE topic_id = $topic_id";
	$result = $db->query($sql);
	$topic_data = $db->fetch_assoc($result);
	
	if($topic_data['topic_hidden'])
	{
		return;
	}
	
	$sql = "SELECT *
			FROM posts
			WHERE topic_id = $topic_id";
	$result = $db->query($sql);
	while($row = $db->fetch_assoc($result))
	{
		$posts[] = $row;
	}
	
	for($i = 0; $i < count($posts); $i++)
	{
		if(array_key_exists($posts[$i]['post_author'], $adjust_post_count))
		{
			$adjust_post_count[ $posts[$i]['post_author'] ]++;
		}
		else
		{
			$adjust_post_count[ $posts[$i]['post_author'] ] = 1;
		}
	}
	
	foreach($adjust_post_count as $user_id => $adjust_by)
	{
		$sql = "UPDATE users
				SET post_count = post_count - $adjust_by
				WHERE user_id = $user_id";
		$db->query($sql);
	}
	
	$sql = "UPDATE topics
			SET topic_hidden = 1,
				topic_type = ". TOPIC_NORMAL ."
			WHERE topic_id = $topic_id";
	$db->query($sql);
}
?>