<?php
/*
* --------------------------------------------------------------------------
*                                    NuclearBB
*                              (c) 2007 NuclearBB
* --------------------------------------------------------------------------
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* --------------------------------------------------------------------------
*/
class session
{
	var $cookie_data = array();
	var $user_data = array();
	var $logged_in = false;
	
	function begin()
	{
		global $config, $db, $template;
		
		$group_memberships = array();
				
		if(isset($_COOKIE[ $config['cookie_name'] . '_data' ]))
		{
			$this->cookie_data = unserialize($_COOKIE[ $config['cookie_name'] . '_data' ]);
		}
		else
		{
			$this->cookie_data = array(
				'USER_ID'		=>	GUEST_USER,
				'SESSION_ID'	=>	''
			);
		}
		
		if($this->cookie_data['USER_ID'] != GUEST_USER)
		{
			//If the user has a valid session id which is mapped to the correct user id
			//in the cookie we trust they are who they say they are and deliver their user data
			$sql = "SELECT g.group_colour, s.*, u.*
					FROM groups g, sessions s, users u
					WHERE s.user_id = '". intval($this->cookie_data['USER_ID']) ."'
					AND s.user_id = u.user_id
					AND g.group_id = u.primary_group";
			$result = $db->query($sql);
			if($db->num_rows($result) > 0)
			{
				$this->user_data = $db->fetch_assoc($result);
				$this->logged_in = true;
				
				//Every minute, give the user a new sid
				if(time() - $this->user_data['session_time'] > 60)
				{
					$new_session_data = $this->update_session($this->user_data['sid']);
					$new_cookie_user_data = array(
						'USER_ID'		=>	$this->user_data['user_id'],
						'SESSION_ID'	=>	$new_session_data['SID']
					);
					//31536000 seconds = 365 days
					$this->set_cookie('data', serialize($new_cookie_user_data), (time() + 31536000));
				}
			}
			else
			{
				$sql = "SELECT *
						FROM users
						WHERE user_id = ". GUEST_USER;
				$result = $db->query($sql);
				$this->user_data = $db->fetch_assoc($result);
			}
		}
		else
		{
			$sql = "SELECT *
					FROM users
					WHERE user_id = ". GUEST_USER;
			$result = $db->query($sql);
			$this->user_data = $db->fetch_assoc($result);
		}
		
		$sql = "SELECT g.*, m.*
				FROM groups g, group_members m
				WHERE g.group_id = m.group_id
				AND m.membership_type != ". MEMBERSHIP_PENDING ."
				AND m.user_id = ". $this->user_data['user_id'];
		$result = $db->query($sql);
		while($row = $db->fetch_assoc($result))
		{
			$group_memberships[] = $row;
		}
		
		$this->user_data['group_memberships'] = $group_memberships;
		
		$template->assign_vars(array(
			'USER_ID'			=>	$this->user_data['user_id'],
			'USER_LOGGED_IN'	=>	$this->logged_in,
			'USERNAME'			=>	$this->user_data['username']
		));
		
		$this->ban_check();
	}
	
	function create_session($user_id)
	{
		global $db;
		
		$session_id = $this->generate_sid();
		$sql = "INSERT INTO sessions (sid, user_id, session_time)
				VALUES('$session_id', $user_id, ". time() .")";
		$db->query($sql);
		
		$sql = "UPDATE users
				SET last_visit = ". time() ."
				WHERE user_id = $user_id";
		$db->query($sql);
		
		return array('SID' => $session_id);
	}
	
	function update_session($sid)
	{
		global $db;
		
		$session_id = $this->generate_sid();
		
		$pathinfo = pathinfo($_SERVER['REQUEST_URI']);
		$current_page = $pathinfo['basename'];
		
		$sql = "UPDATE sessions
				SET sid = '$session_id',
					session_time = ". time() .",
					current_page = '$current_page'
				WHERE sid = '$sid'";
		$db->query($sql);
		
		if(time() - $this->user_data['last_visit'] > 3600)
		{
			$sql = "UPDATE users
					SET last_visit = ". time() ."
					WHERE user_id = ". $this->user_data['user_id'];
			$db->query($sql);
		}
		
		return array('SID' => $session_id);
	}
	
	function generate_sid()
	{
		return md5(uniqid(rand(), true));
	}
	
	function ban_check()
	{
		global $cache, $db;
		
		$bans = $cache->get_bans();
		
		for($i = 0; $i < count($bans); $i++)
		{
			$banned = false;
			
			if(($bans[$i]['ban_expires'] != 0) && ($bans[$i]['ban_expires'] < time()))
			{
				$sql = "DELETE FROM bans
						WHERE ban_id = " . $bans[$i]['ban_id'];
				$db->query($sql);
				
				$cache->delete('bans');
			}
			
			switch($bans[$i]['ban_type'])
			{
				case BAN_USER:
					if($this->user_data['user_id'] == $bans[$i]['ban_info'])
					{
						$banned = true;
					}
				break;
				
				case BAN_EMAIL:
					if($this->user_data['email'] == $bans[$i]['ban_info'])
					{
						$banned = true;
					}
				break;
				
				case BAN_IP:
					if($_SERVER['REMOTE_ADDR'] == $bans[$i]['ban_info'])
					{
						$banned = true;
					}
				break;
			}
			
			if($banned)
			{
				if($bans[$i]['ban_reason'])
				{
					trigger_error(parse_bbcode(newlines($bans[$i]['ban_reason'])));
				}
				else
				{
					trigger_error('you_been_banned');
				}
			}
		}
	}
	
	//Function set_cookie borrowed from phpBB3
	function set_cookie($name, $cookiedata, $cookietime)
	{
		global $config;

		if($config['cookie_domain'] == 'localhost' || $config['cookie_domain'] == '127.0.0.1')
		{
			setcookie($config['cookie_name'] . '_' . $name, $cookiedata, $cookietime, $config['cookie_path']);
		}
		else
		{
			setcookie($config['cookie_name'] . '_' . $name, $cookiedata, $cookietime, $config['cookie_path'], $config['cookie_domain'], $config['cookie_secure']);
		}
	}
}
?>