<?php
/*
* --------------------------------------------------------------------------
*                                    NuclearBB
*                              (c) 2007 NuclearBB
* --------------------------------------------------------------------------
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* --------------------------------------------------------------------------
*/

if(! defined('IN_NBB'))
{
	exit;
}

error_reporting(E_ALL);
$start_time = explode(' ', microtime());
$start_time = $start_time[1] + $start_time[0];

Header("Cache-Control: no-cache, must-revalidate"); //HTTP/1.1
Header("Expires: Mon, 26 Jul 1997 05:00:00 GMT"); //Date in the past

if((filesize("$root_path/inc/config.php")) == 0)
{
	Header("Location: $root_path/install/index.php");
}

function stripslashes_recursive($array)
{
	$return_array = array();
	
	foreach($array as $k => $v)
	{
		if(is_array($v))
		{
			$return_array[$k] = stripslashes_recursive($v);
		}
		else
		{
			$return_array[$k] = stripslashes($v);
		}
	}
	
	return $return_array;
}

if(get_magic_quotes_gpc())
{
	$_GET = stripslashes_recursive($_GET);
	$_POST = stripslashes_recursive($_POST);
	$_COOKIE = stripslashes_recursive($_COOKIE);
}

require("$root_path/inc/config.php");

require("$root_path/inc/php_compat/_include_me.php");

require("$root_path/inc/functions_dbal.php");
require("$root_path/inc/dbal/$db_engine.php");

require("$root_path/inc/constants.php");
require("$root_path/inc/functions.php");
require("$root_path/inc/functions_auth.php");
require("$root_path/inc/functions_cache.php");
require("$root_path/inc/functions_session.php");
require("$root_path/inc/functions_template.php");

set_error_handler('bb_error_handler');

$lang = array();
add_lang('common');

$db = new dbal;
$db->connect($db_conn['HOST'], $db_conn['PORT'], $db_conn['USER'], $db_conn['PASS'], $db_conn['DB_NAME'], $db_conn['PCONNECT']);
unset($db_conn);

$auth = new auth;
$cache = new cache;
$session = new session;

$config = $cache->get_config();
$styles = $cache->get_styles();

//Temporary hack for low graphics mode
if(isset($_GET['low_gfx']))
{
	$template = new template('NuclearBB_print');
	include($root_path . '/styles/NuclearBB_print/images.php');
}
else
{
	$template = new template($styles[ $config['default_style'] ]['style_folder']);
	include($root_path . '/styles/' . $styles[ $config['default_style'] ]['style_folder'] . '/images.php');
	
	$current_style_folder = $styles[ $config['default_style'] ]['style_folder'];
}

$template->force_recompile = true; //=========================================================================== Remove me at release time
?>