<?php
/*
* --------------------------------------------------------------------------
*                                    NuclearBB
*                              (c) 2007 NuclearBB
* --------------------------------------------------------------------------
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* --------------------------------------------------------------------------
*/

if(! defined('IN_NBB'))
{
	exit;
}

define('PAGE_TITLE', 'sentbox');
$pm = array();
$mode = (isset($_GET['mode'])) ? htmlspecialchars($_GET['mode']) : '';
$pm_id = (isset($_GET['id'])) ? intval($_GET['id']) : 0;

switch($mode)
{
	case 'read':
		$template->load('body', 'ucp_read_pm.html');
		
		$sql = "SELECT pm.*, u.user_id, u.username
				FROM private_messages pm, users u
				WHERE pm.pm_id = $pm_id
				AND pm.from_user = ". $session->user_data['user_id'] ."
				AND pm.to_user = u.user_id
				ORDER BY pm.time_sent DESC";
		$result = $db->query($sql);
		$pm = $db->fetch_assoc($result);
		
		if(empty($pm))
		{
			trigger_error('pm_no_exist');
		}
		
		if(! $pm['pm_read'])
		{
			$sql = "UPDATE private_messages
					SET pm_read = 1
					WHERE pm_id = $pm_id";
			$db->query($sql);
		}
		
		$template->assign_vars(array(
			'FROM_USER'		=>	$pm['username'],
			'MESSAGE'		=>	newlines(parse_bbcode($pm['message'])),
			'MODE'			=>	'sentbox',
			'SUBJECT'		=>	$pm['subject'],
			'TIME_SENT'		=>	format_date($pm['time_sent']),
			
			'U_PROFILE'		=>	'profile.php?u=' . $pm['user_id'],
			'U_REPLY'		=>	'ucp.php?m=compose_pm&to=' . $pm['from_user'],
			'U_VIEW'		=>	'ucp.php?m=read_pm&id=' . $pm['pm_id']
		));
		
		$template->display('body');
	break;
	
	default:
		$template->load('body', 'ucp_inbox.html');
		
		$sql = "SELECT pm.*, u.user_id, u.username
				FROM private_messages pm, users u
				WHERE pm.from_user = ". $session->user_data['user_id'] ."
				AND pm.to_user = u.user_id
				ORDER BY pm.time_sent DESC";
		$result = $db->query($sql);
		while($row = $db->fetch_assoc($result))
		{
			$pm[] = $row;
		}
		
		for($i = 0; $i < count($pm); $i++)
		{
			$template->assign_block_vars('pm', array(
				'FROM_USER'		=>	$pm[$i]['username'],
				'READ'			=>	$pm[$i]['pm_read'],
				'SUBJECT'		=>	$pm[$i]['subject'],
				'TIME_SENT'		=>	format_date($pm[$i]['time_sent']),
				
				'U_PROFILE'		=>	'profile.php?u=' . $pm[$i]['user_id'],
				'U_VIEW'		=>	"ucp.php?m=$current_module&amp;mode=read&amp;id=" . $pm[$i]['pm_id']
			));
			
		}
		
		$template->assign_vars(array(
			'MODE'		=>	'sentbox',
			'NUM_PMS'	=>	count($pm)
		));
		
		$template->display('body');
	break;
}
?>