<?php
/*
* --------------------------------------------------------------------------
*                                    NuclearBB
*                              (c) 2007 NuclearBB
* --------------------------------------------------------------------------
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* --------------------------------------------------------------------------
*/

define('IN_NBB', true);
$root_path = '.';
require("$root_path/inc/global.php");
$session->begin();
$auth->setup();

$mark = (isset($_REQUEST['mark'])) ? htmlspecialchars($_REQUEST['mark']) : '';

if($mark == 'forums')
{
	$read_forums = (isset($_COOKIE[ $config['cookie_name'] . '_read_forums' ])) ? unserialize($_COOKIE[ $config['cookie_name'] . '_read_forums' ]) : array();
	$read_topics = (isset($_COOKIE[ $config['cookie_name'] . '_read_topics' ])) ? unserialize($_COOKIE[ $config['cookie_name'] . '_read_topics' ]) : array();
	
	$sql = "SELECT *
			FROM forums";
	$result = $db->query($sql);
	while($row = $db->fetch_assoc($result))
	{
		if(! $auth->forum_check('view_forum', $row['forum_id']))
		{
			continue;
		}
		
		$read_forums[ $row['forum_id'] ] = time();
		$read_topics[ $row['forum_id'] ] = array();
		
		//31536000 seconds = 365 days
		$session->set_cookie('read_forums', serialize($read_forums), (time() + 31536000));
		$session->set_cookie('read_topics', serialize($read_topics), (time() + 31536000));
	}
	
	Header('Location: index.php');
}

forum_header('forum_index');

$template->load('body', 'index.html');

$groups_in_legend = $users_online = array();
$group_legend = $online_users_list = '';

if(! get_forum_list())
{
	trigger_error('no_forums_exist');
}

$session_time = time() - $config['online_users_time'];
$sql = "SELECT u.primary_group, u.user_id, u.username
		FROM sessions s, users u
		WHERE s.session_time > $session_time
		AND s.user_id = u.user_id
		ORDER BY u.username ASC";
$result = $db->query($sql);
while($row = $db->fetch_assoc($result))
{
	$users_online[] = $row;
}

$num_online_users = count($users_online);
$groups = $cache->get_groups();

for($i = 0; $i < count($users_online); $i++)
{
	$group_colour = $groups[ $users_online[$i]['primary_group'] ]['group_colour'];
	$username = (! empty($group_colour)) ? '<span style="color: #'. $group_colour .'; text-decoration: underline; font-weight: bold;">' . $users_online[$i]['username'] . '</span>' : $users_online[$i]['username'];
	$user_text = '<a href="profile.php?u='. $users_online[$i]['user_id'] .'">'. $username .'</a>';
	
	$online_users_list .= (($i + 1) == $num_online_users) ? $user_text : $user_text . ', ';
}

foreach($groups as $group_id => $group_data)
{
	if($group_data['show_on_legend'])
	{
		$groups_in_legend[] = $group_data;
	}
}

for($i = 0; $i < count($groups_in_legend); $i++)
{
	$group_name = (! empty($groups_in_legend[$i]['group_colour'])) ? '<span style="color: #'. $groups_in_legend[$i]['group_colour'] .'; text-decoration: underline;">' . $groups_in_legend[$i]['group_name'] . '</span>' : $groups_in_legend[$i]['group_name'];
	$group_text = '<a href="groups.php?mode=view&amp;g='. $groups_in_legend[$i]['group_id'] .'">'. $group_name .'</a>';
	
	$group_legend .= (($i + 1) == count($groups_in_legend)) ? $group_text : $group_text . ', ';
}

$template->assign_vars(array(
	'FORUM_HAS_USERS_TEXT'		=>	($config['total_members'] == 1) ? lang('forum_has_user') : sprintf(lang('forum_has_users'), $config['total_members']),
	'GROUP_LEGEND'				=>	$group_legend,
	'NEWEST_REGISTERED_USER'	=>	sprintf(lang('newest_registered_user'), $config['last_reg_user_id'], $config['last_reg_username']),
	'ONLINE_USERS_LIST'			=>	$online_users_list,
	'TOTAL_USERS'				=>	$config['total_members'],
	'TOTAL_USERS_ONLINE'		=>	$num_online_users,
	'USERS_ONLINE_TEXT'			=>	($num_online_users == 1) ? lang('1_user_online') : sprintf(lang('x_users_online'), $num_online_users),
	
	'U_MARK_ALL_FORUMS_READ'	=>	'index.php?mark=forums'
));

$template->display('body');

forum_footer();
?>