CREATE TABLE `bans` (
  `ban_id` int(11) NOT NULL auto_increment,
  `ban_type` tinyint(1) NOT NULL default '0',
  `ban_info` varchar(255) NOT NULL default '',
  `ban_reason` text NOT NULL,
  `ban_expires` int(11) NOT NULL default '0',
  PRIMARY KEY  (`ban_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `captcha` (
  `captcha_id` varchar(32) NOT NULL default '',
  `code` varchar(255) NOT NULL default '',
  `captcha_time` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `config` (
  `config_name` varchar(255) NOT NULL default '',
  `config_value` text NOT NULL,
  `cache_value` tinyint(1) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `forums` (
  `forum_id` int(11) NOT NULL auto_increment,
  `forum_type` tinyint(1) NOT NULL default '0',
  `forum_name` varchar(255) NOT NULL default '',
  `forum_description` text NOT NULL,
  `forum_rules` text NOT NULL,
  `forum_flags` int(11) NOT NULL default '0',
  `forum_parent` int(11) NOT NULL default '0',
  `forum_moderators` text NOT NULL,
  `url_redirect` text NOT NULL,
  `left_id` int(11) NOT NULL default '0',
  `right_id` int(11) NOT NULL default '0',
  `topics` int(11) NOT NULL default '0',
  `topics_actual` int(11) NOT NULL default '0',
  `replies` int(11) NOT NULL default '0',
  `replies_actual` int(11) NOT NULL default '0',
  `unapproved_topics` int(11) NOT NULL default '0',
  `unapproved_posts` int(11) NOT NULL default '0',
  `reported_posts` int(11) NOT NULL default '0',
  `last_post_time` int(11) NOT NULL default '0',
  `last_post_subject` varchar(255) NOT NULL default '',
  `last_post_id` int(11) NOT NULL default '0',
  `last_post_topic` int(11) NOT NULL default '0',
  `last_post_username` varchar(255) NOT NULL default '',
  `last_post_user_colour` varchar(6) NOT NULL default '',
  `last_post_user_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`forum_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `forum_perms` (
  `perm_id` int(11) NOT NULL auto_increment,
  `forum_id` int(11) NOT NULL default '0',
  `group_id` int(11) NOT NULL default '0',
  `perm_name_id` int(11) NOT NULL default '0',
  `perm_value` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`perm_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 PACK_KEYS=0;
CREATE TABLE `forum_perm_groups` (
  `group_id` int(11) NOT NULL auto_increment,
  `group_name` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 PACK_KEYS=0;
CREATE TABLE `forum_perm_group_values` (
  `group_id` int(11) NOT NULL default '0',
  `perm_name_id` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `forum_perm_values` (
  `perm_name_id` int(11) NOT NULL auto_increment,
  `perm_name` varchar(30) NOT NULL default '',
  PRIMARY KEY  (`perm_name_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `groups` (
  `group_id` int(11) NOT NULL auto_increment,
  `group_name` varchar(255) NOT NULL default '',
  `show_on_legend` tinyint(1) NOT NULL default '0',
  `group_type` tinyint(1) NOT NULL default '0',
  `group_description` text NOT NULL,
  `group_colour` varchar(6) NOT NULL default '',
  PRIMARY KEY  (`group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `group_members` (
  `group_id` int(11) NOT NULL default '0',
  `user_id` int(11) NOT NULL default '0',
  `membership_type` tinyint(1) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `infractions` (
  `infraction_id` int(11) NOT NULL auto_increment,
  `warning_level` tinyint(4) NOT NULL default '0',
  `infraction_name` varchar(255) NOT NULL default '',
  `infraction_affects` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`infraction_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `infraction_effectors` (
  `effector_id` int(11) NOT NULL auto_increment,
  `affecting` int(11) NOT NULL default '0',
  PRIMARY KEY  (`effector_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `logs` (
  `log_id` int(11) NOT NULL auto_increment,
  `log_type` tinyint(1) NOT NULL default '0',
  `log_text` varchar(255) NOT NULL default '',
  `log_extra` varchar(255) NOT NULL default '',
  `log_user` int(11) NOT NULL default '0',
  `log_time` int(11) NOT NULL default '0',
  PRIMARY KEY  (`log_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `mail_queue` (
  `mail_id` int(11) NOT NULL auto_increment,
  `email` varchar(255) NOT NULL default '',
  `subject` varchar(255) NOT NULL default '',
  `message` text NOT NULL,
  PRIMARY KEY  (`mail_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `modules` (
  `module_id` int(11) NOT NULL auto_increment,
  `module_type` varchar(10) NOT NULL default '',
  `module_name` varchar(255) NOT NULL default '',
  `module_file` varchar(255) NOT NULL default '',
  `parent_id` int(11) NOT NULL default '0',
  `left_id` int(11) NOT NULL default '0',
  `right_id` int(11) NOT NULL default '0',
  `module_enabled` tinyint(1) NOT NULL default '0',
  `show_menu` tinyint(1) NOT NULL default '0',
  `view_perm` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`module_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `notify_topics` (
  `topic_id` int(11) NOT NULL default '0',
  `user_id` int(11) NOT NULL default '0',
  `send_more` tinyint(1) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `perms` (
  `perm_id` int(11) NOT NULL auto_increment,
  `group_id` int(11) NOT NULL default '0',
  `perm_name_id` int(11) NOT NULL default '0',
  `perm_value` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`perm_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 PACK_KEYS=0;
CREATE TABLE `perm_values` (
  `perm_name_id` int(11) NOT NULL auto_increment,
  `perm_name` varchar(30) NOT NULL default '',
  PRIMARY KEY  (`perm_name_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `polls` (
  `poll_id` int(11) NOT NULL auto_increment,
  `poll_title` varchar(255) NOT NULL default '',
  `topic_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`poll_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `poll_options` (
  `option_id` int(11) NOT NULL auto_increment,
  `poll_id` int(11) NOT NULL default '0',
  `option_text` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`option_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `poll_votes` (
  `poll_id` int(11) NOT NULL default '0',
  `vote_option_id` int(11) NOT NULL default '0',
  `user_id` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `posts` (
  `post_id` int(11) NOT NULL auto_increment,
  `topic_id` int(11) NOT NULL default '0',
  `post_subject` varchar(255) NOT NULL default '',
  `post_text` text NOT NULL,
  `post_md5` varchar(32) NOT NULL default '',
  `post_approved` tinyint(1) NOT NULL default '0',
  `post_hidden` tinyint(1) NOT NULL default '0',
  `post_reported` tinyint(1) NOT NULL default '0',
  `time_posted` int(11) NOT NULL default '0',
  `post_author` int(11) NOT NULL default '0',
  `attach_signature` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`post_id`),
  FULLTEXT KEY `post_text` (`post_text`),
  FULLTEXT KEY `post_subject` (`post_subject`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `post_reports` (
  `report_id` int(11) NOT NULL auto_increment,
  `post_id` int(11) NOT NULL default '0',
  `reported_by` int(11) NOT NULL default '0',
  `report_time` int(11) NOT NULL default '0',
  `report_text` text NOT NULL,
  PRIMARY KEY  (`report_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `private_messages` (
  `pm_id` int(11) NOT NULL auto_increment,
  `from_user` int(11) NOT NULL default '0',
  `to_user` int(11) NOT NULL default '0',
  `time_sent` int(11) NOT NULL default '0',
  `pm_read` tinyint(1) NOT NULL default '0',
  `subject` varchar(255) NOT NULL default '',
  `message` text NOT NULL,
  PRIMARY KEY  (`pm_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `ranks` (
  `rank_id` int(11) NOT NULL auto_increment,
  `rank_title` varchar(255) NOT NULL default '',
  `rank_image` varchar(255) NOT NULL default '',
  `rank_special` tinyint(1) NOT NULL default '0',
  `rank_posts` int(11) NOT NULL default '0',
  PRIMARY KEY  (`rank_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `sessions` (
  `sid` varchar(32) NOT NULL default '',
  `user_id` int(11) NOT NULL default '0',
  `session_time` int(11) NOT NULL default '0',
  `current_page` varchar(255) NOT NULL default '',
  `admin_reauthed` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`sid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `smilies` (
  `smiley_id` int(11) NOT NULL auto_increment,
  `smiley_set` int(11) NOT NULL default '0',
  `smiley_text` varchar(10) NOT NULL default '',
  `smiley_image` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`smiley_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `styles` (
  `style_id` int(11) NOT NULL auto_increment,
  `style_name` varchar(255) NOT NULL default '',
  `style_folder` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`style_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `tasks` (
  `task_id` int(11) NOT NULL auto_increment,
  `task_name` varchar(255) NOT NULL default '',
  `task_description` text NOT NULL,
  `task_file` varchar(255) NOT NULL default '',
  `minute` tinyint(4) NOT NULL default '0',
  `hour` tinyint(4) NOT NULL default '0',
  `day` tinyint(4) NOT NULL default '0',
  `next_run` int(11) NOT NULL default '0',
  PRIMARY KEY  (`task_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `topics` (
  `topic_id` int(11) NOT NULL auto_increment,
  `forum_id` int(11) NOT NULL default '0',
  `topic_type` tinyint(1) NOT NULL default '0',
  `topic_locked` tinyint(1) NOT NULL default '0',
  `topic_approved` tinyint(1) NOT NULL default '0',
  `topic_hidden` tinyint(1) NOT NULL default '0',
  `reported_posts` int(11) NOT NULL default '0',
  `topic_title` varchar(255) NOT NULL default '',
  `last_post_time` int(11) NOT NULL default '0',
  `topic_author` int(11) NOT NULL default '0',
  `views` int(11) NOT NULL default '0',
  `replies` int(11) NOT NULL default '0',
  `replies_actual` int(11) NOT NULL default '0',
  `unapproved_posts` int(11) NOT NULL default '0',
  `first_post_id` int(11) NOT NULL default '0',
  `last_post_id` int(11) NOT NULL default '0',
  `moved_topic_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`topic_id`),
  FULLTEXT KEY `topic_title` (`topic_title`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `users` (
  `user_id` int(11) NOT NULL auto_increment,
  `username` varchar(50) NOT NULL default '',
  `password` varchar(32) NOT NULL default '',
  `email` varchar(255) NOT NULL default '',
  `user_active` tinyint(1) NOT NULL default '0',
  `activation_key` varchar(10) NOT NULL default '',
  `primary_group` int(11) NOT NULL default '0',
  `avatar_type` tinyint(1) NOT NULL default '0',
  `avatar_file` text NOT NULL,
  `user_notes` text NOT NULL,
  `user_signature` text NOT NULL,
  `last_visit` int(11) NOT NULL default '0',
  `post_count` int(11) NOT NULL default '0',
  `user_rank` int(11) NOT NULL default '0',
  `date_format` varchar(20) NOT NULL default '',
  `time_offset` int(11) NOT NULL default '0',
  `joined_date` int(11) NOT NULL default '0',
  `website` varchar(255) NOT NULL default '',
  `msn` varchar(255) NOT NULL default '',
  `aol` varchar(255) NOT NULL default '',
  `icq` varchar(255) NOT NULL default '',
  `yahoo` varchar(255) NOT NULL default '',
  `location` varchar(255) NOT NULL default '',
  `user_options` int(11) NOT NULL default '0',
  `unread_pms` int(11) NOT NULL default '0',
  `user_warnings` tinyint(4) NOT NULL default '0',
  `bad_login_attempts` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `warnings` (
  `warning_id` int(11) NOT NULL auto_increment,
  `warn_user` int(11) NOT NULL default '0',
  `warning_type` tinyint(1) NOT NULL default '0',
  `warn_reason` text NOT NULL,
  PRIMARY KEY  (`warning_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `word_censors` (
  `word_id` int(11) NOT NULL auto_increment,
  `bad_word` varchar(255) NOT NULL default '',
  `replacement` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`word_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;