function increase_textarea_size(textarea_id)
{
	the_textarea = getbyid(textarea_id);
	
	height = parseInt(the_textarea.style.height);
	
	new_height = height + 50;
	
	the_textarea.style.height = new_height + 'px';
}

function decrease_textarea_size(textarea_id)
{
	the_textarea = getbyid(textarea_id);
	
	height = parseInt(the_textarea.style.height);
	
	new_height = height - 50;
	
	if(new_height < 200)
	{
		return;
	}
	
	the_textarea.style.height = new_height + 'px';
}

function check_username_not_taken(username, loading_icon_div_name)
{
	if(username.length > 0)
	{
		ajax = new Ajax;
		ajax.mode = 'check_username_not_taken';
		ajax.loading_icon_div = loading_icon_div_name;
		ajax.callback_function = 'handle_username_taken';
		
		ajax.add_post_data('username', username);
		
		ajax.do_post_request();
	}
	else
	{
		handle_username_taken(1);
	}
}

function get_post_for_ajax_edit(the_post_id)
{
	post_id = the_post_id;
	
	ajax = new Ajax;
	ajax.mode = 'get_post';
	ajax.callback_function = 'post_to_textarea';
	
	ajax.add_post_data('post_id', post_id);
	
	ajax.do_post_request();
}

function post_to_textarea(post_text)
{
	div_data = getbyid('post-' + post_id);
	original_post = div_data.innerHTML;
	
	div_data.innerHTML = '<textarea name="new_post" id="new_post" rows="20" cols="100" style="width: 99%; height: 300px">'+ post_text +'</textarea><br /><input type="button" value="'+ l_update +'" id="update_button" onClick="ajax_update_post('+ post_id +');" /><input type="button" value="'+ l_cancel +'" id="cancel_button" onClick="cancel_ajax_edit_post('+ post_id +');" />';
	
	textarea_data = getbyid('new_post');
	textarea_data.focus();
}

function ajax_update_post(post_id)
{
	textarea_data = getbyid('new_post');
	
	if(textarea_data.value.length != 0)
	{
		ajax = new Ajax;
		ajax.mode = 'update_post';
		ajax.callback_function = 'textarea_to_post';
		
		ajax.add_post_data('post_id', post_id);
		ajax.add_post_data('post_text', encodeURIComponent(textarea_data.value));
		
		ajax.do_post_request();
	}
}

function cancel_ajax_edit_post(post_id)
{
	div_data.innerHTML = original_post;
}

function textarea_to_post(post_text)
{
	div_data = getbyid('post-' + post_id);
	div_data.innerHTML = post_text;
}

function get_post_subject_for_ajax_edit(the_post_id)
{
	post_id = the_post_id;
	
	ajax = new Ajax;
	ajax.mode = 'get_post_subject';
	ajax.callback_function = 'post_subject_to_textbox';
	
	ajax.add_post_data('post_id', post_id);
	
	ajax.do_post_request();
}

function post_subject_to_textbox(the_post_subject)
{
	post_subject = the_post_subject;
	
	span_data = getbyid('post_subject-span-' + post_id);
	
	span_data.innerHTML = '<input type="text" name="new_subject" id="new_post_subject" value="'+ post_subject +'" size="50" onKeyPress="handle_post_subject_change_keypress(event, '+ post_id +', this.value);" onBlur="handle_post_subject_change_blur('+ post_id +', this.value);" />';
	
	getbyid('new_post_subject').focus();
}

function handle_post_subject_change_keypress(e, post_id, new_title)
{
	e = e ? e : window.event;
	
	textbox_data = getbyid('new_post_subject');
	
	switch (e.keyCode)
	{
		//Enter
		case 13:
			if(new_title != post_subject)
			{
				ajax = new Ajax;
				ajax.mode = 'update_post_subject';
				ajax.callback_function = 'textbox_to_post_subject';
				
				ajax.add_post_data('post_id', post_id);
				ajax.add_post_data('post_subject', encodeURIComponent(new_title));
				
				ajax.do_post_request();
				
				textbox_to_post_subject('<span id="post_subject-'+ post_id +'">'+ post_subject +'</span>');
			}
			else
			{
				textbox_to_post_subject('<span id="post_subject-'+ post_id +'">'+ post_subject +'</span>');
			}
		break;
		
		//Escape
		case 27:
			textbox_to_post_subject('<span id="post_subject-'+ post_id +'">'+ post_subject +'</span>');
		break;
	}
}

function handle_post_subject_change_blur(post_id, new_title)
{
	textbox_data = getbyid('new_post_subject');
	
	if(new_title != post_subject)
	{
		ajax = new Ajax;
		ajax.mode = 'update_post_subject';
		ajax.callback_function = 'textbox_to_post_subject';
		
		ajax.add_post_data('post_id', post_id);
		ajax.add_post_data('post_subject', encodeURIComponent(new_title));
		
		ajax.do_post_request();
		
		textbox_to_post_subject('<span id="post_subject-'+ post_id +'">'+ post_subject +'</span>');
	}
	else
	{
		textbox_to_post_subject('<span id="post_subject-'+ post_id +'">'+ post_subject +'</span>');
	}
}

function textbox_to_post_subject(new_innerhtml)
{
	span_data.innerHTML = new_innerhtml;
}

function get_topic_title_for_ajax_edit(the_topic_id)
{
	topic_id = the_topic_id;
	
	ajax = new Ajax;
	ajax.mode = 'get_topic_title';
	ajax.callback_function = 'topic_title_to_textbox';
	
	ajax.add_post_data('topic_id', topic_id);
	
	ajax.do_post_request();
}

function topic_title_to_textbox(the_topic_title)
{
	topic_title = the_topic_title;
	
	span_data = getbyid('topic-span-' + topic_id);
	
	span_data.innerHTML = '<input type="text" name="new_topic_title" id="new_title" value="'+ topic_title +'" size="50" onKeyPress="handle_topic_title_change_keypress(event, '+ topic_id +', this.value);" onBlur="handle_topic_title_change_blur('+ topic_id +', this.value);" />';
	
	textbox_data = getbyid('new_title');
	textbox_data.focus();
}

function handle_topic_title_change_keypress(e, topic_id, new_title)
{
	e = e ? e : window.event;
	
	textbox_data = getbyid('new_title');
	
	switch (e.keyCode)
	{
		//Enter
		case 13:
			if((new_title != topic_title) && ((new_title.length != 0)))
			{
				ajax = new Ajax;
				ajax.mode = 'update_topic_title';
				ajax.callback_function = 'textbox_to_topic_title';
				
				ajax.add_post_data('topic_id', topic_id);
				ajax.add_post_data('topic_title', encodeURIComponent(new_title));
				
				ajax.do_post_request();
				
				textbox_to_topic_title('<a id="topic-a-'+ topic_id +'" href="viewtopic.php?t='+ topic_id +'">'+ topic_title +'</a>');
			}
			else
			{
				textbox_to_topic_title('<a id="topic-a-'+ topic_id +'" href="viewtopic.php?t='+ topic_id +'">'+ topic_title +'</a>');
			}
		break;
		
		//Escape
		case 27:
			textbox_to_topic_title('<a id="topic-a-'+ topic_id +'" href="viewtopic.php?t='+ topic_id +'">'+ topic_title +'</a>');
		break;
	}
}

function handle_topic_title_change_blur(topic_id, new_title)
{
	textbox_data = getbyid('new_title');
	
	if((new_title != topic_title) && ((new_title.length != 0)))
	{
		ajax = new Ajax;
		ajax.mode = 'update_topic_title';
		ajax.callback_function = 'textbox_to_topic_title';
		
		ajax.add_post_data('topic_id', topic_id);
		ajax.add_post_data('topic_title', encodeURIComponent(new_title));
		
		ajax.do_post_request();
		
		textbox_to_topic_title('<a id="topic-a-'+ topic_id +'" href="viewtopic.php?t='+ topic_id +'">'+ topic_title +'</a>');
	}
	else
	{
		textbox_to_topic_title('<a id="topic-a-'+ topic_id +'" href="viewtopic.php?t='+ topic_id +'">'+ topic_title +'</a>');
	}
}


function textbox_to_topic_title(new_innerhtml)
{
	span_data.innerHTML = new_innerhtml;
}

function toggle_quick_reply()
{
	if(itm = getbyid('quick-reply'))
	{
		if(itm.style.display == "none")
		{
			Effect.SlideDown(itm);
		}
		else
		{
			Effect.SlideUp(itm);
		}
	}
}

function show_hidden_post(post_id)
{
	getbyid('showpost-' + post_id).style.display = 'none';
	Effect.SlideDown('post_container-' + post_id);
}

function getbyid(id)
{
	itm = null;
	
	if(document.getElementById)
	{
		itm = document.getElementById(id);
	}
	else if(document.all)
	{
		itm = document.all[id];
	}
	else if(document.layers)
	{
		itm = document.layers[id];
	}
	
	return itm;
}

function toggleview(id)
{	
	if(itm = getbyid(id))
	{
		if(itm.style.display == "none")
		{
			show_div(itm);
		}
		else
		{
			hide_div(itm);
		}
	}
}

function hide_div(itm)
{
	itm.style.display = "none";
}

function show_div(itm)
{
	if(! itm) return;
	
	itm.style.display = "";
}