<?php
/*
* --------------------------------------------------------------------------
*                                    NuclearBB
*                              (c) 2007 NuclearBB
* --------------------------------------------------------------------------
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* --------------------------------------------------------------------------
*/

define('IN_NBB', true);
define('IN_LOGIN', true);
$root_path = '.';
require("$root_path/inc/global.php");
$session->begin();
$auth->setup();

$mode = (isset($_GET['mode'])) ? htmlspecialchars($_GET['mode']) : '';

if($session->logged_in && empty($mode))
{
	Header("Location: $root_path");
}

switch($mode)
{
	case 'confirmpasschange':
		$activation_key = (isset($_GET['code'])) ? htmlspecialchars($_GET['code']) : '';
		
		if(isset($_POST['submit']))
		{
			forum_header('enter_new_password');
			
			if($_POST['pass1'] != $_POST['pass2'])
			{
				define('META_REFRESH', 'index.php');
				trigger_error('password_mismatch');
			}
			
			$update_sql = $db->build_query('UPDATE', array(
				'activation_key'	=>	'',
				'password'			=>	md5_salt($_POST['pass1'])
			));
			
			$sql = "UPDATE users
					SET $update_sql
					WHERE activation_key = '". $db->escape($activation_key) ."'";
			$db->query($sql);
			
			define('META_REFRESH', 'index.php');
			trigger_error('password_reset_successfully');
		}
		else
		{
			$user_data = array();
			
			$sql = "SELECT *
					FROM users
					WHERE activation_key = '". $db->escape($activation_key) ."'";
			$result = $db->query($sql);
			$user_data = $db->fetch_assoc($result);
			
			if(empty($user_data) || empty($activation_key))
			{
				define('META_REFRESH', 'contact.php');
				trigger_error('activation_error');
			}
			
			forum_header('enter_new_password');
						
			$template->load('body', 'confirm_passchange.html');
			
			$template->assign_vars(array(
				'FORM_ACTION'	=>	"login.php?mode=confirmpasschange&amp;code=$activation_key"
			));
			
			$template->display('body');
		}
	break;
	
	case 'forgotpass':
		if(isset($_POST['submit']))
		{
			$user_id = 0;
			$user_id = user_id_from_username($_POST['username']);
			
			if(empty($user_id))
			{
				trigger_error('user_no_exist');
			}
			
			$sql = "SELECT *
					FROM users
					WHERE user_id = $user_id";
			$result = $db->query($sql);
			$user_data = $db->fetch_assoc($result);
			
			$activation_key = generate_random_string(10);
			
			$update_sql = $db->build_query('UPDATE', array(
				'activation_key'	=>	$activation_key
			));
			
			$sql = "UPDATE users
					SET $update_sql
					WHERE user_id = $user_id";
			$db->query($sql);
			
			require("$root_path/inc/functions_email.php");
			$mail = new email;
			
			$mail->subject = 'Password reset instructions';
			$mail->add_recipient($user_data['email'], $user_data['username']);
			
			$mail->load_message('forgotten_password');
			$mail->parse_vars(array(
				'U_RESET_PASS'	=>	"{$config['board_url']}/login.php?mode=confirmpasschange&amp;code=$activation_key"
			));
			
			$mail->send();
			
			define('META_REFRESH', 'index.php');
			forum_header('forgotten_password');
			trigger_error('forgot_pass_mail_sent');
		}
		else
		{
			forum_header('forgotten_password');
			
			$template->load('body', 'forgot_pass.html');
			
			$template->assign_vars(array(
				'FORM_ACTION'	=>	'login.php?mode=forgotpass'
			));
			
			$template->display('body');
		}
	break;
	
	case 'logout':
		$sql = "DELETE FROM sessions
				WHERE user_id = " . $session->user_data['user_id'];
		$db->query($sql);
		
		//This is so the header reads "Welcome, Guest" and not "Welcome, [Username]"
		//after they have successfully logged out
		$template->assign_vars(array(
			'USER_LOGGED_IN'	=>	false,
			'USERNAME'			=>	lang('guest')
		));
		
		$session->set_cookie('data', false, (time() - 360));
		define('META_REFRESH', 'index.php');
		forum_header('logout');
		trigger_error('successful_logout');
	break;
	
	default:
		if(isset($_POST['submit']))
		{
			$password = md5_salt($_POST['password']);
			
			$sql = "SELECT *
					FROM users
					WHERE username = '". $db->escape($_POST['username']) ."'
					AND password = '$password'
					AND user_active = 1";
			$result = $db->query($sql);
			$user_data = $db->fetch_assoc($result);
			
			if(! empty($user_data))
			{
				$sql = "DELETE FROM sessions
						WHERE user_id = " . $user_data['user_id'];
				$db->query($sql);
				
				$session_data = $session->create_session($user_data['user_id']);
				$cookie_user_data = array(
					'USER_ID'		=>	$user_data['user_id'],
					'SESSION_ID'	=>	$session_data['SID']
				);
		
				//31536000 seconds = 365 days
				$session->set_cookie('data', serialize($cookie_user_data), (time() + 31536000));
				
				//This is so the header reads "Welcome, [Username]" and not "Welcome, Guest"
				//after they have successfully logged in
				$template->assign_vars(array(
					'USER_LOGGED_IN'	=>	true,
					'USERNAME'			=>	$user_data['username']
				));
				
				define('META_REFRESH', 'index.php');
				forum_header('login');
				
				trigger_error('successful_login');
			}
			else
			{
				define('META_REFRESH', 'login.php');
				trigger_error('login_error');
			}
		}
		else
		{
			forum_header('login');
			
			$template->load('body', 'login.html');
			
			$template->assign_vars(array(
				'FORM_ACTION'		=>	'login.php',
				
				'U_FORGOT_PASSWORD'	=>	'login.php?mode=forgotpass'
			));
			
			$template->display('body');
		}
	break;
}

forum_footer();
?>