<?php
/*
* --------------------------------------------------------------------------
*                                    NuclearBB
*                              (c) 2007 NuclearBB
* --------------------------------------------------------------------------
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* --------------------------------------------------------------------------
*/

define('IN_NBB', true);
$root_path = '.';
require("$root_path/inc/global.php");
$session->begin();
$auth->setup();
include("$root_path/inc/functions_moderator.php");

$mode = (isset($_REQUEST['mode'])) ? htmlspecialchars($_REQUEST['mode']) : '';
$forum_id = (isset($_REQUEST['f'])) ? intval($_REQUEST['f']) : 0;
$topic_id = (isset($_REQUEST['t'])) ? intval($_REQUEST['t']) : 0;
$post_id = (isset($_REQUEST['p'])) ? intval($_REQUEST['p']) : 0;
$posts = (isset($_POST['posts'])) ? $_POST['posts'] : array();
$topics = (isset($_POST['topics'])) ? $_POST['topics'] : array();

switch($mode)
{
	case 'view_post_report':
		$sql = "SELECT f.*, p.*, t.*
				FROM forums f, posts p, topics t
				WHERE p.post_id = $post_id
				AND t.topic_id = p.topic_id
				AND f.forum_id = t.forum_id";
		$result = $db->query($sql);
		$post_data = $db->fetch_assoc($result);
		
		if(! $auth->forum_check('view_reported_posts', $post_data['forum_id']))
		{
			trigger_error('not_auth');
		}
		
		if(isset($_POST['submit']))
		{
			$take_action = htmlspecialchars($_POST['take_action']);
			
			$sql = "UPDATE forums
					SET reported_posts = reported_posts - 1
					WHERE forum_id = " . $post_data['forum_id'];
			$db->query($sql);
			
			$sql = "UPDATE topics
					SET reported_posts = reported_posts - 1
					WHERE topic_id = " . $post_data['topic_id'];
			$db->query($sql);
			
			$sql = "UPDATE posts
					SET post_reported = 0
					WHERE post_id = $post_id";
			$db->query($sql);
			
			switch($take_action)
			{
				case 'warn_user':
					define('META_REFRESH', 'mcp.php?mode=warn_user&amp;u=' . $post_data['post_author'] . '&amp;f=' . $post_data['forum_id']);
					trigger_error('report_closed_warn');
				break;
				
				case 'ban_user':
					trigger_error('report_closed_ban');
				break;
				
				default:
				case 'no_action':
					trigger_error('report_closed_nfa');
				break;
			}
		}
		else
		{
			forum_header('view_post_report');
			
			$sql = "SELECT r.*, u.*
					FROM post_reports r, users u
					WHERE r.post_id = $post_id
					AND u.user_id = r.reported_by
					ORDER BY r.report_time DESC";
			$result = $db->query($sql);
			$report_data = $db->fetch_assoc($result);
			
			$template->load('body', 'view_post_report.html');
			
			$template->assign_vars(array(
				'REPORT_REASON'		=>	newlines($report_data['report_text']),
				'REPORTED_BY'		=>	$report_data['username'],
				'TIME_REPORTED'		=>	format_date($report_data['report_time'])
			));
			
			$template->display('body');
		}
	break;
	
	case 'warn_user':
		$user_id = (isset($_REQUEST['u'])) ? intval($_REQUEST['u']) : 0;
		$user_data = array();
		
		if(! $auth->forum_check('warn_user', $forum_id))
		{
			trigger_error('not_auth');
		}
		
		$sql = "SELECT *
				FROM users
				WHERE user_id = $user_id";
		$result = $db->query($sql);
		$user_data = $db->fetch_assoc($result);
		
		if(empty($user_data))
		{
			trigger_error('user_no_exist');
		}
		
		if($user_data['user_id'] == $session->user_data['user_id'])
		{
			trigger_error('no_warn_self');
		}
		
		forum_header('warn_user');
		
		if(isset($_POST['warn_submit']))
		{
			$insert_sql = $db->build_query('INSERT', array(
				'warn_reason'	=>	htmlspecialchars($_POST['reason']),
				'warning_type'	=>	intval($_POST['warn_type']),
				'warn_user'		=>	$user_id
			));
			
			$sql = "INSERT INTO warnings $insert_sql";
			$db->query($sql);
			
			$adjust_direction = ($_POST['warn_type'] == WARN_UP) ? '+' : '-';
			
			$sql = "UPDATE users
					SET user_warnings = user_warnings $adjust_direction 1
					WHERE user_id = $user_id";
			$db->query($sql);
			
			trigger_error('user_warned');
		}
		else
		{
			$template->load('warn', 'warn_user.html');
			
			$template->assign_vars(array(
				'CURRENT_WARN_LEVEL'	=>	$user_data['user_warnings'],
				'FORM_ACTION'			=>	"mcp.php?mode=$mode&amp;f=$forum_id&amp;u=$user_id",
				'WARN_DOWN'				=>	WARN_DOWN,
				'WARN_UP'				=>	WARN_UP,
				'WARN_USERNAME'			=>	$user_data['username']
			));
			
			$template->display('warn');
		}
	break;
	
	case 'delete_post':
		$delete_posts = array();
		
		if(isset($_POST['confirm_no']))
		{
			Header("Location: viewtopic.php?t=$topic_id");
		}
		
		if(isset($_POST['confirm_yes']))
		{
			$in_posts = implode(',', $posts);
			
			$sql = "SELECT t.*, p.*
					FROM topics t, posts p
					WHERE p.post_id IN($in_posts)
					AND t.topic_id = p.topic_id";
			$result = $db->query($sql);
			while($row = $db->fetch_assoc($result))
			{
				$delete_posts[] = $row;
			}
			
			for($i = 0; $i < count($delete_posts); $i++)
			{
				//If we're trying to delete the first post (which counts as deleting the topic)
				//we check the use can delete topics and then do it
				if($delete_posts[$i]['post_id'] == $delete_posts[$i]['first_post_id'])
				{
					if(! $auth->forum_check('delete_topic', $delete_posts[$i]['forum_id']))
					{
						trigger_error('not_auth');
					}
					
					delete_topic($delete_posts[$i]['topic_id']);
					
					define('META_REFRESH', 'viewforum.php?f=' . $delete_posts[$i]['forum_id']);
					forum_header('delete_topic');
					mcp_success(sprintf(lang('return_forum'), $delete_posts[$i]['forum_id']), 'topics_deleted');
					
					return;
				}
				
				if(! $auth->forum_check('delete_post', $delete_posts[$i]['forum_id']))
				{
					trigger_error('not_auth');
				}
				
				delete_post($delete_posts[$i]['post_id']);
			}
			
			define('META_REFRESH', "viewtopic.php?t=$topic_id");
			forum_header('delete_post');
			mcp_success(sprintf(lang('return_topic'), $topic_id), 'posts_deleted');
		}
		else
		{
			forum_header('delete_post');
			
			for($i = 0; $i < count($posts); $i++)
			{
				$template->assign_block_vars('hidden_info', array(
					'NAME'	=>	'posts',
					'VALUE'	=>	$posts[$i]
				));
			}
			
			confirm_box("mcp.php?mode=delete_post&amp;t=$topic_id", lang('confirm_delete_post'));
		}
	break;
	
	case 'delete_topic':
		$delete_topics = array();
		
		if(isset($_POST['confirm_no']))
		{
			Header("Location: viewforum.php?f=$forum_id");
		}
		
		if(isset($_POST['confirm_yes']))
		{
			$in_topics = implode(',', $topics);
			
			$sql = "SELECT *
					FROM topics
					WHERE topic_id IN($in_topics)";
			$result = $db->query($sql);
			while($row = $db->fetch_assoc($result))
			{
				$delete_topics[] = $row;
			}
			
			for($i = 0; $i < count($delete_topics); $i++)
			{
				if(! $auth->forum_check('delete_topic', $delete_topics[$i]['forum_id']))
				{
					trigger_error('not_auth');
				}
				
				delete_topic($delete_topics[$i]['topic_id']);
			}
			
			define('META_REFRESH', "viewforum.php?f=$forum_id");
			forum_header('delete_topic');
			mcp_success(sprintf(lang('return_forum'), $forum_id), 'topics_deleted');
		}
		else
		{
			forum_header('delete_topic');
			
			if(! empty($topic_id))
			{
				$topics[] = $topic_id;
			}
			
			for($i = 0; $i < count($topics); $i++)
			{
				$template->assign_block_vars('hidden_info', array(
					'NAME'	=>	'topics',
					'VALUE'	=>	$topics[$i]
				));
			}
			
			confirm_box("mcp.php?mode=delete_topic&amp;f=$forum_id", lang('confirm_delete_topic'));
		}
	break;
	
	case 'move_topic':
		if(isset($_POST['move_submit']))
		{
			$move_topics = array();
			$in_topics = (! empty($topic_id)) ? $topic_id : implode(',', $topics);
			
			$sql = "SELECT *
					FROM topics
					WHERE topic_id IN($in_topics)";
			$result = $db->query($sql);
			while($row = $db->fetch_assoc($result))
			{
				$move_topics[] = $row;
			}
			
			for($i = 0; $i < count($move_topics); $i++)
			{
				if(! $auth->forum_check('move_topic', $forum_id))
				{
					trigger_error('not_auth');
				}
				
				move_topic($move_topics[$i]['topic_id'], intval($_POST['new_forum_id']));
			}
			
			define('META_REFRESH', "viewforum.php?f=$forum_id");
			forum_header('move_topic');
			mcp_success(sprintf(lang('return_forum'), $forum_id), 'topics_moved');
		}
		else
		{
			forum_header('move_topic');
			
			$forums = $right = array();
			
			$template->load('body', 'move_topic.html');
			
			$sql = "SELECT *
					FROM forums
					WHERE forum_type != ". TYPE_LINK ."
					ORDER BY left_id ASC";
			$result = $db->query($sql);
			while($row = $db->fetch_assoc($result))
			{
				//Only show forums the user is auth'ed to view
				if($auth->forum_check('view_forum', $row['forum_id']))
				{
					$forums[] = $row;
				}
			}
			
			for($i = 0; $i < count($forums); $i++)
			{
				if($forums[$i]['right_id'] != ($forums[$i]['left_id'] + 1))
				{
					$right[] = $forums[$i]['right_id'];
				}
				
				$num_right = count($right);
				$last_right = $right[ $num_right - 1 ];
				if(($forums[$i]['right_id'] + 1) == $last_right)
				{
					array_pop($right);
				}
				
				$t = count($right);
				
				$template->assign_block_vars('forum', array(
					'ID'	=>	$forums[$i]['forum_id'],
					'NAME'	=>	str_repeat('-', count($right)) . '['. $forums[$i]['left_id'] .'] ' . $forums[$i]['forum_name'] . ' ['. $forums[$i]['right_id'] .'] ('. $right[ $t - 1 ] .')'
				));
			}
			
			for($i = 0; $i < count($topics); $i++)
			{
				$template->assign_block_vars('topic', array(
					'ID'	=>	$topics[$i]
				));
			}
			
			$template->assign_vars(array(
				'FORM_ACTION'	=>	"mcp.php?f=$forum_id&amp;mode=move_topic"
			));
			
			$template->display('body');
		}
	break;
	
	case 'approve_post':
		$approve_posts = array();
		$in_posts = implode(',', $posts);
		
		$sql = "SELECT p.*, t.*
				FROM posts p, topics t
				WHERE post_id IN($in_posts)
				AND p.topic_id = t.topic_id";
		$result = $db->query($sql);
		while($row = $db->fetch_assoc($result))
		{
			$approve_posts[] = $row;
		}
		
		for($i = 0; $i < count($approve_posts); $i++)
		{
			if(! $auth->forum_check('approve_post', $approve_posts[$i]['forum_id']))
			{
				trigger_error('not_auth');
			}
			
			//Is the user trying to approve the first post (which counts as the topic)
			if($approve_posts[$i]['first_post_id'] == $approve_posts[$i]['post_id'])
			{
				if(! $auth->forum_check('approve_topic', $approve_posts[$i]['forum_id']))
				{
					trigger_error('not_auth');
				}
				
				approve_topic($topic_id);
				mcp_success(sprintf(lang('return_topic'), $topic_id), 'topic_approved');
				forum_footer();
			}
			
			approve_post($approve_posts[$i]['post_id']);
		}
		
		define('META_REFRESH', "viewtopic.php?t=$topic_id");
		forum_header('approve_post');
		mcp_success(sprintf(lang('return_topic'), $topic_id), 'post_approved');
	break;
	
	case 'approve_topic':
		$sql = "SELECT *
				FROM topics
				WHERE topic_id = $topic_id";
		$result = $db->query($sql);
		$topic_data = $db->fetch_assoc($result);
		
		if(! $auth->forum_check('approve_topic', $topic_data['forum_id']))
		{
			trigger_error('not_auth');
		}
		
		approve_topic($topic_id);
		
		define('META_REFRESH', 'viewforum.php?f=' . $topic_data['forum_id']);
		forum_header('approve_topic');
		mcp_success(sprintf(lang('return_forum'), $topic_data['forum_id']), 'topic_approved');
	break;
	
	case 'normalise':
		$normalise_topics = array();
		$in_topics = (! empty($topic_id)) ? $topic_id : implode(',', $topics);
		
		$sql = "SELECT *
				FROM topics
				WHERE topic_id IN($in_topics)";
		$result = $db->query($sql);
		while($row = $db->fetch_assoc($result))
		{
			$normalise_topics[] = $row;
		}
		
		for($i = 0; $i < count($normalise_topics); $i++)
		{
			if(! $auth->forum_check('normalise_topic', $forum_id))
			{
				trigger_error('not_auth');
			}
			
			alter_topic_type($normalise_topics[$i]['topic_id'], TOPIC_NORMAL, $forum_id);
		}
		
		define('META_REFRESH', "viewforum.php?f=$forum_id");
		forum_header('normalise_topic');
		mcp_success(sprintf(lang('return_forum'), $forum_id), 'topics_normalised');
	break;
	
	case 'globalise':
		$globalise_topics = array();
		$in_topics = (! empty($topic_id)) ? $topic_id : implode(',', $topics);
		
		$sql = "SELECT *
				FROM topics
				WHERE topic_id IN($in_topics)";
		$result = $db->query($sql);
		while($row = $db->fetch_assoc($result))
		{
			$globalise_topics[] = $row;
		}
		
		for($i = 0; $i < count($globalise_topics); $i++)
		{
			if(! $auth->forum_check('globalise_topic', $globalise_topics[$i]['forum_id']))
			{
				trigger_error('not_auth');
			}
			
			alter_topic_type($globalise_topics[$i]['topic_id'], TOPIC_GLOBAL, $globalise_topics[$i]['forum_id']);
		}
		
		forum_header('globalise_topic');
		trigger_error('topics_globalised');
	break;
	
	case 'announce':
		$announce_topics = array();
		$in_topics = (! empty($topic_id)) ? $topic_id : implode(',', $topics);
		
		$sql = "SELECT *
				FROM topics
				WHERE topic_id IN($in_topics)";
		$result = $db->query($sql);
		while($row = $db->fetch_assoc($result))
		{
			$announce_topics[] = $row;
		}
		
		for($i = 0; $i < count($announce_topics); $i++)
		{
			if(! $auth->forum_check('announce_topic', $announce_topics[$i]['forum_id']))
			{
				trigger_error('not_auth');
			}
			
			alter_topic_type($announce_topics[$i]['topic_id'], TOPIC_ANNOUNCEMENT, $announce_topics[$i]['forum_id']);
		}
		
		define('META_REFRESH', "viewforum.php?f=$forum_id");
		forum_header('announce_topic');
		mcp_success(sprintf(lang('return_forum'), $forum_id), 'topics_announced');
	break;
	
	case 'sticky':
		$sticky_topics = array();
		$in_topics = (! empty($topic_id)) ? $topic_id : implode(',', $topics);
		
		$sql = "SELECT *
				FROM topics
				WHERE topic_id IN($in_topics)";
		$result = $db->query($sql);
		while($row = $db->fetch_assoc($result))
		{
			$sticky_topics[] = $row;
		}
		
		for($i = 0; $i < count($sticky_topics); $i++)
		{
			if(! $auth->forum_check('sticky_topic', $sticky_topics[$i]['forum_id']))
			{
				trigger_error('not_auth');
			}
			
			alter_topic_type($sticky_topics[$i]['topic_id'], TOPIC_STICKY, $sticky_topics[$i]['forum_id']);
		}
		
		define('META_REFRESH', "viewforum.php?f=$forum_id");
		forum_header('sticky_topic');
		mcp_success(sprintf(lang('return_forum'), $forum_id), 'topics_stickied');
	break;
	
	case 'unlock':
		$unlock_topics = array();
		$in_topics = (! empty($topic_id)) ? $topic_id : implode(',', $topics);
		
		$sql = "SELECT *
				FROM topics
				WHERE topic_id IN($in_topics)";
		$result = $db->query($sql);
		while($row = $db->fetch_assoc($result))
		{
			$unlock_topics[] = $row;
		}
		
		for($i = 0; $i < count($unlock_topics); $i++)
		{
			if(! $auth->forum_check('unlock_topic', $unlock_topics[$i]['forum_id']))
			{
				trigger_error('not_auth');
			}
			
			unlock_topic($unlock_topics[$i]['topic_id']);
		}
		
		if(! empty($topic_id))
		{
			define('META_REFRESH', "viewtopic.php?t=$topic_id");
			forum_header('unlock_topic');
			mcp_success(sprintf(lang('return_topic'), $topic_id), 'topics_unlocked');
		}
		else
		{
			define('META_REFRESH', "viewforum.php?f=$forum_id");
			forum_header('unlock_topic');
			mcp_success(sprintf(lang('return_forum'), $forum_id), 'topics_unlocked');
		}
	break;
	
	case 'lock':
		$lock_topics = array();
		$in_topics = (! empty($topic_id)) ? $topic_id : implode(',', $topics);
		
		$sql = "SELECT *
				FROM topics
				WHERE topic_id IN($in_topics)";
		$result = $db->query($sql);
		while($row = $db->fetch_assoc($result))
		{
			$lock_topics[] = $row;
		}
		
		for($i = 0; $i < count($lock_topics); $i++)
		{
			if(! $auth->forum_check('lock_topic', $lock_topics[$i]['forum_id']))
			{
				trigger_error('not_auth');
			}
			
			lock_topic($lock_topics[$i]['topic_id']);
		}
		
		if(! empty($topic_id))
		{
			define('META_REFRESH', "viewtopic.php?t=$topic_id");
			forum_header('lock_topic');
			mcp_success(sprintf(lang('return_topic'), $topic_id), 'topics_locked');
		}
		else
		{
			define('META_REFRESH', "viewforum.php?f=$forum_id");
			forum_header('lock_topic');
			mcp_success(sprintf(lang('return_forum'), $forum_id), 'topics_locked');
		}
	break;
	
	case 'hide_post':
		$hide_posts = array();
		$in_posts = implode(',', $posts);
		
		$sql = "SELECT p.*, t.*
				FROM posts p, topics t
				WHERE post_id IN($in_posts)
				AND p.topic_id = t.topic_id";
		$result = $db->query($sql);
		while($row = $db->fetch_assoc($result))
		{
			$hide_posts[] = $row;
		}
		
		for($i = 0; $i < count($hide_posts); $i++)
		{
			if(! $auth->forum_check('hide_post', $hide_posts[$i]['forum_id']))
			{
				trigger_error('not_auth');
			}
			
			//Is the user trying to hide the first post (which counts as the topic)
			if($hide_posts[$i]['first_post_id'] == $hide_posts[$i]['post_id'])
			{
				if(! $auth->forum_check('hide_topic', $hide_posts[$i]['forum_id']))
				{
					trigger_error('not_auth');
				}
				
				hide_topic($topic_id);
				mcp_success(sprintf(lang('return_forum'), $hide_posts[$i]['forum_id']), 'topic_hidden');
				forum_footer();
			}
			
			hide_post($hide_posts[$i]['post_id']);
		}
		
		define('META_REFRESH', "viewtopic.php?f=$topic_id");
		forum_header('hide_post');
		mcp_success(sprintf(lang('return_topic'), $topic_id), 'posts_hidden');
	break;
	
	case 'hide_topic':
		$hide_topics = array();
		$in_topics = (! empty($topic_id)) ? $topic_id : implode(',', $topics);
		
		$sql = "SELECT *
				FROM topics
				WHERE topic_id IN($in_topics)";
		$result = $db->query($sql);
		while($row = $db->fetch_assoc($result))
		{
			$hide_topics[] = $row;
		}
		
		for($i = 0; $i < count($hide_topics); $i++)
		{
			if(! $auth->forum_check('hide_topic', $hide_topics[$i]['forum_id']))
			{
				trigger_error('not_auth');
			}
			
			hide_topic($hide_topics[$i]['topic_id']);
		}
		
		define('META_REFRESH', "viewforum.php?f=$forum_id");
		forum_header('hide_topic');
		mcp_success(sprintf(lang('return_forum'), $forum_id), 'topics_hidden');
	break;
	
	case 'merge_posts':
		trigger_error('This doesn\'t work yet!');
	break;
	
	default:
		trigger_error('no_mode');
	break;
}

if(! defined('HEADER_OUT'))
{
	forum_header('moderator_control_panel');
}

forum_footer();
?>