<?php
/*
* --------------------------------------------------------------------------
*                                    NuclearBB
*                              (c) 2007 NuclearBB
* --------------------------------------------------------------------------
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* --------------------------------------------------------------------------
*/

define('IN_NBB', true);
$root_path = '.';
require("$root_path/inc/global.php");
require("$root_path/inc/functions_post.php");
$session->begin();
$auth->setup();

$forum_id = (isset($_GET['f'])) ? intval($_GET['f']) : 0;
$post_id = (isset($_GET['p'])) ? intval($_GET['p']) : 0;
$topic_id = (isset($_GET['t'])) ? intval($_GET['t']) : 0;
$mode = (isset($_GET['mode'])) ? htmlspecialchars($_GET['mode']) : '';
$show_preview = (isset($_POST['preview'])) ? true : false;

if(! $session->logged_in)
{
	trigger_error('not_auth');
}

//Assign some template vars common to all modes
$template->assign_vars(array(
	'MODE'					=>	$mode,
	'SHOW_PREVIEW'			=>	$show_preview,
	'SOMEONE_ELSE_POSTED'	=>	false
));

switch($mode)
{
	case 'edit':
		$sql = "SELECT t.*, p.*
				FROM topics t, posts p
				WHERE p.post_id = $post_id
				AND p.topic_id = t.topic_id";
		$result = $db->query($sql);
		$post_data = $db->fetch_assoc($result);
		if((empty($post_data)) || ($post_data['topic_hidden']))
		{
			define('META_REFRESH', 'index.php');
			trigger_error('post_no_exist');
		}
		
		if(! (($session->user_data['user_id'] == $post_data['post_author'] && $auth->forum_check('edit_own_posts', $post_data['forum_id'])) || $auth->forum_check('edit_others_posts', $post_data['forum_id'])) || ($post_data['topic_locked']))
		{
			trigger_error('not_auth');
		}
		
		if($post_data['topic_type'] != TOPIC_GLOBAL)
		{
			$sql = "SELECT *
					FROM forums
					WHERE forum_id = ". $post_data['forum_id'];
			$result = $db->query($sql);
			$forum_data = $db->fetch_assoc($result);
			
			$sql = "SELECT *
					FROM forums
					WHERE left_id < ". $forum_data['left_id'] ."
					AND right_id > ". $forum_data['right_id'] ."
					ORDER BY left_id ASC;";
			$result = $db->query($sql);
			while($row = $db->fetch_assoc($result))
			{
				if($row['forum_type'] != TYPE_CATEGORY)
				{
					$update_forum_ids[] = $row['forum_id'];
				}
				
				$navigation[] = array('viewforum.php?f=' . $row['forum_id'], $row['forum_name']);
			}
			
			$navigation[] = array('viewforum.php?f=' . $forum_data['forum_id'], $forum_data['forum_name']);
			$navigation[] = array('viewtopic.php?t=' . $post_data['topic_id'], $post_data['topic_title']);
		}
		
		for($i = 0; $i < count($navigation); $i++)
		{
			$template->assign_block_vars('navigation', array(
				'FORUM_NAME'	=>	$navigation[$i][1],
				'U_VIEWFORUM'	=>	$navigation[$i][0]
			));
		}
		
		if(isset($_POST['post_submit']))
		{
			check_required_fields(array('post'));
			$new_subject = trim(htmlspecialchars($_POST['post_subject']));
			$new_post = trim(htmlspecialchars($_POST['post']));
			$new_md5 = md5($new_post);
			
			//Only update the post if the message, title or attach signature has changed
			if(($new_md5 != $post_data['post_md5']) || ($post_data['post_subject'] != $new_subject) || (($post_data['attach_signature'] && ! isset($_POST['attach_signature'])) || ((! $post_data['attach_signature'] && isset($_POST['attach_signature'])))))
			{
				$update_sql = $db->build_query('UPDATE', array(
					'attach_signature'	=>	(isset($_POST['attach_signature'])) ? 1 : 0,
					'post_md5'			=>	$new_md5,
					'post_subject'		=>	$new_subject,
					'post_text'			=>	$new_post
				));
				
				$sql = "UPDATE posts
						SET $update_sql
						WHERE post_id = $post_id";
				$db->query($sql);
				
				if($post_id == $post_data['first_post_id'])
				{
					$sql = "UPDATE topics
							SET topic_title = '". $db->escape($new_subject) ."'
							WHERE topic_id = " . $post_data['topic_id'];
					$db->query($sql);
				}
			}
			
			define('META_REFRESH', "viewtopic.php?t=". $post_data['topic_id'] ."&amp;p=$post_id#p$post_id");
			trigger_error(sprintf(lang('post_updated'), $post_data['topic_id'], $post_id));
		}
		else
		{
			forum_header('edit_post');
			
			$template->load('body', 'post.html');
			
			$template->assign_vars(array(
				'ATTACH_SIGNATURE'		=>	$post_data['attach_signature'],
				'POST_SUBJECT'			=>	$post_data['post_subject'],
				'POST_TEXT'				=>	$post_data['post_text'],
				'PREVIEW_TEXT'			=>	(isset($_POST['post'])) ? newlines(censor_text(parse_smilies(parse_bbcode(htmlspecialchars($_POST['post']))))) : '',
				'PREVIEW_TITLE'			=>	(isset($_POST['post_subject'])) ? censor_text(htmlspecialchars($_POST['post_subject'])) : '',
				'TOPIC_TITLE'			=>	$post_data['topic_title'],
				
				'POST_FORM_ACTION'		=>	"post.php?mode=edit&amp;p=$post_id",
				
				'L_PERFORMING_ACTION'	=>	lang('edit'),
				'L_SUBMIT_BUTTON_TEXT'	=>	lang('update_post')
			));
			
			$template->display('body');
		}
	break;
	
	case 'quote':
	case 'reply':
		$forum_data = $navigation = $quote_post_data = $topic_data = $update_forum_ids = array();
		
		if($mode == 'quote')
		{
			$sql = "SELECT p.*, t.*, u.*
					FROM posts p, topics t, users u
					WHERE p.post_id = $post_id
					AND t.topic_id = $topic_id
					AND t.topic_id = p.topic_id
					AND p.post_author = u.user_id";
			$result = $db->query($sql);
			$quote_post_data = $db->fetch_assoc($result);
		}
		
		$sql = "SELECT *
				FROM topics
				WHERE topic_id = $topic_id";
		$result = $db->query($sql);
		$topic_data = $db->fetch_assoc($result);
		
		if((empty($topic_data)) || ($topic_data['topic_hidden']) || (($topic_data['topic_type'] != TOPIC_GLOBAL) && (! $auth->forum_check('post', $topic_data['forum_id']))))
		{
			define('META_REFRESH', 'index.php');
			trigger_error('topic_no_exist');
		}
		
		if($topic_data['topic_type'] == TOPIC_GLOBAL)
		{
			if(empty($forum_id))
			{
				define('META_REFRESH', 'index.php');
				trigger_error('topic_no_exist');
			}
			
			$topic_data['forum_id'] = $forum_id;
		}
		
		$sql = "SELECT *
				FROM forums
				WHERE forum_id = ". $topic_data['forum_id'];
		$result = $db->query($sql);
		$forum_data = $db->fetch_assoc($result);
		
		if($topic_data['topic_locked'] || $forum_data['forum_flags'] & FLAG_LOCKED)
		{
			define('META_REFRESH', 'index.php');
			trigger_error('unable_reply_topic');
		}
		
		if($topic_data['topic_type'] != TOPIC_GLOBAL)
		{
			$sql = "SELECT *
					FROM forums
					WHERE left_id < ". $forum_data['left_id'] ."
					AND right_id > ". $forum_data['right_id'] ."
					ORDER BY left_id ASC;";
			$result = $db->query($sql);
			while($row = $db->fetch_assoc($result))
			{
				if($row['forum_type'] != TYPE_CATEGORY)
				{
					$update_forum_ids[] = $row['forum_id'];
				}
				
				$navigation[] = array('viewforum.php?f=' . $row['forum_id'], $row['forum_name']);
			}
			
			$navigation[] = array('viewforum.php?f=' . $forum_data['forum_id'], $forum_data['forum_name']);
			$navigation[] = array('viewtopic.php?t=' . $topic_data['topic_id'], $topic_data['topic_title']);
		}
		
		for($i = 0; $i < count($navigation); $i++)
		{
			$template->assign_block_vars('navigation', array(
				'FORUM_NAME'	=>	$navigation[$i][1],
				'U_VIEWFORUM'	=>	$navigation[$i][0]
			));
		}
		
		if((isset($_POST['post_submit']) || isset($_POST['preview'])) && (intval($_POST['last_post_time']) < $topic_data['last_post_time']))
		{
			unset($_POST['preview']);
			unset($_POST['post_submit']);
			
			$sql = "SELECT p.*, t.*, u.username
					FROM posts p, topics t, users u
					WHERE p.topic_id = t.topic_id
					AND p.post_author = u.user_id
					AND t.topic_id = $topic_id
					AND p.time_posted > ". (intval($_POST['last_post_time'])) ."
					ORDER BY p.time_posted DESC";
			$result = $db->query($sql);
			while($row = $db->fetch_assoc($result))
			{
				$template->assign_block_vars('newer_post', array(
					'AUTHOR'	=>	$row['username'],
					'POST'		=>	newlines(censor_text(parse_bbcode($row['post_text'])))
				));
			}
			
			$template->assign_vars(array(
				'SOMEONE_ELSE_POSTED'	=>	true
			));
		}
		
		if(isset($_POST['post_submit']))
		{
			check_required_fields(array('post'));
			
			$notify_data = array();
			$post_subject = htmlspecialchars($_POST['post_subject']);
			$post_text = trim(htmlspecialchars($_POST['post']));
			$post_md5 = md5($post_text);
			$dupe_posts = 0;
			$post_approved = (($forum_data['forum_flags'] & FLAG_APPROVE_REPLIES) && (! $auth->forum_check('approve_post', $forum_data['forum_id']))) ? false : true;
			
			$post_id = create_post($topic_id, $_POST['post_subject'], $_POST['post'], $post_approved);
			
			if((isset($_POST['lock_topic'])) && ($auth->forum_check('lock_topic', $forum_data['forum_id'])))
			{
				include("$root_path/inc/functions_moderator.php");
				lock_topic($topic_id);
			}
			
			$sql = "SELECT n.*, u.username, u.email
					FROM notify_topics n, users u
					WHERE n.topic_id = $topic_id
					AND n.send_more = 1
					AND n.user_id = u.user_id";
			$result = $db->query($sql);
			while($row = $db->fetch_assoc($result))
			{
				$notify_data[ $row['user_id'] ] = $row;
			}
			
			if(isset($_POST['notify_on_reply']))
			{
				if(! array_key_exists($session->user_data['user_id'], $notify_data))
				{
					$sql = "INSERT INTO notify_topics (topic_id, user_id, send_more)
							VALUES($topic_id, ". $session->user_data['user_id'] .", 0)";
					$db->query($sql);
				}
			}
			
			//Send notification E-Mails
			require("$root_path/inc/functions_email.php");
			$mail = new email;
			
			$mail->subject = 'Topic reply notification: '. $topic_data['topic_title'];
			
			$mail->load_message('topic_reply_notification');
			$mail->parse_vars(array(
				'TOPIC_TITLE'	=>	$topic_data['topic_title'],
				
				'U_VIEW'		=>	"{$config['board_url']}/viewtopic.php?t=$topic_id"
			));
			
			foreach($notify_data as $k => $v)
			{
				if($k != $session->user_data['user_id'])
				{
					$mail->add_recipient($v['email'], $v['username']);
				}
			}
			
			$mail->send();
			
			$sql = "UPDATE notify_topics
					SET send_more = 0
					WHERE topic_id = $topic_id";
			$db->query($sql);
			
			if($topic_data['topic_type'] != TOPIC_GLOBAL)
			{
				$update_forum_ids[] = $forum_data['forum_id'];
				$imploded_update_forums = implode(',', $update_forum_ids);
				
				$last_subject = (empty($post_subject)) ? 'Re: '. $topic_data['topic_title'] : $post_subject;
				
				$update_sql = $db->build_query('UPDATE', array(
					'last_post_id'			=>	$post_id,
					'last_post_subject'		=>	$last_subject,
					'last_post_time'		=>	time(),
					'last_post_topic'		=>	$topic_id,
					'last_post_user_id'		=>	$session->user_data['user_id'],
					'last_post_user_colour'	=>	$session->user_data['group_colour'],
					'last_post_username'	=>	$session->user_data['username']
				));
				
				$replies_sql = ($post_approved) ? 'replies = replies + 1' : 'unapproved_posts = unapproved_posts + 1';
				
				$sql = "UPDATE forums
						SET $update_sql,
							$replies_sql,
							replies_actual = replies_actual + 1
						WHERE forum_id IN($imploded_update_forums)";
				$db->query($sql);
			}
			
			$replies_sql = ($post_approved) ? 'replies = replies + 1' : 'unapproved_posts = unapproved_posts + 1';
			$last_post_time_sql = ($post_approved) ? 'last_post_time = '. time() .',' : '';
			
			$sql = "UPDATE topics
					SET $replies_sql,
						replies_actual = replies_actual + 1,
						$last_post_time_sql
						last_post_id = $post_id
					WHERE topic_id = {$topic_data['topic_id']}";
			$db->query($sql);
			
			if(! isset($_POST['attach_signature']))
			{
				$sql = "UPDATE posts
						SET attach_signature = 0
						WHERE post_id = $post_id";
				$db->query($sql);
			}
			
			if((($forum_data['forum_flags'] & FLAG_INCREMENT_POST_COUNT) && $session->logged_in) && ($post_approved))
			{
				$sql = "UPDATE users
						SET post_count = post_count + 1
						WHERE user_id = ". $session->user_data['user_id'];
				$db->query($sql);
			}
			
			$read_topics = (isset($_COOKIE[ $config['cookie_name'] . '_read_topics' ])) ? unserialize($_COOKIE[ $config['cookie_name'] . '_read_topics' ]) : array();
			
			$read_topics[ $forum_data['forum_id'] ][$topic_id] = time();
			
			//31536000 seconds = 365 days
			$session->set_cookie('read_topics', serialize($read_topics), (time() + 31536000));
			
			$append_forum = ($topic_data['topic_type'] == TOPIC_GLOBAL) ? "&amp;f=$forum_id" : '';
			
			$success_msg = ($post_approved) ? sprintf(lang('reply_added'), "viewtopic.php?t={$topic_data['topic_id']}$append_forum&amp;p=$post_id#p$post_id") : sprintf(lang('reply_added_requires_approval'), $topic_data['forum_id']);
			
			if($post_approved)
			{
				define('META_REFRESH', "viewtopic.php?t={$topic_data['topic_id']}$append_forum&amp;p=$post_id#p$post_id");
			}
			else
			{
				define('META_REFRESH', 'viewforum.php?f=' . $topic_data['forum_id']);
			}
			
			trigger_error($success_msg);
		}
		else
		{
			forum_header('add_reply');
			
			$template->load('body', 'post.html');
			
			$auth_check_forum_id = ($topic_data['topic_type'] == TOPIC_GLOBAL) ? $forum_id : $topic_data['forum_id'];
			
			$template->assign_vars(array(
				'ATTACH_SIGNATURE'		=>	$session->user_data['user_options'] & USER_ATTACH_SIGNATURE,
				'LAST_POST_TIME'		=>	$topic_data['last_post_time'],
				'NOTIFY_ON_REPLY'		=>	$session->user_data['user_options'] & USER_NOTIFY_TOPIC_REPLY,
				'PREVIEW_TEXT'			=>	(isset($_POST['post'])) ? newlines(censor_text(parse_smilies(parse_bbcode(htmlspecialchars($_POST['post']))))) : '',
				'PREVIEW_TITLE'			=>	(isset($_POST['post_subject'])) ? censor_text(htmlspecialchars($_POST['post_subject'])) : '',
				'POST_SUBJECT'			=>	(empty($_POST['post_subject'])) ? '' : htmlspecialchars($_POST['post_subject']),
				'POST_TEXT'				=>	(isset($_POST['post'])) ? htmlspecialchars($_POST['post']) : (($mode == 'quote') ? '[quote='. $quote_post_data['username'] .']' . $quote_post_data['post_text'] . '[/quote]' : ''),
				'TOPIC_TITLE'			=>	$topic_data['topic_title'],
				
				'A_LOCK'				=>	$auth->forum_check('lock_topic', $auth_check_forum_id),
				
				'POST_FORM_ACTION'		=>	($topic_data['topic_type'] == TOPIC_GLOBAL) ? "post.php?mode=reply&amp;t=$topic_id&amp;f=$forum_id" : "post.php?mode=reply&amp;t=$topic_id",
				'U_VIEWTOPIC'			=>	"viewtopic.php?t={$topic_data['topic_id']}&amp;p={$topic_data['last_post_id']}#p{$topic_data['last_post_id']}",
				
				'L_PERFORMING_ACTION'	=>	lang('add_reply'),
				'L_SUBMIT_BUTTON_TEXT'	=>	lang('post_message')
			));
			
			topic_review($topic_id);
			
			$template->display('body');
		}
	break;
	
	case 'new':
		$forum_data = $navigation = $update_forum_ids = array();
		
		$sql = "SELECT *
				FROM forums
				WHERE forum_id = $forum_id";
		$result = $db->query($sql);
		$forum_data = $db->fetch_assoc($result);
		
		if((empty($forum_data)) || (! $auth->forum_check('post', $forum_id)))
		{
			trigger_error('forum_no_exist');
		}
		
		if($forum_data['forum_flags'] & FLAG_LOCKED)
		{
			trigger_error('forum_locked_no_reply');
		}
		
		$sql = "SELECT *
				FROM forums
				WHERE left_id < ". $forum_data['left_id'] ."
				AND right_id > ". $forum_data['right_id'] ."
				ORDER BY left_id ASC;";
		$result = $db->query($sql);
		while($row = $db->fetch_assoc($result))
		{
			if($row['forum_type'] != TYPE_CATEGORY)
			{
				$update_forum_ids[] = $row['forum_id'];
			}
			
			$navigation[] = array($row['forum_id'], $row['forum_name']);
		}
		
		$navigation[] = array($forum_data['forum_id'], $forum_data['forum_name']);
		
		for($i = 0; $i < count($navigation); $i++)
		{
			$template->assign_block_vars('navigation', array(
				'FORUM_NAME'	=>	$navigation[$i][1],
				'U_VIEWFORUM'	=>	'viewforum.php?f=' . $navigation[$i][0]
			));
		}
		
		if(isset($_POST['post_submit']))
		{
			check_required_fields(array('post_subject', 'post'));
			
			$poll_options = array();
			$num_poll_choices = 0;
			$poll_title = (isset($_POST['poll_title'])) ? htmlspecialchars($_POST['poll_title']) : '';
			$poll_options_post = (isset($_POST['poll_options'])) ? $_POST['poll_options'] : array();
			$topic_type = (isset($_POST['topic_type'])) ? intval($_POST['topic_type']) : TOPIC_NORMAL;
			$topic_approved = (($forum_data['forum_flags'] & FLAG_APPROVE_NEW_TOPICS) && (! $auth->forum_check('approve_topic', $forum_id))) ? false : true;
			
			$topic_id = create_topic($forum_id, $_POST['post_subject'], $topic_type, $topic_approved);
			$post_id = create_post($topic_id, $_POST['post_subject'], $_POST['post'], true);
			
			if(isset($_POST['notify_on_reply']))
			{
				$sql = "INSERT INTO notify_topics (topic_id, user_id, send_more)
						VALUES($topic_id, ". $session->user_data['user_id'] .", 0)";
				$db->query($sql);
			}
			
			if((isset($_POST['lock_topic'])) && ($auth->forum_check('lock_topic', $forum_id)))
			{
				include("$root_path/inc/functions_moderator.php");
				lock_topic($topic_id);
			}
			
			for($i = 0; $i < count($poll_options_post); $i++)
			{
				$poll_options[] = htmlspecialchars($poll_options_post[$i]);
				if(! empty($poll_options[$i]))
				{
					$num_poll_choices++;
				}
			}
			
			if(! empty($poll_title) && $num_poll_choices < 2)
			{
				trigger_error('num_poll_choices');
			}
			
			if(! empty($poll_title))
			{
				$sql = "INSERT INTO polls (poll_title, topic_id)
						VALUES('". $db->escape($poll_title) ."', $topic_id)";
				$db->query($sql);
				$poll_id = $db->last_id();
				
				for($i = 0; $i < count($poll_options); $i++)
				{
					if(empty($poll_options[$i]))
					{
						continue;
					}
					
					$sql = "INSERT INTO poll_options (poll_id, option_text)
							VALUES($poll_id, '". $db->escape($poll_options[$i]) ."')";
					$db->query($sql);
				}
			}
			
			if($topic_type != TOPIC_GLOBAL)
			{
				$update_forum_ids[] = $forum_data['forum_id'];
				$imploded_update_forums = implode(',', $update_forum_ids);
				
				$update_sql = $db->build_query('UPDATE', array(
					'last_post_time'		=>	time(),
					'last_post_subject'		=>	trim(htmlspecialchars($_POST['post_subject'])),
					'last_post_id'			=>	$post_id,
					'last_post_user_colour'	=>	$session->user_data['group_colour'],
					'last_post_user_id'		=>	$session->user_data['user_id'],
					'last_post_username'	=>	$session->user_data['username'],
					'last_post_topic'		=>	$topic_id
				));
				
				$topic_update_sql = ($topic_approved) ? 'topics = topics + 1' : 'unapproved_topics = unapproved_topics + 1';
				
				$sql = "UPDATE forums
						SET $update_sql,
							$topic_update_sql,
							topics_actual = topics_actual + 1
						WHERE forum_id IN($imploded_update_forums)";
				$db->query($sql);
			}
			
			$sql = "UPDATE topics
					SET first_post_id = $post_id,
						last_post_id = $post_id
					WHERE topic_id = $topic_id";
			$db->query($sql);
			
			if(! isset($_POST['attach_signature']))
			{
				$sql = "UPDATE posts
						SET attach_signature = 0
						WHERE post_id = $post_id";
				$db->query($sql);
			}
			
			if((($forum_data['forum_flags'] & FLAG_INCREMENT_POST_COUNT) && $session->logged_in) && ($topic_approved))
			{
				$sql = "UPDATE users
						SET post_count = post_count + 1
						WHERE user_id = ". $session->user_data['user_id'];
				$db->query($sql);
			}
			
			$read_topics = (isset($_COOKIE[ $config['cookie_name'] . '_read_topics' ])) ? unserialize($_COOKIE[ $config['cookie_name'] . '_read_topics' ]) : array();
			
			$read_topics[ $forum_data['forum_id'] ][$topic_id] = time();
			
			//31536000 seconds = 365 days
			$session->set_cookie('read_topics', serialize($read_topics), (time() + 31536000));
			
			$success_msg = ($topic_approved) ? sprintf(lang('topic_added'), $topic_id) : sprintf(lang('topic_added_requires_approval'), $forum_id);
			
			if($topic_approved)
			{
				define('META_REFRESH', "viewtopic.php?t=$topic_id");
			}
			else
			{
				define('META_REFRESH', "viewforum.php?f=$forum_id");
			}
			
			trigger_error($success_msg);
		}
		else
		{
			forum_header('new_topic');
			
			$template->load('body', 'post.html');
			
			for($i = 0; $i < 3; $i++)
			{
				$template->assign_block_vars('poll_options', array(
					'OPTION_VALUE'		=>	(isset($_POST['poll_options'][$i])) ? htmlspecialchars($_POST['poll_options'][$i]) : '',
					'QUESTION_NUMBER'	=>	sprintf(lang('question_number'), ($i + 1))
				));
			}
			
			$template->assign_vars(array(
				'ATTACH_SIGNATURE'		=>	$session->user_data['user_options'] & USER_ATTACH_SIGNATURE,
				'FORUM_ID'				=>	$forum_id,
				'FORUM_NAME'			=>	$forum_data['forum_name'],
				'NOTIFY_ON_REPLY'		=>	$session->user_data['user_options'] & USER_NOTIFY_TOPIC_REPLY,
				'POLL_TITLE'			=>	(isset($_POST['poll_title'])) ? htmlspecialchars($_POST['poll_title']) : '',
				'POST_SUBJECT'			=>	(isset($_POST['post_subject'])) ? htmlspecialchars($_POST['post_subject']) : '',
				'POST_TEXT'				=>	(isset($_POST['post'])) ? htmlspecialchars($_POST['post']) : '',
				'PREVIEW_TEXT'			=>	(isset($_POST['post'])) ? newlines(censor_text(parse_smilies(parse_bbcode(htmlspecialchars($_POST['post']))))) : '',
				'PREVIEW_TITLE'			=>	(isset($_POST['post_subject'])) ? censor_text(htmlspecialchars($_POST['post_subject'])) : '',
				'SHOW_POLL_FORM'		=>	($auth->forum_check('vote_poll', $forum_id)),
				'SHOW_POST_AS'			=>	(($auth->forum_check('sticky_topic', $forum_id)) || ($auth->forum_check('announce_topic', $forum_id)) || ($auth->forum_check('global_topic_topic', $forum_id))),
				
				'TOPIC_ANNOUNCEMENT'	=>	TOPIC_ANNOUNCEMENT,
				'TOPIC_GLOBAL'			=>	TOPIC_GLOBAL,
				'TOPIC_NORMAL'			=>	TOPIC_NORMAL,
				'TOPIC_STICKY'			=>	TOPIC_STICKY,
				
				'A_ANNOUNCE'			=>	$auth->forum_check('announce_topic', $forum_id),
				'A_GLOBAL'				=>	$auth->forum_check('globalise_topic', $forum_id),
				'A_LOCK'				=>	$auth->forum_check('lock_topic', $forum_id),
				'A_STICKY'				=>	$auth->forum_check('sticky_topic', $forum_id),
				
				'POST_FORM_ACTION'		=>	"post.php?mode=new&amp;f=$forum_id",
				
				'L_PERFORMING_ACTION'	=>	lang('new_topic'),
				'L_SUBMIT_BUTTON_TEXT'	=>	lang('post_message')
			));
			
			$template->display('body');
		}
	break;
	
	default:
		trigger_error('no_mode_set');
	break;
}

forum_footer();
?>