<?php
/*
* --------------------------------------------------------------------------
*                                    NuclearBB
*                              (c) 2007 NuclearBB
* --------------------------------------------------------------------------
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* --------------------------------------------------------------------------
*/

define('IN_NBB', true);
$root_path = '.';
require("$root_path/inc/global.php");
$session->begin();
$auth->setup();
forum_header('view_profile');
$user_id = (isset($_GET['u'])) ? intval($_GET['u']) : 0;

if(! $auth->check('view_profile'))
{
	trigger_error('not_auth');
}

$ranks = $user_data = array();
$rank_image = $rank_text = '';

if(empty($user_id))
{
	define('META_REFRESH', 'index.php');
	trigger_error('no_user_id');
}

$sql = "SELECT *
		FROM users
		WHERE user_id = $user_id";
$result = $db->query($sql);
$user_data = $db->fetch_assoc($result);
if((empty($user_data)) || ($user_id == GUEST_USER))
{
	trigger_error('user_not_exist');
}

$sql = "SELECT g.*, m.*
		FROM groups g, group_members m
		WHERE m.user_id = ". $user_data['user_id'] ."
		AND g.group_type != ". GROUP_HIDDEN ."
		AND m.group_id = g.group_id
		ORDER BY g.group_name ASC";
$result = $db->query($sql);
while($row = $db->fetch_assoc($result))
{
	$group_data[] = $row;
}

$template->load('body', 'profile.html');

for($i = 0; $i < count($group_data); $i++)
{
	$template->assign_block_vars('group', array(
		'ID'			=>	$group_data[$i]['group_id'],
		'NAME'			=>	$group_data[$i]['group_name'],
		'IS_PRIMARY'	=>	($user_data['primary_group'] == $group_data[$i]['group_id'])
	));
}

$ranks = $cache->get_ranks();

if(! empty($user_data['user_rank']))
{
	foreach($ranks['special'] as $k => $v)
	{
		$rank_text = $ranks['special'][ $user_data['user_rank'] ]['rank_title'];
		if(! empty($ranks['special'][ $user_data['user_rank'] ]['rank_image']))
		{
			//Start with a global image
			$rank_image = "$root_path/images/ranks/". $ranks['special'][ $user_data['user_rank'] ]['rank_image'];
			
			//Now, if a template specific one exists we'll use that instead
			if(file_exists("$root_path/$template->style_folder/$template->style_name/images/ranks/". $ranks['special'][ $user_data['user_rank'] ]['rank_image']))
			{
				$rank_image = "$root_path/$template->style_folder/$template->style_name/images/ranks/". $ranks['special'][ $user_data['user_rank'] ]['rank_image'];
			}
		}
	}
}
else
{
	foreach($ranks['normal'] as $k => $v)
	{
		if($ranks['normal'][$k]['rank_posts'] <= $user_data['post_count'])
		{
			$rank_text = $ranks['normal'][$k]['rank_title'];
			if(! empty($ranks['normal'][$k]['rank_image']))
			{
				//Start with a global image
				$rank_image = "$root_path/images/ranks/". $ranks['normal'][$k]['rank_image'];
				
				//Now, if a template specific one exists we'll use that instead
				if(file_exists("$root_path/$template->style_folder/$template->style_name/images/ranks/". $ranks['normal'][$k]['rank_image']))
				{
					$rank_image = "$root_path/$template->style_folder/$template->style_name/images/ranks/". $ranks['normal'][$k]['rank_image'];
				}
			}
		}
	}
}

$template->assign_vars(array(
	'AVATAR_IMG_TEXT'	=>	($user_data['avatar_type'] != 0) ? generate_avatar_text($user_data['avatar_type'], $user_data['avatar_file']) : '',
	'AOL'				=>	$user_data['aol'],
	'ICQ'				=>	$user_data['icq'],
	'JOINED_DATE'		=>	format_date($user_data['joined_date']),
	'LAST_VISIT'		=>	format_date($user_data['last_visit']),
	'MSN'				=>	$user_data['msn'],
	'POST_COUNT'		=>	$user_data['post_count'],
	'RANK_IMAGE'		=>	$rank_image,
	'RANK_TEXT'			=>	$rank_text,
	'SIGNATURE'			=>	newlines(parse_bbcode($user_data['user_signature'])),
	'USERNAME'			=>	$user_data['username'],
	'WEBSITE'			=>	$user_data['website'],
	'YAHOO'				=>	$user_data['yahoo'],
	
	'U_PM'				=>	'ucp.php?m=compose_pm&amp;to=' . $user_data['user_id']
));

$template->display('body');

forum_footer();
?>