<?php
/*
* --------------------------------------------------------------------------
*                                    NuclearBB
*                              (c) 2007 NuclearBB
* --------------------------------------------------------------------------
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* --------------------------------------------------------------------------
*/

define('IN_NBB', true);
$root_path = '.';
require("$root_path/inc/global.php");
$session->begin();
$auth->setup();
$mode = (isset($_GET['mode'])) ? htmlspecialchars($_GET['mode']) : '';

include("$root_path/inc/functions_captcha.php");
$captcha = new captcha;

if($session->logged_in)
{
	Header('Location: index.php');
}

switch($mode)
{
	case 'activate':
		$activation_code = (isset($_GET['code'])) ? htmlspecialchars($_GET['code']) : '';
		$user_data = array();
		
		$sql = "SELECT *
				FROM users
				WHERE activation_key = '". $db->escape($activation_code) ."'";
		$result = $db->query($sql);
		$user_data = $db->fetch_assoc($result);
		
		if(! empty($user_data))
		{
			$sql = "UPDATE users
					SET user_active = 1,
						activation_key = '',
						bad_login_attempts = 0
					WHERE user_id = " . $user_data['user_id'];
			$db->query($sql);
			
			define('META_REFRESH', 'index.php');
			trigger_error('activated_successfully');
		}
		else
		{
			define('META_REFRESH', 'index.php');
			trigger_error('code_invalid');
		}
	break;
}

forum_header('register');

if(isset($_POST['register_submit']))
{
	check_required_fields(array('username', 'email', 'pass1', 'pass2', 'captcha_guess'));
	
	$email_message = $registration_message = '';
	
	$username = htmlspecialchars($_POST['username']);
	$email = htmlspecialchars($_POST['email']);
	$pass1 = htmlspecialchars($_POST['pass1']);
	$pass2 = htmlspecialchars($_POST['pass2']);
	$captcha_id = (isset($_POST['captcha_id'])) ? htmlspecialchars($_POST['captcha_id']) : '';
	$captcha_guess = (isset($_POST['captcha_id'])) ? htmlspecialchars($_POST['captcha_guess']) : '';
	$salted_pass = md5_salt($pass1);
	$activation_key = '';
	
	if($username_status = check_allowed_username($username))
	{
		trigger_error($username_status);
	}
	
	if($email_status = check_email($email))
	{
		trigger_error($email_status);
	}
	
	if($pass1 != $pass2)
	{
		trigger_error('password_mismatch');
	}
	
	if($config['captcha_registration'])
	{
		if(! $captcha->check($captcha_id, $captcha_guess))
		{
			trigger_error('captcha_error');
		}
	}
	
	$insert_sql = $db->build_query('INSERT', array(
		'aol'				=>	htmlspecialchars($_POST['aol']),
		'date_format'		=>	'd M Y H:i',
		'email'				=>	$email,
		'icq'				=>	htmlspecialchars($_POST['icq']),
		'joined_date'		=>	time(),
		'location'			=>	htmlspecialchars($_POST['location']),
		'msn'				=>	htmlspecialchars($_POST['msn']),
		'password'			=>	$salted_pass,
		'primary_group'		=>	3,
		'user_signature'	=>	htmlspecialchars($_POST['signature']),
		'user_options'		=>	3,
		'username'			=>	$username,
		'website'			=>	htmlspecialchars($_POST['website']),
		'yahoo'				=>	htmlspecialchars($_POST['yahoo'])
	));
	
	$sql = "INSERT INTO users $insert_sql";
	$db->query($sql);
	$user_id = $db->last_id();
	
	$sql = "INSERT INTO group_members (group_id, user_id)
			VALUES(3, $user_id)";
	$db->query($sql);
	
	$sql = "UPDATE config
			SET config_value = config_value + 1
			WHERE config_name = 'total_members'";
	$db->query($sql);
	
	$sql = "UPDATE config
			SET config_value = '". $db->escape($username) ."'
			WHERE config_name = 'last_reg_username'";
	$db->query($sql);
	
	$sql = "UPDATE config
			SET config_value = $user_id
			WHERE config_name = 'last_reg_user_id'";
	$db->query($sql);
	
	if($_POST['coppa_state'] == 'under')
	{
		$email_message = 'register_coppa';
		$registration_message = 'reg_successful_coppa';
	}
	else
	{
		switch($config['activation_method'])
		{
			case ACTIVATION_NONE:
				$sql = "UPDATE users
						SET user_active = 1
						WHERE user_id = $user_id";
				$db->query($sql);
				
				$email_message = 'register_no_activation';
				$registration_message = 'reg_successful_no_activation';
			break;
			
			case ACTIVATION_USER:
				$email_message = 'register_user_activation';
				$registration_message = 'reg_successful_user_activation';
				
				$activation_key = generate_random_string(10);
				
				$sql = "UPDATE users
						SET activation_key = '$activation_key'
						WHERE user_id = $user_id";
				$db->query($sql);
			break;
			
			case ACTIVATION_ADMIN:
				$email_message = 'register_admin_activation';
				$registration_message = 'reg_successful_admin_activation';
			break;
		}
	}
	
	require("$root_path/inc/functions_email.php");
	$mail = new email;
	
	$mail->subject = 'Welcome to our forums';
	$mail->add_recipient($email, $username);
	
	$mail->load_message($email_message);
	$mail->parse_vars(array(
		'EMAIL_ADDRESS'	=>	$email,
		'FAX_NUMBER'	=>	$config['coppa_fax'],
		'FORUM_NAME'	=>	$config['board_name'],
		'MAIL_INFO'		=>	$config['coppa_mail'],
		'PASSWORD'		=>	$pass1,
		'USERNAME'		=>	$username,
		
		'U_ACTIVATE'	=>	"{$config['board_url']}/register.php?mode=activate&amp;code=$activation_key"
	));
	
	$mail->send();
	
	$cache->delete('config');
	trigger_error($registration_message);
}
else
{
	$coppa_state = 'over';
	
	if($config['enable_coppa'])
	{
		if(isset($_POST['coppa_under']))
		{
			$coppa_state = 'under';
		}
		
		if(! (isset($_POST['coppa_under']) || isset($_POST['coppa_over'])))
		{
			$template->load('body', 'coppa_agree.html');
			
			$template->display('body');
			
			forum_footer();
		}
	}
	
	$template->load('body', 'register.html');
	
	$template->assign_vars(array(
		'CAPTCHA_ID'	=>	$captcha->create_captcha(),
		'COPPA_STATE'	=>	$coppa_state,
		'SHOW_CAPTCHA'	=>	$config['captcha_registration'],
		
		'U_REGISTER'	=>	'register.php'
	));
	
	$template->display('body');
}
forum_footer();
?>