<?php
/*
* --------------------------------------------------------------------------
*                                    NuclearBB
*                              (c) 2007 NuclearBB
* --------------------------------------------------------------------------
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* --------------------------------------------------------------------------
*/

define('IN_NBB', true);
$root_path = '.';
require("$root_path/inc/global.php");
$session->begin();
$auth->setup();
forum_header('report_post');
$post_id = (isset($_GET['p'])) ? intval($_GET['p']) : 0;
$navigation = array();

$sql = "SELECT f.*, p.*, t.*
		FROM forums f, posts p, topics t
		WHERE p.post_id = $post_id
		AND t.topic_id = p.topic_id
		AND f.forum_id = t.forum_id";
$result = $db->query($sql);
$post_data = $db->fetch_assoc($result);

if(! $auth->forum_check('report_post', $post_data['forum_id']))
{
	trigger_error('not_auth');
}

if($post_data['post_reported'])
{
	trigger_error('post_already_reported');
}

$sql = "SELECT *
		FROM forums
		WHERE left_id < ". $post_data['left_id'] ."
		AND right_id > ". $post_data['right_id'] ."
		ORDER BY left_id ASC;";
$result = $db->query($sql);
while($row = $db->fetch_assoc($result))
{
	$navigation[] = array($row['forum_id'], $row['forum_name']);
}

$navigation[] = array($post_data['forum_id'], $post_data['forum_name']);

for($i = 0; $i < count($navigation); $i++)
{
	$template->assign_block_vars('navigation', array(
		'FORUM_NAME'	=>	$navigation[$i][1],
		
		'U_VIEWFORUM'	=>	'viewforum.php?f=' . $navigation[$i][0]
	));
}

if(isset($_POST['submit']))
{
	check_required_fields(array('report_reason'));
	
	$insert_sql = $db->build_query('INSERT', array(
		'post_id'		=>	$post_id,
		'reported_by'	=>	$session->user_data['user_id'],
		'report_text'	=>	htmlspecialchars($_POST['report_reason']),
		'report_time'	=>	time()
	));
	
	$sql = "INSERT INTO
			post_reports $insert_sql";
	$db->query($sql);
	
	$sql = "UPDATE forums
			SET reported_posts = reported_posts + 1
			WHERE forum_id = " . $post_data['forum_id'];
	$db->query($sql);
	
	$sql = "UPDATE topics
			SET reported_posts = reported_posts + 1
			WHERE topic_id = " . $post_data['topic_id'];
	$db->query($sql);
	
	$sql = "UPDATE posts
			SET post_reported = 1
			WHERE post_id = $post_id";
	$db->query($sql);
	
	trigger_error('post_report_sent');
}
else
{
	$template->load('body', 'report_post.html');
	
	$template->assign_vars(array(
		'FORM_ACTION'	=>	"report.php?p=$post_id",
		'TOPIC_TITLE'	=>	$post_data['topic_title'],
		
		'U_VIEWTOPIC'	=>	'viewtopic.php?t=' . $post_data['topic_id']
	));
	
	$template->display('body');
}

forum_footer();
?>