<?php
/*
* --------------------------------------------------------------------------
*                                    NuclearBB
*                              (c) 2007 NuclearBB
* --------------------------------------------------------------------------
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* --------------------------------------------------------------------------
*/

define('IN_NBB', true);
$root_path = '.';
require("$root_path/inc/global.php");
$session->begin();
$auth->setup();
forum_header('search'); 
$search_query = (isset($_REQUEST['query'])) ? htmlspecialchars($_REQUEST['query']) : '';
$show_results_as = (isset($_REQUEST['show_results_as'])) ? htmlspecialchars($_REQUEST['show_results_as']) : 'posts';

if(! empty($search_query))
{
	$search_results = array();
	
	$load_template = ($show_results_as == 'topics') ? 'search_results_topics' : 'search_results_posts';
	$template->load('body', "$load_template.html");
	
	$sql = "SELECT u1.username AS author_username, u1.user_id AS author_user_id, f.*, g1.group_colour AS author_colour, p.*, t.*,
			MATCH(p.post_text)
			AGAINST ('". $db->escape($search_query) ."') AS score
			FROM forums f, groups g1, posts p, topics t, users u1
			WHERE MATCH(p.post_text)
			AGAINST ('". $db->escape($search_query) ."')
			AND t.topic_id = p.topic_id
			AND u1.user_id = p.post_author
			AND g1.group_id = u1.primary_group
			AND f.forum_id = t.forum_id
			ORDER BY score DESC";
	$result = $db->query($sql);
	while($row = $db->fetch_assoc($result))
	{
		//Only display this result if it meets the following criteria:
		//=> It is posted in a forum the user has view permission in
		//=> If it is a hidden post, the user must have permission to view hidden posts
		//=> If it is an unapproved post, the user must have permission to view unapproved posts
		if((! $auth->forum_check('view_forum', $row['forum_id'])) || ($row['post_hidden'] && ! $auth->forum_check('view_hidden_posts', $row['forum_id'])) || (! $row['post_approved'] && ! $auth->forum_check('view_unapproved_posts', $row['forum_id'])))
		{
			continue;
		}
		
		$search_results[] = $row;
	}
	
	for($i = 0; $i < count($search_results); $i++)
	{
		$template->assign_block_vars('result', array(
			'POST_AUTHOR'			=>	$search_results[$i]['author_username'],
			'POST_AUTHOR_COLOUR'	=>	$search_results[$i]['author_colour'],
			'POST_TEXT'				=>	newlines(censor_text(parse_smilies(parse_bbcode($search_results[$i]['post_text'])))),
			'POSTED_IN_FORUM'		=>	$search_results[$i]['forum_name'],
			'TIME_POSTED'			=>	format_date($search_results[$i]['time_posted']),
			'TOPIC_TITLE'			=>	censor_text($search_results[$i]['topic_title']),
			'REPLIES'				=>	$search_results[$i]['replies'],
			'VIEWS'					=>	$search_results[$i]['views'],
			
			'U_FORUM'				=>	'viewforum.php?f=' . $search_results[$i]['forum_id'],
			'U_PROFILE'				=>	'profile.php?u=' . $search_results[$i]['author_user_id'],
			'U_VIEWTOPIC'			=>	'viewtopic.php?t=' . $search_results[$i]['topic_id'] . '&p=' . $search_results[$i]['post_id'] . '#p' . $search_results[$i]['post_id']
		));
	}
	
	$template->assign_vars(array(
		'NUM_RESULTS'				=>	count($search_results),
		'QUERY_VALUE'				=>	$search_query,
		'SHOW_AS_POSTS'				=>	$show_results_as == 'posts',
		'SHOW_AS_TOPICS'			=>	$show_results_as != 'posts',
		
		'L_SEARCH_RESULTS_FOR_X'	=>	sprintf(lang('search_results_for_x'), $search_query)
	));
}
else
{
	$template->load('body', 'search.html');
	
	$template->assign_vars(array(
		'FORM_ACTION'		=>	'search.php',
		'SHOW_AS_POSTS'		=>	$show_results_as == 'posts',
		'SHOW_AS_TOPICS'	=>	$show_results_as != 'posts',
	));
}

$template->display('body');

forum_footer();
?>