<?php
/*
* --------------------------------------------------------------------------
*                                    NuclearBB
*                              (c) 2007 NuclearBB
* --------------------------------------------------------------------------
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* --------------------------------------------------------------------------
*/

define('IN_NBB', true);
$root_path = '.';
require("$root_path/inc/global.php");
$session->begin();
$auth->setup();

$forum_id = (isset($_GET['f'])) ? intval($_GET['f']) : 0;
$page_number = (isset($_GET['page'])) ? intval($_GET['page']) : 0;
$mark = (isset($_GET['mark'])) ? htmlspecialchars($_GET['mark']) : '';
$forum_data = $navigation = $normal_topics = $special_topics = $topic_types = $topics = array();
$forum_has_unread = false;

$topic_offset = ($page_number != 0) ? ($page_number * $config['topics_per_page']) - $config['topics_per_page'] : 0;

$read_forums = (isset($_COOKIE[ $config['cookie_name'] . '_read_forums' ])) ? unserialize($_COOKIE[ $config['cookie_name'] . '_read_forums' ]) : array();
$read_topics = (isset($_COOKIE[ $config['cookie_name'] . '_read_topics' ])) ? unserialize($_COOKIE[ $config['cookie_name'] . '_read_topics' ]) : array();

if(! array_key_exists($forum_id, $read_forums))
{
	$read_forums[$forum_id] = 0;
}

if(! array_key_exists($forum_id, $read_topics))
{
	$read_topics[$forum_id] = array();
}

$sql = "SELECT *
		FROM forums
		WHERE forum_id = $forum_id";
$result = $db->query($sql);
$forum_data = $db->fetch_assoc($result);
if((empty($forum_data)) || (! $auth->forum_check('view_forum', $forum_id)))
{
	define('META_REFRESH', 'index.php');
	trigger_error('forum_no_exist');
}

if($mark == 'read')
{
	$read_forums[$forum_id] = time();
	$session->set_cookie('read_forums', serialize($read_forums), (time() + 31536000));
	
	Header("Location: viewforum.php?f=$forum_id");
	exit;
}

if($forum_data['forum_type'] == TYPE_LINK)
{
	if($forum_data['forum_flags'] & FLAG_LINK_FORUM_COUNT)
	{
		$sql = "UPDATE forums
				SET topics = topics + 1
				WHERE forum_id = $forum_id";
		$db->query($sql);
	}
	
	Header('Location: ' . $forum_data['url_redirect']);
}

$has_subforums = get_forum_list($forum_id);

$topic_types = array(TOPIC_ANNOUNCEMENT, TOPIC_GLOBAL);

if($topic_offset == 0)
{
	$topic_types[] = TOPIC_STICKY;
}

$topic_types = implode(',', $topic_types);

$hidden_topics_sql = (! $auth->forum_check('view_hidden_topics', $forum_id)) ? 'AND t.topic_hidden = 0' : '';
$unapproved_topics_sql = ($auth->forum_check('view_unapproved_topics', $forum_id)) ? 'AND t.topic_approved IN(0, 1)' : 'AND t.topic_approved = 1';

$sql = "SELECT t.*, u1.username AS creator_username, u2.username AS last_post_username, u2.user_id AS last_post_user_id, p.post_id, p.post_subject, g1.group_colour AS creator_user_colour, g2.group_colour AS last_post_user_colour
		FROM topics t, users u1, users u2, posts p, groups g1, groups g2
		WHERE t.forum_id IN(0, $forum_id)
		AND t.topic_author = u1.user_id
		AND t.last_post_id = p.post_id
		AND t.topic_type IN($topic_types)
		AND u1.primary_group = g1.group_id
		AND u2.primary_group = g2.group_id
		AND u2.user_id = p.post_author
		$hidden_topics_sql
		$unapproved_topics_sql
		ORDER BY t.topic_type DESC, t.last_post_time DESC";
$result = $db->query($sql);
while($row = $db->fetch_assoc($result))
{
	$special_topics[] = $row;
}

$sql = "SELECT t.*, u1.username AS creator_username, u2.username AS last_post_username, u2.user_id AS last_post_user_id, p.post_id, p.post_subject, g1.group_colour AS creator_user_colour, g2.group_colour AS last_post_user_colour
		FROM topics t, users u1, users u2, posts p, groups g1, groups g2
		WHERE t.forum_id = $forum_id
		AND t.topic_author = u1.user_id
		AND t.last_post_id = p.post_id
		AND t.topic_type = ". TOPIC_NORMAL ."
		AND u1.primary_group = g1.group_id
		AND u2.primary_group = g2.group_id
		AND u2.user_id = p.post_author
		$hidden_topics_sql
		$unapproved_topics_sql
		ORDER BY t.last_post_time DESC
		LIMIT $topic_offset, ". $config['topics_per_page'];
$result = $db->query($sql);
while($row = $db->fetch_assoc($result))
{
	$normal_topics[] = $row;
}

$topics = array_merge($special_topics, $normal_topics);
$num_special_topics = count($special_topics);

$template->load('body', 'viewforum.html');

for($i = 0; $i < count($topics); $i++)
{
	$topic_is_new = false;
	
	if($session->logged_in)
	{
		$topic_is_new = true;
		
		if(($read_forums[$forum_id] > $topics[$i]['last_post_time']) || (array_key_exists($topics[$i]['topic_id'], $read_topics[$forum_id])) && ($read_topics[$forum_id][ $topics[$i]['topic_id'] ] >= $topics[$i]['last_post_time']))
		{
			$topic_is_new = false;
		}
	}
	
	$forum_has_unread = (($forum_has_unread == false) && (! $topic_is_new)) ? false : true;
	
	$topic_type = '';
	switch($topics[$i]['topic_type'])
	{
		case TOPIC_STICKY:
			$topic_type = lang('sticky');
		break;
		
		case TOPIC_ANNOUNCEMENT:
			$topic_type = lang('announcement');
		break;
		
		case TOPIC_GLOBAL:
			$topic_type = lang('global_announcement');
		break;
	}
	
	$template->assign_block_vars('topic', array(
		'AUTHOR'					=>	$topics[$i]['creator_username'],
		'AUTHOR_COLOUR'				=>	$topics[$i]['creator_user_colour'],
		'CAN_INSTA_EDIT'			=>	(($topics[$i]['topic_type'] != TOPIC_GLOBAL) && (($session->user_data['user_id'] == $topics[$i]['topic_author'] && $auth->forum_check('edit_own_posts', $forum_data['forum_id'])) || $auth->forum_check('edit_others_posts', $forum_data['forum_id']))),
		'CAN_EDIT_TOPIC_TITLE'		=>	(($session->user_data['user_id'] == $topics[$i]['topic_author'] && $auth->forum_check('edit_own_posts', $forum_data['forum_id'])) || $auth->forum_check('edit_others_posts', $forum_data['forum_id'])),
		'HAS_REPORTED_POSTS'		=>	($auth->forum_check('view_reported_posts', $forum_id) && $topics[$i]['reported_posts'] > 0),
		'HAS_UNAPPROVED_POSTS'		=>	($auth->forum_check('view_unapproved_posts', $forum_id) && $topics[$i]['unapproved_posts'] > 0),
		'LAST_POST_AUTHOR'			=>	$topics[$i]['last_post_username'],
		'LAST_POST_SUBJECT'			=>	(empty($topics[$i]['post_subject'])) ? 'Re: ' . truncate_string(censor_text($topics[$i]['topic_title']), 22) : truncate_string(censor_text($topics[$i]['post_subject']), 25),
		'LAST_POST_USER_COLOUR'		=>	$topics[$i]['last_post_user_colour'],
		'NUM_UNAPPROVED_POSTS'		=>	$topics[$i]['unapproved_posts'],
		'REPORTED_POSTS_TEXT'		=>	($topics[$i]['reported_posts'] > 1) ? sprintf(lang('topic_contains_reported_posts'), $topics[$i]['reported_posts']) : lang('topic_contains_reported_post'),
		'REPLIES'					=>	($auth->forum_check('view_hidden_posts', $forum_id)) ? $topics[$i]['replies_actual'] : $topics[$i]['replies'],
		'TITLE'						=>	censor_text($topics[$i]['topic_title']),
		'TOPIC_APPROVED'			=>	($topics[$i]['topic_approved']),
		'TOPIC_HIDDEN'				=>	$topics[$i]['topic_hidden'],
		'TOPIC_HIDDEN_TEXT'			=>	sprintf(lang('topic_is_hidden'), $topics[$i]['topic_id'], $topics[$i]['topic_title']),
		'TOPIC_ID'					=>	$topics[$i]['topic_id'],
		'TOPIC_IS_NEW'				=>	$topic_is_new,
		'TOPIC_LOCKED'				=>	$topics[$i]['topic_locked'],
		'TOPIC_TYPE'				=>	$topic_type,
		'TOPIC_UNAPPROVED_TEXT'		=>	sprintf(lang('topic_requires_approval'), $topics[$i]['topic_id'], $topics[$i]['topic_title']),
		'UNAPPROVED_POSTS_TEXT'		=>	($topics[$i]['unapproved_posts'] > 1) ? sprintf(lang('topic_contains_unapproved_posts'), $topics[$i]['unapproved_posts']) : lang('topic_contains_unapproved_post'),
		'VIEWS'						=>	$topics[$i]['views'],
		
		'U_LAST_POST'				=>	"viewtopic.php?t={$topics[$i]['topic_id']}&amp;p={$topics[$i]['last_post_id']}#p{$topics[$i]['last_post_id']}",
		'U_LAST_POSTER_PROFILE'		=>	"profile.php?u={$topics[$i]['last_post_user_id']}",
		'U_NEW_POSTS'				=>	"viewtopic.php?t={$topics[$i]['topic_id']}&amp;view=new_posts",
		'U_PROFILE'					=>	"profile.php?u={$topics[$i]['topic_author']}",
		'U_VIEWTOPIC'				=>	($topics[$i]['topic_type'] == TOPIC_GLOBAL) ? "viewtopic.php?t={$topics[$i]['topic_id']}&amp;f=$forum_id" : "viewtopic.php?t={$topics[$i]['topic_id']}"
	));
}

$template->assign_vars(array(
	'CAN_POST_IN_FORUM'	=>	($forum_data['forum_type'] == TYPE_CATEGORY) ? false : true,
	'FORUM_ID'			=>	$forum_data['forum_id'],
	'FORUM_NAME'		=>	$forum_data['forum_name'],
	'FORUM_LOCKED'		=>	$forum_data['forum_flags'] & FLAG_LOCKED,
	'FORUM_RULES'		=>	newlines(parse_bbcode($forum_data['forum_rules'])),
	'HAS_SUBFORUMS'		=>	$has_subforums,
	'NUM_TOPICS'		=>	count($topics),
	'PAGINATION'		=>	generate_pagination((($auth->forum_check('view_hidden_topics', $forum_id) ? $forum_data['topics_actual'] - $num_special_topics : $forum_data['topics']) - $num_special_topics), $config['topics_per_page'], $topic_offset, "viewforum.php?f=$forum_id"),
	'SHOW_FORUM_RULES'	=>	(($forum_data['forum_flags'] & FLAG_SHOW_FORUM_RULES) && (! empty($forum_data['forum_rules']))),
	
	'A_ANNOUNCE'		=>	$auth->forum_check('announce_topic', $forum_id),
	'A_DELETE_TOPIC'	=>	$auth->forum_check('delete_topic', $forum_id),
	'A_GLOBALISE'		=>	$auth->forum_check('globalise_topic', $forum_id),
	'A_HIDE_TOPIC'		=>	$auth->forum_check('hide_topic', $forum_id),
	'A_LOCK'			=>	$auth->forum_check('lock_topic', $forum_id),
	'A_MODERATE'		=>	$auth->forum_check('moderate', $forum_id),
	'A_MOVE_TOPIC'		=>	$auth->forum_check('move_topic', $forum_id),
	'A_NORMALISE'		=>	$auth->forum_check('normalise_topic', $forum_id),
	'A_POST'			=>	(($auth->forum_check('post', $forum_id)) && (! ($forum_data['forum_flags'] & FLAG_LOCKED))),
	'A_STICKY'			=>	$auth->forum_check('sticky_topic', $forum_id),
	'A_UNLOCK'			=>	$auth->forum_check('unlock_topic', $forum_id),
	
	'U_MARK_FORUM_READ'	=>	"viewforum.php?f=$forum_id&amp;mark=read",
	'U_NEW_TOPIC'		=>	"post.php?mode=new&amp;f=$forum_id"
));

if(! $forum_has_unread)
{
	$read_forums[$forum_id] = time();
	$read_topics[$forum_id] = array();
	
	//31536000 seconds = 365 days
	$session->set_cookie('read_forums', serialize($read_forums), (time() + 31536000));
	$session->set_cookie('read_topics', serialize($read_topics), (time() + 31536000));
}

//forum_header('view_forum');
forum_header($forum_data['forum_name']);

$template->display('body');

forum_footer();
?>