<?php
/*
* --------------------------------------------------------------------------
*                                    NuclearBB
*                              (c) 2007 NuclearBB
* --------------------------------------------------------------------------
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* --------------------------------------------------------------------------
*/

define('IN_NBB', true);
$root_path = '.';
require("$root_path/inc/global.php");
$session->begin();
$auth->setup();

$post_id = (isset($_GET['p'])) ? intval($_GET['p']) : 0;
$topic_id = (isset($_GET['t'])) ? intval($_GET['t']) : 0;
$forum_id = (isset($_GET['f'])) ? intval($_GET['f']) : 0;
$page_number = (isset($_GET['page'])) ? intval($_GET['page']) : 0;
$view = (isset($_GET['view'])) ? htmlspecialchars($_GET['view']) : '';
$forum_data = $navigation = $topic_data = $posts = $ranks = array();
$last_post_time = $row_count = $total_votes = 0;

$sql = "SELECT *
		FROM topics
		WHERE topic_id = $topic_id";
$result = $db->query($sql);
$topic_data = $db->fetch_assoc($result);
if((empty($topic_data)) || (! $auth->forum_check('view_hidden_topics', $topic_data['forum_id']) && $topic_data['topic_hidden']) || (! $topic_data['topic_approved'] && ! $auth->forum_check('view_unapproved_topics', $topic_data['forum_id'])) || (($topic_data['topic_type'] != TOPIC_GLOBAL) && (! $auth->forum_check('view_forum', $topic_data['forum_id']))))
{
	define('META_REFRESH', 'index.php');
	trigger_error('topic_no_exist');
}

if($topic_data['topic_type'] == TOPIC_GLOBAL)
{
	if(empty($forum_id))
	{
		trigger_error('topic_no_exist');
	}
	
	$topic_data['forum_id'] = $forum_id;
}

$read_forums = (isset($_COOKIE[ $config['cookie_name'] . '_read_forums' ])) ? unserialize($_COOKIE[ $config['cookie_name'] . '_read_forums' ]) : array();
$read_topics = (isset($_COOKIE[ $config['cookie_name'] . '_read_topics' ])) ? unserialize($_COOKIE[ $config['cookie_name'] . '_read_topics' ]) : array();

if(! array_key_exists($forum_id, $read_forums))
{
	$read_forums[$forum_id] = 0;
}

if(! array_key_exists($topic_data['forum_id'], $read_topics))
{
	$read_topics[ $topic_data['forum_id'] ] = array();
}

if(! array_key_exists($topic_id, $read_topics[ $topic_data['forum_id'] ]))
{
	$read_topics[ $topic_data['forum_id'] ][$topic_id] = 0;
}

if($view == 'new_posts')
{
	$forum_time = $read_forums[ $topic_data['forum_id'] ];
	$topic_time = $read_topics[ $topic_data['forum_id'] ][$topic_id];
	
	$last_posted_time = intval(max($forum_time, $topic_time));
	
	$sql = "SELECT t.*, p.*
			FROM topics t, posts p
			WHERE p.topic_id = t.topic_id
			AND p.topic_id = $topic_id
			AND p.time_posted > $last_posted_time
			ORDER BY p.time_posted ASC
			LIMIT 1";
	$result = $db->query($sql);
	$newest_post_data = $db->fetch_assoc($result);
	
	Header("Location: viewtopic.php?t=$topic_id&p=" . $newest_post_data['post_id'] . '#p' . $newest_post_data['post_id']);
	exit;
}

//If we request a single post, we should take the user to the correct page
if(! empty($post_id))
{
	$temp_posts = array();
	
	$sql = "SELECT t.*, p.*
			FROM topics t, posts p
			WHERE p.topic_id = t.topic_id
			AND p.topic_id = $topic_id
			ORDER BY p.time_posted ASC";
	$result = $db->query($sql);
	while($row = $db->fetch_assoc($result))
	{
		$temp_posts[] = $row['post_id'];
	}
	
	for($i = 0; $i < count($temp_posts); $i++)
	{
		if($temp_posts[$i] == $post_id)
		{
			$page_number = ceil((($i + 1) / $config['posts_per_page']));
		}
	}
}

$post_offset = ($page_number != 0) ? ($page_number * $config['posts_per_page']) - $config['posts_per_page'] : 0;

$sql = "SELECT *
		FROM forums
		WHERE forum_id = ". $topic_data['forum_id'];
$result = $db->query($sql);
$forum_data = $db->fetch_assoc($result);

$sql = "UPDATE topics
		SET views = views + 1
		WHERE topic_id = $topic_id";
$db->query($sql);

$sql = "UPDATE notify_topics
		SET send_more = 1
		WHERE topic_id = $topic_id
		AND user_id = ". $session->user_data['user_id'];
$db->query($sql);

if($topic_data['topic_type'] != TOPIC_GLOBAL)
{
	$sql = "SELECT *
			FROM forums
			WHERE left_id < ". $forum_data['left_id'] ."
			AND right_id > ". $forum_data['right_id'] ."
			ORDER BY left_id ASC;";
	$result = $db->query($sql);
	while($row = $db->fetch_assoc($result))
	{
		$navigation[] = array($row['forum_id'], $row['forum_name']);
	}
}

$navigation[] = array($forum_data['forum_id'], $forum_data['forum_name']);

$hidden_posts_sql = (! $auth->forum_check('view_hidden_posts', $topic_data['forum_id'])) ? 'AND p.post_hidden = 0' : '';
$unapproved_posts_sql = ($auth->forum_check('view_unapproved_posts', $topic_data['forum_id'])) ? 'AND p.post_approved IN(0, 1)' : 'AND p.post_approved = 1';

$sql = "SELECT p.*, u.username, u.user_signature, u.post_count, u.user_rank, u.avatar_type, u.avatar_file, u.website, u.location, u.msn, u.yahoo, u.aol, u.icq, u.user_warnings, g.group_colour
		FROM posts p, users u, groups g
		WHERE p.post_author = u.user_id
		AND u.primary_group = g.group_id
		AND p.topic_id = $topic_id
		$hidden_posts_sql
		$unapproved_posts_sql
		ORDER BY p.time_posted ASC
		LIMIT $post_offset, ". $config['posts_per_page'];
$result = $db->query($sql);
while($row = $db->fetch_assoc($result))
{
	$posts[] = $row;
}

if(isset($_POST['poll_submit']))
{
	if(! $auth->forum_check('vote_poll', $topic_data['forum_id']))
	{
		trigger_error('not_auth');
	}
	
	$poll_id = intval($_POST['poll_id']);
	$option_id = intval($_POST['poll_choice']);
	
	$sql = "SELECT *
			FROM poll_votes
			WHERE poll_id = $poll_id
			AND user_id = {$session->user_data['user_id']}";
	$result = $db->query($sql);
	$vote_data = $db->fetch_assoc($result);
	if(! empty($vote_data))
	{
		trigger_error('already_voted_poll');
	}
	
	$sql = "INSERT INTO poll_votes (poll_id, vote_option_id, user_id)
			VALUES($poll_id, $option_id, {$session->user_data['user_id']})";
	$db->query($sql);
	
	trigger_error('vote_cast');
}

$sql = "SELECT *
		FROM polls
		WHERE topic_id = $topic_id";
$result = $db->query($sql);
$poll_data = $db->fetch_assoc($result);

if(! empty($poll_data))
{
	$user_has_voted = false;
	
	$sql = "SELECT *
			FROM poll_options
			WHERE poll_id = ". $poll_data['poll_id'];
	$result = $db->query($sql);
	while($row = $db->fetch_assoc($result))
	{
		$poll_options[] = $row;
		$poll_votes[ $row['option_id'] ] = 0;
	}
	
	$sql = "SELECT *
			FROM poll_votes
			WHERE poll_id = {$poll_data['poll_id']}";
	$result = $db->query($sql);
	while($row = $db->fetch_assoc($result))
	{
		$poll_votes[ $row['vote_option_id'] ]++;
		$total_votes++;
		
		if($row['user_id'] == $session->user_data['user_id'])
		{
			$user_has_voted = true;
		}
	}
	
	for($i = 0; $i < count($poll_options); $i++)
	{
		$thing = ($total_votes > 0) ? $poll_votes[ $poll_options[$i]['option_id'] ] / $total_votes : 0;
		
		$template->assign_block_vars('poll_options', array(
			'OPTION_ID'			=>	$poll_options[$i]['option_id'],
			'OPTION_TEXT'		=>	censor_text($poll_options[$i]['option_text']),
			'OPTION_PERCENT'	=>	round($thing * 100),
			'OPTION_VOTES'		=>	$poll_votes[ $poll_options[$i]['option_id'] ]
		));
	}
	
	$template->assign_vars(array(
		'POLL_ID'			=>	$poll_data['poll_id'],
		'POLL_TITLE'		=>	censor_text($poll_data['poll_title']),
		'SHOW_VOTE_CHOICES'	=>	($auth->forum_check('vote_poll', $topic_data['forum_id']) && ! $user_has_voted),
		'TOTAL_POLL_VOTES'	=>	$total_votes,
		
		'U_VOTE_POLL'		=>	"viewtopic.php?t=$topic_id"
	));
}

$template->load('body', 'viewtopic.html');

$ranks = $cache->get_ranks();

for($i = 0; $i < count($posts); $i++)
{
	if(! $posts[$i]['post_hidden'])
	{
		$row_count++;
	}
	
	$is_new_post = false;
	
	$user_rank_image = $user_rank_text = '';
	$last_post_time = ($posts[$i]['time_posted'] > $last_post_time) ? $posts[$i]['time_posted'] : $last_post_time;
	
	if(! empty($posts[$i]['user_rank']))
	{
		foreach($ranks['special'] as $k => $v)
		{
			$user_rank_text = $ranks['special'][ $posts[$i]['user_rank'] ]['rank_title'];
			if(! empty($ranks['special'][ $posts[$i]['user_rank'] ]['rank_image']))
			{
				//Start with a global image
				$user_rank_image = "$root_path/images/ranks/". $ranks['special'][ $posts[$i]['user_rank'] ]['rank_image'];
				
				//Now, if a template specific one exists we'll use that instead
				if(file_exists("$root_path/$template->style_folder/$template->style_name/images/ranks/". $ranks['special'][ $posts[$i]['user_rank'] ]['rank_image']))
				{
					$user_rank_image = "$root_path/$template->style_folder/$template->style_name/images/ranks/". $ranks['special'][ $posts[$i]['user_rank'] ]['rank_image'];
				}
			}
		}
	}
	else
	{
		foreach($ranks['normal'] as $k => $v)
		{
			if($ranks['normal'][$k]['rank_posts'] <= $posts[$i]['post_count'])
			{
				$user_rank_text = $ranks['normal'][$k]['rank_title'];
				if(! empty($ranks['normal'][$k]['rank_image']))
				{
					//Start with a global image
					$user_rank_image = "$root_path/images/ranks/". $ranks['normal'][$k]['rank_image'];
					
					//Now, if a template specific one exists we'll use that instead
					if(file_exists("$root_path/$template->style_folder/$template->style_name/images/ranks/". $ranks['normal'][$k]['rank_image']))
					{
						$user_rank_image = "$root_path/$template->style_folder/$template->style_name/images/ranks/". $ranks['normal'][$k]['rank_image'];
					}
				}
			}
		}
	}
	
	if((! empty($read_topics[ $topic_data['forum_id'] ][$topic_id])) && ($posts[$i]['time_posted'] > $read_topics[ $topic_data['forum_id'] ][$topic_id]))
	{
		$is_new_post = true;
	}
	
	$template->assign_block_vars('post', array(
		'AVATAR_IMG_TEXT'		=>	($posts[$i]['avatar_type'] != 0) ? generate_avatar_text($posts[$i]['avatar_type'], $posts[$i]['avatar_file']) : '',
		'CAN_EDIT'				=>	((($session->user_data['user_id'] == $posts[$i]['post_author'] && $auth->forum_check('edit_own_posts', $forum_data['forum_id'])) || $auth->forum_check('edit_others_posts', $forum_data['forum_id'])) && ((! $topic_data['topic_locked']) && (! $topic_data['topic_hidden']))),
		'CAN_INSTA_EDIT'		=>	(($topic_data['topic_type'] != TOPIC_GLOBAL) && (($session->user_data['user_id'] == $posts[$i]['post_author'] && $auth->forum_check('edit_own_posts', $forum_data['forum_id'])) || $auth->forum_check('edit_others_posts', $forum_data['forum_id']))),
		'HAS_AVATAR'			=>	($posts[$i]['avatar_type'] != 0),
		'HIDE_POST'				=>	($posts[$i]['post_hidden']),
		'IS_NEW_POST'			=>	$is_new_post,
		'ROW_COUNT'				=>	$row_count,
		'POST_AUTHOR'			=>	$posts[$i]['username'],
		'POST_HIDDEN'			=>	(($topic_data['topic_hidden'] && $posts[$i]['post_id'] == $topic_data['first_post_id']) || $posts[$i]['post_hidden']),
		'POST_ID'				=>	$posts[$i]['post_id'],
		'POST_TEXT'				=>	newlines(censor_text(parse_smilies(parse_bbcode($posts[$i]['post_text'])))),
		'POST_REPORTED'			=>	(($posts[$i]['post_reported']) && ($auth->forum_check('view_reported_posts', $forum_data['forum_id']))),
		'POST_SUBJECT'			=>	(empty($posts[$i]['post_subject'])) ? 'Re: '. censor_text($topic_data['topic_title']) : censor_text($posts[$i]['post_subject']),
		'POST_UNAPPROVED'		=>	((! $posts[$i]['post_approved']) || (! $topic_data['topic_approved'] && $topic_data['first_post_id'] == $posts[$i]['post_id'])),
		'SHOW_SIGNATURE'		=>	(($posts[$i]['attach_signature']) && (! empty($posts[$i]['user_signature']))),
		'TIME_POSTED'			=>	format_date($posts[$i]['time_posted']),
		'USER_COLOUR'			=>	$posts[$i]['group_colour'],
		'USER_AOL'				=>	$posts[$i]['aol'],
		'USER_ICQ'				=>	$posts[$i]['icq'],
		'USER_LOCATION'			=>	$posts[$i]['location'],
		'USER_MSN'				=>	$posts[$i]['msn'],
		'USER_POST_COUNT'		=>	$posts[$i]['post_count'],
		'USER_RANK_IMAGE'		=>	$user_rank_image,
		'USER_RANK_TEXT'		=>	$user_rank_text,
		'USER_SIGNATURE'		=>	newlines(censor_text(parse_smilies(parse_bbcode($posts[$i]['user_signature'])))),
		'USER_WARNINGS'			=>	$posts[$i]['user_warnings'],
		'USER_WEBSITE'			=>	$posts[$i]['website'],
		'USER_YAHOO'			=>	$posts[$i]['yahoo'],
		
		'A_REPORT_POST'			=>	(($auth->forum_check('report_post', $forum_data['forum_id'])) && (! $posts[$i]['post_reported'])),
		'A_WARN'				=>	(($auth->forum_check('warn_user', $forum_data['forum_id'])) && ($session->user_data['user_id'] != $posts[$i]['post_author'])),
		
		'U_EDIT'				=>	'post.php?mode=edit&amp;p=' . $posts[$i]['post_id'],
		'U_PM_USER'				=>	'ucp.php?m=compose_pm&amp;to=' . $posts[$i]['post_author'],
		'U_PROFILE'				=>	'profile.php?u='. $posts[$i]['post_author'],
		'U_QUOTE'				=>	"post.php?mode=quote&amp;t=$topic_id&amp;p=" . $posts[$i]['post_id'],
		'U_REPORT_POST'			=>	'report.php?p=' . $posts[$i]['post_id'],
		'U_VIEW_POST_REPORT'	=>	'mcp.php?mode=view_post_report&amp;p=' . $posts[$i]['post_id'],
		'U_WARN_USER'			=>	'mcp.php?mode=warn_user&amp;u='. $posts[$i]['post_author'] .'&amp;f=' . $forum_data['forum_id']
	));
}

for($i = 0; $i < count($navigation); $i++)
{
	$template->assign_block_vars('navigation', array(
		'FORUM_NAME'	=>	$navigation[$i][1],
		
		'U_VIEWFORUM'	=>	'viewforum.php?f=' . $navigation[$i][0]
	));
}

$template->assign_vars(array(
	'FORUM_NAME'			=>	$forum_data['forum_name'],
	'FORUM_RULES'			=>	newlines(parse_bbcode($forum_data['forum_rules'])),
	'LAST_POST_TIME'		=>	$topic_data['last_post_time'],
	'PAGINATION'			=>	generate_pagination(($auth->forum_check('view_hidden_posts', $topic_data['forum_id']) ? $topic_data['replies_actual'] : $topic_data['replies']), $config['posts_per_page'], $post_offset, "viewtopic.php?t=$topic_id"),
	'SHOW_FORUM_RULES'		=>	(($forum_data['forum_flags'] & FLAG_SHOW_FORUM_RULES) && (! empty($forum_data['forum_rules']))),
	'SHOW_PREVIEW'			=>	false,
	'TOPIC_HAS_POLL'		=>	(! empty($poll_data)),
	'TOPIC_ID'				=>	$topic_id,
	'TOPIC_LOCKED'			=>	(($topic_data['topic_locked']) || ($forum_data['forum_flags'] & FLAG_LOCKED)),
	'TOPIC_TITLE'			=>	censor_text($topic_data['topic_title']),
	
	'A_APPROVE_POST'		=>	(($topic_data['unapproved_posts'] > 0) && ($auth->forum_check('approve_post', $forum_data['forum_id']))),
	'A_APPROVE_TOPIC'		=>	((! $topic_data['topic_approved']) && ($auth->forum_check('approve_topic', $forum_data['forum_id']))),
	'A_ANNOUNCE'			=>	(($topic_data['topic_type'] != TOPIC_ANNOUNCEMENT) && ($auth->forum_check('announce_topic', $forum_data['forum_id']))),
	'A_CREATE_TOPIC'		=>	(($auth->forum_check('post', $forum_data['forum_id'])) && (! ($forum_data['forum_flags'] & FLAG_LOCKED))),
	'A_DELETE_POST'			=>	$auth->forum_check('delete_post', $forum_data['forum_id']),
	'A_DELETE_TOPIC'		=>	$auth->forum_check('delete_topic', $forum_data['forum_id']),
	'A_GLOBALISE'			=>	(($topic_data['topic_type'] != TOPIC_GLOBAL) && ($auth->forum_check('globalise_topic', $forum_data['forum_id']))),
	'A_HIDE_POST'			=>	$auth->forum_check('hide_post', $forum_data['forum_id']),
	'A_HIDE_TOPIC'			=>	((! $topic_data['topic_hidden']) && ($auth->forum_check('hide_topic', $forum_data['forum_id']))),
	'A_LOCK'				=>	((! $topic_data['topic_locked']) && ($auth->forum_check('lock_topic', $forum_data['forum_id']))),
	'A_MODERATE'			=>	$auth->forum_check('moderate', $forum_data['forum_id']),
	'A_NORMALISE'			=>	(($topic_data['topic_type'] != TOPIC_NORMAL) && ($auth->forum_check('normalise_topic', $forum_data['forum_id']))),
	'A_REPLY'				=>	(($auth->forum_check('post', $forum_data['forum_id'])) && (! (($topic_data['topic_locked']) || ($forum_data['forum_flags'] & FLAG_LOCKED)))),
	'A_QUICK_REPLY'			=>	(($auth->forum_check('quick_reply', $forum_data['forum_id'])) && (! (($topic_data['topic_locked']) || ($forum_data['forum_flags'] & FLAG_LOCKED)))),
	'A_STICKY'				=>	(($topic_data['topic_type'] != TOPIC_STICKY) && ($auth->forum_check('sticky_topic', $forum_data['forum_id']))),
	'A_UNLOCK'				=>	(($topic_data['topic_locked']) && ($auth->forum_check('unlock_topic', $forum_data['forum_id']))),
	'A_VIEW_WARNINGS'		=>	$auth->forum_check('view_warnings', $forum_data['forum_id']),
	
	'QUICK_REPLY_ACTION'	=>	($topic_data['topic_type'] == TOPIC_GLOBAL) ? "post.php?mode=reply&amp;t=$topic_id&amp;f=$forum_id" : "post.php?mode=reply&amp;t=$topic_id",
	'U_MCP'					=>	($topic_data['topic_type'] == TOPIC_GLOBAL) ? "mcp.php?t=$topic_id&amp;f=$forum_id" : "mcp.php?t=$topic_id&amp;f=" . $topic_data['forum_id'],
	'U_NEW_TOPIC'			=>	"post.php?mode=new&amp;f={$forum_data['forum_id']}",
	'U_REPLY'				=>	($topic_data['topic_type'] == TOPIC_GLOBAL) ? "post.php?mode=reply&amp;t=$topic_id&amp;f=$forum_id" : "post.php?mode=reply&amp;t=$topic_id",
	'U_VIEWFORUM'			=>	"viewforum.php?f={$forum_data['forum_id']}"
));

if($last_post_time > $read_topics[ $topic_data['forum_id'] ][$topic_id])
{
	$read_topics[ $topic_data['forum_id'] ][$topic_id] = $last_post_time;
}

//31536000 seconds = 365 days
$session->set_cookie('read_topics', serialize($read_topics), (time() + 31536000));

//forum_header('view_topic');
forum_header($topic_data['topic_title']);

$template->display('body');
forum_footer();
?>