<?php
/*
* --------------------------------------------------------------------------
*                                    NuclearBB
*                              (c) 2007 NuclearBB
* --------------------------------------------------------------------------
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* --------------------------------------------------------------------------
*/

define('IN_NBB', true);
$root_path = '.';
require("$root_path/inc/global.php");
$session->begin();
$auth->setup();
add_lang('whos_online');
forum_header('whos_online');

$template->load('body', 'whos_online.html');

$forums = $topics = $users = $users_online = array();
$groups = $cache->get_groups();

$session_time = time() - $config['online_users_time'];
$sql = "SELECT u.primary_group, u.user_id, u.username, s.current_page, s.session_time
		FROM sessions s, users u
		WHERE s.session_time > $session_time
		AND s.user_id = u.user_id
		ORDER BY s.session_time ASC";
$result = $db->query($sql);
while($row = $db->fetch_assoc($result))
{
	$users_online[] = $row;
	
	preg_match('#([a-z]+)#', $row['current_page'], $current_page);
	
	switch($current_page[1])
	{
		case 'post':
			preg_match('#mode=([a-z]+)#', $row['current_page'], $mode);
			
			switch($mode[1])
			{
				case 'new':
					preg_match('#f=([0-9]+)#', $row['current_page'], $in_forum);
					
					if(! array_key_exists($in_forum[1], $forums))
					{
						$sql = "SELECT *
								FROM forums
								WHERE forum_id = ". $in_forum[1];
						$result = $db->query($sql);
						$forums[ $in_forum[1] ] = $db->fetch_assoc($result);
					}
				break;
				
				case 'reply':
					preg_match('#t=([0-9]+)#', $row['current_page'], $in_topic);
					
					if(! array_key_exists($in_topic[1], $topics))
					{
						$sql = "SELECT *
								FROM topics
								WHERE topic_id = ". $in_topic[1];
						$result = $db->query($sql);
						$topics[ $in_topic[1] ] = $db->fetch_assoc($result);
					}
				break;
			}
		break;
		
		case 'profile':
			preg_match('#u=([0-9]+)#', $row['current_page'], $viewing_profile);
			
			if(! array_key_exists($viewing_profile[1], $users))
			{
				$sql = "SELECT *
						FROM users
						WHERE user_id = ". $viewing_profile[1];
				$result = $db->query($sql);
				$users[ $viewing_profile[1] ] = $db->fetch_assoc($result);
			}
		break;
		
		case 'viewforum':
			preg_match('#f=([0-9]+)#', $row['current_page'], $in_forum);
			
			if(! array_key_exists($in_forum[1], $forums))
			{
				$sql = "SELECT *
						FROM forums
						WHERE forum_id = ". $in_forum[1];
				$result = $db->query($sql);
				$forums[ $in_forum[1] ] = $db->fetch_assoc($result);
			}
		break;
		
		case 'viewtopic':
			preg_match('#t=([0-9]+)#', $row['current_page'], $in_topic);
			
			if(! array_key_exists($in_topic[1], $topics))
			{
				$sql = "SELECT *
						FROM topics
						WHERE topic_id = ". $in_topic[1];
				$result = $db->query($sql);
				$topics[ $in_topic[1] ] = $db->fetch_assoc($result);
			}
		break;
	}
}

for($i = 0; $i < count($users_online); $i++)
{
	$location = 'forum_index';
	preg_match('#([a-z]+)#', $users_online[$i]['current_page'], $current_page);
	
	switch($current_page[1])
	{
		case 'mcp':
			$location = 'viewing_mcp';
		break;
		
		case 'memberlist':
			$location = 'viewing_memberlist';
		break;
		
		case 'post':
			preg_match('#mode=([a-z]+)#', $users_online[$i]['current_page'], $mode);
			
			switch($mode[1])
			{
				case 'new':
					preg_match('#f=([0-9]+)#', $users_online[$i]['current_page'], $in_forum);
					
					if($auth->forum_check('view_forum', $in_forum[1]))
					{
						$location = sprintf(lang('making_new_topic'), $in_forum[1], $forums[ $in_forum[1] ]['forum_name']);
					}
				break;
				
				case 'reply':
					preg_match('#t=([0-9]+)#', $users_online[$i]['current_page'], $in_topic);
					
					if($auth->forum_check('view_forum', $topics[ $in_topic[1] ]['forum_id']))
					{
						$location = sprintf(lang('replying_to_topic'), $in_topic[1], $topics[ $in_topic[1] ]['topic_title']);
					}
				break;
			}
		break;
		
		case 'profile':
			preg_match('#u=([0-9]+)#', $users_online[$i]['current_page'], $viewing_profile);
			
			$location = sprintf(lang('viewing_profile'), $viewing_profile[1], $users[ $viewing_profile[1] ]['username']);
		break;
		
		case 'search':
			$location = 'searching_forums';
		break;
		
		case 'ucp':
			$location = 'viewing_ucp';
		break;
		
		case 'viewforum':
			preg_match('#f=([0-9]+)#', $users_online[$i]['current_page'], $in_forum);
			
			if($auth->forum_check('view_forum', $in_forum[1]))
			{
				$location = sprintf(lang('viewing_forum'), $in_forum[1], $forums[ $in_forum[1] ]['forum_name']);
			}
		break;
		
		case 'viewtopic':
			preg_match('#t=([0-9]+)#', $users_online[$i]['current_page'], $in_topic);
			
			if($auth->forum_check('view_forum', $topics[ $in_topic[1] ]['forum_id']))
			{
				$location = sprintf(lang('viewing_topic'), $topics[ $in_topic[1] ]['topic_id'], $topics[ $in_topic[1] ]['topic_title']);
			}
		break;
		
		case 'whosonline':
			$location = 'viewing_whosonline';
		break;
		
		default:
			$location = 'forum_index';
		break;
	}
	
	$template->assign_block_vars('user', array(
		'LAST_SEEN'		=>	format_date($users_online[$i]['session_time']),
		'LOCATION'		=>	lang($location, true),
		'USER_COLOUR'	=>	$groups[ $users_online[$i]['primary_group'] ]['group_colour'],
		'USERNAME'		=>	$users_online[$i]['username'],
		
		'U_PROFILE'		=>	'profile.php?u=' . $users_online[$i]['user_id']
	));
}

$template->display('body');
forum_footer();
?>